C  --- FILE LEEDCON.M4 ---
C  LEED MAIN PROGRAMS + INPUT DATA FOR SURFACES WITH 4 ATOMS PER UNIT
C  CELL
C
C
C  --- M4.1.1
C     PROGRAM GLIDE(INPUT,OUTPUT,PUN,TAPE8,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN)
C  TEST PROGRAM FOR GLIDE PLANE SYMMETRY. TEST STRUCTURE HAS TOP LAYER  150382
C  WITH 4-FOLD AXIS AND 2 GLIDE PLANES PERPENDICULAR TO EACH OTHER
C  (P4GM). THIS AND 3 OTHER MAIN PROGRAMS EXPLOIT DIFFERENT DEGREES
C  OF SYMMETRY. NOTE THE PARTICULAR CHOICES OF LOCATIONS OF THE
C  REFERENCE POINTS WITH RESPECT TO THE 4-FOLD AXIS AND THE GLIDE
C  PLANES.
C  CAUTION - THE COMMENTS IN THE BODY OF THIS MAIN PROGRAM ARE NOT ALL
C  APPROPRIATE.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASW(3)
C  4=NL, 45=KLM
      COMPLEX VL(4,2),FLMS(4, 45),FLM( 45)
C  4(1ST DIMENSION)=NL=NL1*NL2, 4(2ND DIMENSION)=IDEG
      DIMENSION V(4,2),JJS(4,4)
C  4=KNBS=NO. OF BEAM SETS READ IN, 37=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(4),NB(4),SPQF(2,37),SPQ(2,37),PQF(2,37),PQ(2,37)
      INTEGER KSYM(2,37),SYM(2,37)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  12=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,10)
C  4=NLAY, VPOS NOT USED, 12 FIXED, 759 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(1,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM( 809),YLM( 81),FAC2( 81),FAC1( 9)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
      COMPLEX ROV(37,37),TOV(37,37)
C  12=KNP
      COMPLEX RA1(37,12),TA1(37,12),RA2(37,12),TA2(37,12)
C  25=LMT, 15=LEV, 300(IN GH)=LMG, 4=NLAY, 100(IN TS)=LMN, 200=LM2N
C  100(IN TH, IPL)=LMNI
      COMPLEX TAU(25,15),TAUG(25),TAUGM(25),GH(300,25),RG(3,4,37),
     1TS(100),TG(2,200),VT(200),TH(100,100)
      DIMENSION IPL(100)
C  15=LEV, 10=LOD
      COMPLEX AMULT(37),CYLM(37,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(37)
C  10 FIXED (FOR RFS2OV), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(37),PK(37,10),AW(37,2),ANEW(37,20)
C ***** FOR CDC ONLY  *********
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
C     COMMON/BIG/ GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
      COMMON /NST/NST1,ASI(3,10),STPS(3,10,2),NSTS(10,2),NACV
      COMMON /ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     1 IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN,
     2 BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYER (0,IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
C  START WITH OVERLAYER - E BECOMES ENERGY IN OVERLAYER
      E = EC - VO
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FROM PHASE SHIFTS, CORRECTED FOR
C  THERMAL VIBRATION (CAF AND TSF) OR NOT (AF AND TSF0). AF AND CAF
C  ARE USED FOR BRAVAIS-LATTICE LAYERS. TSF0 AND TSF ARE USED FOR
C  COMPOSITE LAYERS.
C  THIS CALL IS FOR OVERLAYER (IEL=2 IN INPUT SEQUENCE OF PHASE SHIFTS)
C     CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
C    1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  CHOOSE PARAMETERS RELEVANT TO OVERLAYER
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
C  IT=(0),1 MEANS INCLUDE (NO) EXPLICIT DEBYE-WALLER FACTORS IN MSMF
      IT=0
      TV = TVB
      VPI = VPIO
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUM IN FMAT. IF MUFFIN-TIN CONSTANTS AND
C  DAMPINGS IN SUBSTRATE AND OVERLAYER ARE EQUAL, DO LATTICE SUMS FOR
C  BOTH TYPES OF LAYERS NOW (NLS=NL IMPLIES - DO ALL SUBLATTICES).
C  OTHERWISE DO ONLY OVERLAYER LATTICE SUM (NLS=1 IMPLIES - DO ONLY THE
C  SUBLATTICE EQUAL TO THE OVERLAYER LATTICE)
      NLS = 1
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  NLS = NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C  PRODUCE REFLECTION (ROV) AND TRANSMISSION (TOV) MATRICES FOR THE
C  OVERLAYER. ONLY ONE REGISTRY- ID=1. ONLY ONE SUBLATTICE
C  OVERLAYER SYMMETRIES AND REGISTRIES APPLY- LAY=1. TEMPERATURE-
C  DEPENDENT PHASE SHIFTS USED- CAF
C     CALL MSMF(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,NT,NT,NT,AMULT,CYLM,
C    1PQ,SYM,NT,FLMS,FLM,V,NL,0,0,1,1,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
C    2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,1)
C     WRITE (6,410)
C
C
C  CONSIDER SUBSTRATE NEXT. CHOOSE CORRECT ENERGY
      E = EC
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR SUBSTRATE
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      VPI = VPIS
      VPI1 = VPIS
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  GO TO 930
C  PERFORM PLANAR LATTICE SUMS FOR SUBSTRATE IF NOT DONE BEFORE
      CALL  FMAT (FLMS, V, JJS, NL, NL, DCUTS, IDEG, LMAX,KLM)
  930 CONTINUE
C  SET PARAMETERS FOR  TOP SUBSTRATE LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=2
      NEW=1
      VPI1=VPIS
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR RUMPLED LAYER
      CALL MTINV(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,FPOS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,416)
      CALL CMPRTL(ROV,NT,NT,3HROV)
      CALL CMPRTL(TOV,NT,NT,3HTOV)
      CALL CMPRT(CYLM,NT,LMMAX,4HCYLM)
      CALL CMPRT(FLMS,NL,KLM,4HFLMS)
      CALL CMPRTL(TAU,LMT,LEV,3HTAU)
      CALL RMPRT(FPOS,NLAY,3,4HFPOS)
      CALL RMPRT(POSS,NLAY,3,4HPOSS)
      CALL RMPRT(DRL,NLAY2,3,3HDRL)
      CALL RMPRT(SDRL,NLAY2,3,4HSDRL)
      CALL IMPRT(NUGH,NLAY2,1,4HNUGH)
      CALL IMPRT(NGEQ,NLAY2,1,4HNGEQ)
      CALL IMPRT(NGOL,NLAY2,1,4HNGOL)
C  SET PARAMETERS FOR  BULK LAYERS
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA
C  PRODUCE REFLECTION (RA1,RA2) AND TRANSMISSION (TA1,TA2) MATRICES
C  FOR SUBSTRATE LAYERS. TWO REGISTRIES- ID=2 (RA1,TA1 FOR REGISTRY
C  SS1, RA2,TA2 FOR REGISTRY SS2). NLL=NL SUBLATTICES. SUBSTRATE LAYER
C  SYMMETRIES AND REGISTRIES APPLY- LAY=2.
C  FIRST BEAM SET FIRST (NAA BEAMS)
      NAA = NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS NA=NS=NAA)
      NBB = NB(2)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  THIRD BEAM SET NEXT (NCC BEAMS. NOTE OFFSETS NA=NS=NAA+NBB)
      N=NAA+NBB
      NCC = NB(3)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NCC,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  FOURTH BEAM SET NEXT (NDD BEAMS. NOTE OFFSETS NA=NS=NAA+NBB+NCC)
      N=NAA+NBB+NCC
      NDD = NB(4)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NDD,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
      CALL CMPRTL(RA1,NT,NP,3HRA1)
      CALL CMPRTL(TA1,NT,NP,3HTA1)
C
C
C  NOW STACK LAYERS.
C  ASW BECOMES VECTOR BETWEEN 1ST AND 2ND SUBSTRATE LAYERS, AND WILL
C  BE VARIED BY SSTEP IN LOOP 969
C     DO 936 J=2,3
C 936 ASW(J)=ASA(J)
C     ASW(1)=ASA(1)-FPOS(2,1)
C     SSTEP=0.05/0.529
C     DO 969 ISUB=1,3
C     DO 935 J=1,3
C 935 AS(J)=ASW(J)*0.529
C     WRITE(6,430)(AS(J),J=1,3)
C  ASV BECOMES THE 3-D VECTOR FROM OVERLAYER TO TOP SUBSTRATE LAYER
C  AND WILL BE VARIED
      DO 937 J=1,3
  937 ASV(J)=ASB(J)
C  LOOP 960 RUNS OVER GEOMETRIES
HE OVERLAYER SPACING ASV(1) IS
C  VARIED
      DO 960 I = 1, NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      A=AS(1)
      WRITE (6,430) (AS(J),J=1,3)
C  COMPUTE REFLECTED BEAM AMPLITUDES (XI) BY RFS
      CALL RFSO2(ROV,TOV,ROV,TOV,RA1,TA1,RA1,TA1,
     1NT,NB,KNBS,NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH LAYER SPACING A ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  960 ASV(1)=ASV(1)+STEP
C     ASW(1)=ASW(1)-SSTEP
  969 CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 W(100)+P(2*2)W, RFS, GLIDE PLANES,NO SYMM,5 PH. SH.
  4  2  2               IDEG NL1 NL2
  4 37  6               KNBS KNT NPUN
 12                     NPSI
 3.1600 0.0000          ARA1
 0.0000 3.1600          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 1.5800 1.5800 1.5800   ASA
 6.3200 0.0000          ARB1
 0.0000 6.3200          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.5800 0.0000 0.0000   ASB
 0.5000 0.4000 0.1000   FR ASE STEP
  1                     NSTEP
  9
 0.     0.      1  1
 1.0000 0.      1  1
-1.0000 0.      1  1
 0.     1.0000  1  1
 0.    -1.0000  1  1
 1.0000 1.0000  1  1
 1.0000-1.0000  1  1
-1.0000-1.0000  1  1
-1.0000 1.0000  1  1
  8
  .5000 0.      1  1
 -.5000 0.      1  1
  .5000 1.0000  1  1
  .5000-1.0000  1  1
 -.5000-1.0000  1  1
 -.5000 1.0000  1  1
 1.5000 0.      1  1
-1.5000 0.      1  1
  8
 0.      .5000  1  1
 0.     -.5000  1  1
 1.0000  .5000  1  1
 1.0000 -.5000  1  1
-1.0000 -.5000  1  1
-1.0000  .5000  1  1
 0.     1.5000  1  1
 0.    -1.5000  1  1
 12
  .5000  .5000  1  1
  .5000 -.5000  1  1
 -.5000 -.5000  1  1
 -.5000  .5000  1  1
 1.5000  .5000  1  1
 1.5000 -.5000  1  1
-1.5000 -.5000  1  1
-1.5000  .5000  1  1
  .5000 1.5000  1  1
  .5000-1.5000  1  1
 -.5000-1.5000  1  1
 -.5000 1.5000  1  1
 0.0020                 TST
  1  2  3  4  5  6      NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 400.0000 183.8500   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
5402.0000   1.0080   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
  .3000
 -.8877 -.3222-2.5871  .0032  .0001  .0000  .0000  .0000  .0000  .0000
 1.3979 0.0211 0.0003 0.0000 0.0000 0.0000 0.0000
  .4000
-1.0151 -.4178-1.5835  .0082  .0003  .0000  .0000  .0000  .0000  .0000
 1.3321 0.0320 0.0006 0.0000 0.0000 0.0000 0.0000
  .5000
-1.1255 -.5032-1.0993  .0169  .0008  .0000  .0000  .0000  .0000  .0000
 1.2785 0.0440 0.0010 0.0000 0.0000 0.0000 0.0000
  .7500
-1.3563 -.6825 -.9244  .0612  .0042  .0002  .0000  .0000  .0000  .0000
 1.1743 0.0772 0.0025 0.0001 0.0000 0.0000 0.0000
 1.0000
-1.5484 -.8282 -.9594  .1479  .0127  .0009  .0001  .0000  .0000  .0000
 1.0944 0.1125 0.0050 0.0001 0.0000 0.0000 0.0000
 1.5000
-1.8682-1.0650-1.0764  .4547  .0565  .0060  .0006  .0000  .0000  .0000
 0.9739 0.1818 0.0125 0.0006 0.0000 0.0000 0.0000
 2.0000
-2.1338-1.2639-1.1761  .7973  .1489  .0205  .0026  .0003  .0000  .0000
 0.8847 0.2416 0.0233 0.0014 0.0001 0.0000 0.0000
 3.0000
-2.5582-1.6008-1.3333 1.1383  .4604  .0950  .0180  .0028  .0004  .0000
 0.7610 0.3215 0.0527 0.0049 0.0003 0.0000 0.0000
 4.0000
-2.8837-1.8755-1.4771 1.2583  .7767  .2267  .0591  .0129  .0023  .0003
 0.6829 0.3567 0.0877 0.0113 0.0009 0.0001 0.0000
 5.0000
-3.1446-2.1007-1.6131 1.3196 1.0178  .3728  .1271  .0359  .0083  .0016
 0.6334 0.3644 0.1227 0.0207 0.0022 0.0002 0.0000
 6.0000
-3.3643-2.2904-1.7352 1.3479 1.2153  .4993  .2083  .0735  .0212  .0050
 0.6021 0.3577 0.1534 0.0328 0.0043 0.0004 0.0000
 7.0000
-3.5565-2.4564-1.8434 1.3564 1.3807  .6050  .2868  .1215  .0425  .0122
 0.5819 0.3447 0.1778 0.0469 0.0074 0.0008 0.0001
  4                     NLAY
 0.0000 1.8800 1.2800   FPOS(1,J)
 0.0000-1.2800 1.8800   FPOS(2,J)
 0.0000-1.8800-1.2800   FPOS(3,J)
 0.0000 1.2800-1.8800   FPOS(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  1                     NTAU
  1  1  1  1            LPS
  4  0                  NINV NLAY2R
  0  0  0  0            INV
  20.00  21.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C
C  --- M4.1.2
C
C     PROGRAM GLIDE(INPUT,OUTPUT,PUN,TAPE8,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN)
C  TEST PROGRAM FOR GLIDE PLANE SYMMETRY. TEST STRUCTURE HAS TOP LAYER  150382
C  WITH 4-FOLD AXIS AND 2 GLIDE PLANES PERPENDICULAR TO EACH OTHER
C  (P4GM). THIS AND 3 OTHER MAIN PROGRAMS EXPLOIT DIFFERENT DEGREES
C  OF SYMMETRY. NOTE THE PARTICULAR CHOICES OF LOCATIONS OF THE
C  REFERENCE POINTS WITH RESPECT TO THE 4-FOLD AXIS AND THE GLIDE
C  PLANES.
C  CAUTION - THE COMMENTS IN THE BODY OF THIS MAIN PROGRAM ARE NOT ALL
C  APPROPRIATE.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASW(3)
C  4=NL, 45=KLM
      COMPLEX VL(4,2),FLMS(4, 45),FLM( 45)
C  4(1ST DIMENSION)=NL=NL1*NL2, 4(2ND DIMENSION)=IDEG
      DIMENSION V(4,2),JJS(4,4)
C  4=KNBS=NO. OF BEAM SETS READ IN, 18=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(4),NB(4),SPQF(2,18),SPQ(2,18),PQF(2,18),PQ(2,18)
      INTEGER KSYM(2,18),SYM(2,18)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  12=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,10)
C  4=NLAY, VPOS NOT USED, 12 FIXED, 759 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(1,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM( 809),YLM( 81),FAC2( 81),FAC1( 9)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
      COMPLEX ROV(18,18),TOV(18,18)
C  6=KNP
      COMPLEX RA1(18,6),TA1(18,6),RA2(18,6),TA2(18,6)
C  25=LMT, 15=LEV, 300(IN GH)=LMG, 4=NLAY, 100(IN TS)=LMN, 200=LM2N
C  100(IN TH, IPL)=LMNI
      COMPLEX TAU(25,15),TAUG(25),TAUGM(25),GH(300,25),RG(3,4,18),
     1TS(100),TG(2,200),VT(200),TH(100,100)
      DIMENSION IPL(100)
C  15=LEV, 10=LOD
      COMPLEX AMULT(18),CYLM(18,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(18)
C  10 FIXED (FOR RFS2OV), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(18),PK(18,10),AW(18,2),ANEW(18,20)
C ***** FOR CDC ONLY  *********
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
C     COMMON/BIG/ GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
      COMMON /NST/NST1,ASI(3,10),STPS(3,10,2),NSTS(10,2),NACV
      COMMON /ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     1 IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN,
     2 BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYER (0,IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
C  START WITH OVERLAYER - E BECOMES ENERGY IN OVERLAYER
      E = EC - VO
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FROM PHASE SHIFTS, CORRECTED FOR
C  THERMAL VIBRATION (CAF AND TSF) OR NOT (AF AND TSF0). AF AND CAF
C  ARE USED FOR BRAVAIS-LATTICE LAYERS. TSF0 AND TSF ARE USED FOR
C  COMPOSITE LAYERS.
C  THIS CALL IS FOR OVERLAYER (IEL=2 IN INPUT SEQUENCE OF PHASE SHIFTS)
C     CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
C    1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  CHOOSE PARAMETERS RELEVANT TO OVERLAYER
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
C  IT=(0),1 MEANS INCLUDE (NO) EXPLICIT DEBYE-WALLER FACTORS IN MSMF
      IT=0
      TV = TVB
      VPI = VPIO
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUM IN FMAT. IF MUFFIN-TIN CONSTANTS AND
C  DAMPINGS IN SUBSTRATE AND OVERLAYER ARE EQUAL, DO LATTICE SUMS FOR
C  BOTH TYPES OF LAYERS NOW (NLS=NL IMPLIES - DO ALL SUBLATTICES).
C  OTHERWISE DO ONLY OVERLAYER LATTICE SUM (NLS=1 IMPLIES - DO ONLY THE
C  SUBLATTICE EQUAL TO THE OVERLAYER LATTICE)
      NLS = 1
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  NLS = NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C  PRODUCE REFLECTION (ROV) AND TRANSMISSION (TOV) MATRICES FOR THE
C  OVERLAYER. ONLY ONE REGISTRY- ID=1. ONLY ONE SUBLATTICE
C  OVERLAYER SYMMETRIES AND REGISTRIES APPLY- LAY=1. TEMPERATURE-
C  DEPENDENT PHASE SHIFTS USED- CAF
C     CALL MSMF(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,NT,NT,NT,AMULT,CYLM,
C    1PQ,SYM,NT,FLMS,FLM,V,NL,0,0,1,1,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
C    2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,1)
C     WRITE (6,410)
C
C
C  CONSIDER SUBSTRATE NEXT. CHOOSE CORRECT ENERGY
      E = EC
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR SUBSTRATE
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      VPI = VPIS
      VPI1 = VPIS
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  GO TO 930
C  PERFORM PLANAR LATTICE SUMS FOR SUBSTRATE IF NOT DONE BEFORE
      CALL  FMAT (FLMS, V, JJS, NL, NL, DCUTS, IDEG, LMAX,KLM)
  930 CONTINUE
C  SET PARAMETERS FOR  TOP SUBSTRATE LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=2
      NEW=1
      VPI1=VPIS
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR RUMPLED LAYER
      CALL MTINV(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,FPOS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,416)
      CALL CMPRTL(ROV,NT,NT,3HROV)
      CALL CMPRTL(TOV,NT,NT,3HTOV)
      CALL CMPRT(CYLM,NT,LMMAX,4HCYLM)
      CALL CMPRT(FLMS,NL,KLM,4HFLMS)
      CALL CMPRTL(TAU,LMT,LEV,3HTAU)
      CALL RMPRT(FPOS,NLAY,3,4HFPOS)
      CALL RMPRT(POSS,NLAY,3,4HPOSS)
      CALL RMPRT(DRL,NLAY2,3,3HDRL)
      CALL RMPRT(SDRL,NLAY2,3,4HSDRL)
      CALL IMPRT(NUGH,NLAY2,1,4HNUGH)
      CALL IMPRT(NGEQ,NLAY2,1,4HNGEQ)
      CALL IMPRT(NGOL,NLAY2,1,4HNGOL)
C  SET PARAMETERS FOR  BULK LAYERS
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA
C  PRODUCE REFLECTION (RA1,RA2) AND TRANSMISSION (TA1,TA2) MATRICES
C  FOR SUBSTRATE LAYERS. TWO REGISTRIES- ID=2 (RA1,TA1 FOR REGISTRY
C  SS1, RA2,TA2 FOR REGISTRY SS2). NLL=NL SUBLATTICES. SUBSTRATE LAYER
C  SYMMETRIES AND REGISTRIES APPLY- LAY=2.
C  FIRST BEAM SET FIRST (NAA BEAMS)
      NAA = NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS NA=NS=NAA)
      NBB = NB(2)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  THIRD BEAM SET NEXT (NCC BEAMS. NOTE OFFSETS NA=NS=NAA+NBB)
      N=NAA+NBB
      NCC = NB(3)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NCC,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  FOURTH BEAM SET NEXT (NDD BEAMS. NOTE OFFSETS NA=NS=NAA+NBB+NCC)
      N=NAA+NBB+NCC
      NDD = NB(4)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NDD,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
      CALL CMPRTL(RA1,NT,NP,3HRA1)
      CALL CMPRTL(TA1,NT,NP,3HTA1)
      CALL CMPRTL(RA2,NT,NP,3HRA2)
      CALL CMPRTL(TA2,NT,NP,3HTA2)
C
C
C  NOW STACK LAYERS.
C  ASW BECOMES VECTOR BETWEEN 1ST AND 2ND SUBSTRATE LAYERS, AND WILL
C  BE VARIED BY SSTEP IN LOOP 969
C     DO 936 J=2,3
C 936 ASW(J)=ASA(J)
C     ASW(1)=ASA(1)-FPOS(2,1)
C     SSTEP=0.05/0.529
C     DO 969 ISUB=1,3
C     DO 935 J=1,3
C 935 AS(J)=ASW(J)*0.529
C     WRITE(6,430)(AS(J),J=1,3)
C  ASV BECOMES THE 3-D VECTOR FROM OVERLAYER TO TOP SUBSTRATE LAYER
C  AND WILL BE VARIED
      DO 937 J=1,3
  937 ASV(J)=ASB(J)
C  LOOP 960 RUNS OVER GEOMETRIES
HE OVERLAYER SPACING ASV(1) IS
C  VARIED
      DO 960 I = 1, NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      A=AS(1)
      WRITE (6,430) (AS(J),J=1,3)
C  COMPUTE REFLECTED BEAM AMPLITUDES (XI) BY RFS
      CALL RFSO2(ROV,TOV,ROV,TOV,RA1,TA1,RA2,TA2,
     1NT,NB,KNBS,NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH LAYER SPACING A ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  960 ASV(1)=ASV(1)+STEP
C     ASW(1)=ASW(1)-SSTEP
  969 CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 W(100)+P(2*2)W, RFS, GLIDE PLANES,SSYM=26,5 PH. SH.
  4  2  2               IDEG NL1 NL2
  4 18  6               KNBS KNT NPUN
 12                     NPSI
 3.1600 0.0000          ARA1
 0.0000 3.1600          ARA2
 0.5000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 1.5800 0.0000 1.5800   ASA
 6.3200 0.0000          ARB1
 0.0000 6.3200          ARB2
 0.5000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.5800 0.0000 0.0000   ASB
 0.5000 0.4000 0.1000   FR ASE STEP
  1                     NSTEP
  6
 0.     0.      1  1
 1.0000 0.      6  6
 0.     1.0000  1  1
 0.    -1.0000  1  1
 1.0000 1.0000  6  6
 1.0000-1.0000  6  6
  4
  .5000 0.      6  6
  .5000 1.0000  6  6
  .5000-1.0000  6  6
 1.5000 0.      6  6
  2
 1.0000  .5000 26 26
 1.0000 -.5000 26 26
  6
  .5000  .5000 26 26
  .5000 -.5000 26 26
 1.5000  .5000 26 26
 1.5000 -.5000 26 26
  .5000 1.5000 26 26
  .5000-1.5000 26 26
 0.0020                 TST
  1  2  3  4  5  6      NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 400.0000 183.8500   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
5402.0000   1.0080   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
  .3000
 -.8877 -.3222-2.5871  .0032  .0001  .0000  .0000  .0000  .0000  .0000
 1.3979 0.0211 0.0003 0.0000 0.0000 0.0000 0.0000
  .4000
-1.0151 -.4178-1.5835  .0082  .0003  .0000  .0000  .0000  .0000  .0000
 1.3321 0.0320 0.0006 0.0000 0.0000 0.0000 0.0000
  .5000
-1.1255 -.5032-1.0993  .0169  .0008  .0000  .0000  .0000  .0000  .0000
 1.2785 0.0440 0.0010 0.0000 0.0000 0.0000 0.0000
  .7500
-1.3563 -.6825 -.9244  .0612  .0042  .0002  .0000  .0000  .0000  .0000
 1.1743 0.0772 0.0025 0.0001 0.0000 0.0000 0.0000
 1.0000
-1.5484 -.8282 -.9594  .1479  .0127  .0009  .0001  .0000  .0000  .0000
 1.0944 0.1125 0.0050 0.0001 0.0000 0.0000 0.0000
 1.5000
-1.8682-1.0650-1.0764  .4547  .0565  .0060  .0006  .0000  .0000  .0000
 0.9739 0.1818 0.0125 0.0006 0.0000 0.0000 0.0000
 2.0000
-2.1338-1.2639-1.1761  .7973  .1489  .0205  .0026  .0003  .0000  .0000
 0.8847 0.2416 0.0233 0.0014 0.0001 0.0000 0.0000
 3.0000
-2.5582-1.6008-1.3333 1.1383  .4604  .0950  .0180  .0028  .0004  .0000
 0.7610 0.3215 0.0527 0.0049 0.0003 0.0000 0.0000
 4.0000
-2.8837-1.8755-1.4771 1.2583  .7767  .2267  .0591  .0129  .0023  .0003
 0.6829 0.3567 0.0877 0.0113 0.0009 0.0001 0.0000
 5.0000
-3.1446-2.1007-1.6131 1.3196 1.0178  .3728  .1271  .0359  .0083  .0016
 0.6334 0.3644 0.1227 0.0207 0.0022 0.0002 0.0000
 6.0000
-3.3643-2.2904-1.7352 1.3479 1.2153  .4993  .2083  .0735  .0212  .0050
 0.6021 0.3577 0.1534 0.0328 0.0043 0.0004 0.0000
 7.0000
-3.5565-2.4564-1.8434 1.3564 1.3807  .6050  .2868  .1215  .0425  .0122
 0.5819 0.3447 0.1778 0.0469 0.0074 0.0008 0.0001
  4                     NLAY
 0.0000 1.8800 1.2800   FPOS(1,J)
 0.0000-1.2800 1.8800   FPOS(2,J)
 0.0000-1.8800-1.2800   FPOS(3,J)
 0.0000 1.2800-1.8800   FPOS(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  1                     NTAU
  1  1  1  1            LPS
  4  0                  NINV NLAY2R
  0  0  0  0            INV
  20.00  21.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C
C  --- M4.1.3
C
C     PROGRAM GLIDE(INPUT,OUTPUT,PUN,TAPE8,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN)
C  TEST PROGRAM FOR GLIDE PLANE SYMMETRY. TEST STRUCTURE HAS TOP LAYER  150382
C  WITH 4-FOLD AXIS AND 2 GLIDE PLANES PERPENDICULAR TO EACH OTHER
C  (P4GM). THIS AND 3 OTHER MAIN PROGRAMS EXPLOIT DIFFERENT DEGREES
C  OF SYMMETRY. NOTE THE PARTICULAR CHOICES OF LOCATIONS OF THE
C  REFERENCE POINTS WITH RESPECT TO THE 4-FOLD AXIS AND THE GLIDE
C  PLANES.
C  CAUTION - THE COMMENTS IN THE BODY OF THIS MAIN PROGRAM ARE NOT ALL
C  APPROPRIATE.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASW(3)
C  4=NL, 45=KLM
      COMPLEX VL(4,2),FLMS(4, 45),FLM( 45)
C  4(1ST DIMENSION)=NL=NL1*NL2, 4(2ND DIMENSION)=IDEG
      DIMENSION V(4,2),JJS(4,4)
C  4=KNBS=NO. OF BEAM SETS READ IN, 9=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(4),NB(4),SPQF(2,9),SPQ(2,9),PQF(2,9),PQ(2,9)
      INTEGER KSYM(2,9),SYM(2,9)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  12=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,10)
C  4=NLAY, VPOS NOT USED, 12 FIXED, 759 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(1,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM( 809),YLM( 81),FAC2( 81),FAC1( 9)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
      COMPLEX ROV(9,9),TOV(9,9)
C  4=KNP
      COMPLEX RA1(9,4),TA1(9,4),RA2(9,4),TA2(9,4)
C  25=LMT, 15=LEV, 300(IN GH)=LMG, 4=NLAY, 100(IN TS)=LMN, 200=LM2N
C  100(IN TH, IPL)=LMNI
      COMPLEX TAU(25,15),TAUG(25),TAUGM(25),GH(300,25),RG(3,4,9),
     1TS(100),TG(2,200),VT(200),TH(100,100)
      DIMENSION IPL(100)
C  15=LEV, 10=LOD
      COMPLEX AMULT(9),CYLM(9,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(9)
C  10 FIXED (FOR RFS2OV), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(9),PK(9,10),AW(9,2),ANEW(9,20)
C ***** FOR CDC ONLY  *********
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
C     COMMON/BIG/ GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
      COMMON /NST/NST1,ASI(3,10),STPS(3,10,2),NSTS(10,2),NACV
      COMMON /ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     1 IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN,
     2 BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYER (0,IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
C  START WITH OVERLAYER - E BECOMES ENERGY IN OVERLAYER
      E = EC - VO
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FROM PHASE SHIFTS, CORRECTED FOR
C  THERMAL VIBRATION (CAF AND TSF) OR NOT (AF AND TSF0). AF AND CAF
C  ARE USED FOR BRAVAIS-LATTICE LAYERS. TSF0 AND TSF ARE USED FOR
C  COMPOSITE LAYERS.
C  THIS CALL IS FOR OVERLAYER (IEL=2 IN INPUT SEQUENCE OF PHASE SHIFTS)
C     CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
C    1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  CHOOSE PARAMETERS RELEVANT TO OVERLAYER
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
C  IT=(0),1 MEANS INCLUDE (NO) EXPLICIT DEBYE-WALLER FACTORS IN MSMF
      IT=0
      TV = TVB
      VPI = VPIO
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUM IN FMAT. IF MUFFIN-TIN CONSTANTS AND
C  DAMPINGS IN SUBSTRATE AND OVERLAYER ARE EQUAL, DO LATTICE SUMS FOR
C  BOTH TYPES OF LAYERS NOW (NLS=NL IMPLIES - DO ALL SUBLATTICES).
C  OTHERWISE DO ONLY OVERLAYER LATTICE SUM (NLS=1 IMPLIES - DO ONLY THE
C  SUBLATTICE EQUAL TO THE OVERLAYER LATTICE)
      NLS = 1
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  NLS = NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C  PRODUCE REFLECTION (ROV) AND TRANSMISSION (TOV) MATRICES FOR THE
C  OVERLAYER. ONLY ONE REGISTRY- ID=1. ONLY ONE SUBLATTICE
C  OVERLAYER SYMMETRIES AND REGISTRIES APPLY- LAY=1. TEMPERATURE-
C  DEPENDENT PHASE SHIFTS USED- CAF
C     CALL MSMF(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,NT,NT,NT,AMULT,CYLM,
C    1PQ,SYM,NT,FLMS,FLM,V,NL,0,0,1,1,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
C    2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,1)
C     WRITE (6,410)
C
C
C  CONSIDER SUBSTRATE NEXT. CHOOSE CORRECT ENERGY
      E = EC
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR SUBSTRATE
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      VPI = VPIS
      VPI1 = VPIS
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  GO TO 930
C  PERFORM PLANAR LATTICE SUMS FOR SUBSTRATE IF NOT DONE BEFORE
      CALL  FMAT (FLMS, V, JJS, NL, NL, DCUTS, IDEG, LMAX,KLM)
  930 CONTINUE
C  SET PARAMETERS FOR  TOP SUBSTRATE LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=2
      NEW=1
      VPI1=VPIS
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR RUMPLED LAYER
      CALL MTINV(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,FPOS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,416)
      CALL CMPRTL(ROV,NT,NT,3HROV)
      CALL CMPRTL(TOV,NT,NT,3HTOV)
      CALL CMPRT(CYLM,NT,LMMAX,4HCYLM)
      CALL CMPRT(FLMS,NL,KLM,4HFLMS)
      CALL CMPRTL(TAU,LMT,LEV,3HTAU)
      CALL RMPRT(FPOS,NLAY,3,4HFPOS)
      CALL RMPRT(POSS,NLAY,3,4HPOSS)
      CALL RMPRT(DRL,NLAY2,3,3HDRL)
      CALL RMPRT(SDRL,NLAY2,3,4HSDRL)
      CALL IMPRT(NUGH,NLAY2,1,4HNUGH)
      CALL IMPRT(NGEQ,NLAY2,1,4HNGEQ)
      CALL IMPRT(NGOL,NLAY2,1,4HNGOL)
C  SET PARAMETERS FOR  BULK LAYERS
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA
C  PRODUCE REFLECTION (RA1,RA2) AND TRANSMISSION (TA1,TA2) MATRICES
C  FOR SUBSTRATE LAYERS. TWO REGISTRIES- ID=2 (RA1,TA1 FOR REGISTRY
C  SS1, RA2,TA2 FOR REGISTRY SS2). NLL=NL SUBLATTICES. SUBSTRATE LAYER
C  SYMMETRIES AND REGISTRIES APPLY- LAY=2.
C  FIRST BEAM SET FIRST (NAA BEAMS)
      NAA = NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS NA=NS=NAA)
      NBB = NB(2)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  THIRD BEAM SET NEXT (NCC BEAMS. NOTE OFFSETS NA=NS=NAA+NBB)
      N=NAA+NBB
      NCC = NB(3)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NCC,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  FOURTH BEAM SET NEXT (NDD BEAMS. NOTE OFFSETS NA=NS=NAA+NBB+NCC)
      N=NAA+NBB+NCC
      NDD = NB(4)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NDD,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
      CALL CMPRTL(RA1,NT,NP,3HRA1)
      CALL CMPRTL(TA1,NT,NP,3HTA1)
      CALL CMPRTL(RA2,NT,NP,3HRA2)
      CALL CMPRTL(TA2,NT,NP,3HTA2)
C
C
C  NOW STACK LAYERS.
C  ASW BECOMES VECTOR BETWEEN 1ST AND 2ND SUBSTRATE LAYERS, AND WILL
C  BE VARIED BY SSTEP IN LOOP 969
C     DO 936 J=2,3
C 936 ASW(J)=ASA(J)
C     ASW(1)=ASA(1)-FPOS(2,1)
C     SSTEP=0.05/0.529
C     DO 969 ISUB=1,3
C     DO 935 J=1,3
C 935 AS(J)=ASW(J)*0.529
C     WRITE(6,430)(AS(J),J=1,3)
C  ASV BECOMES THE 3-D VECTOR FROM OVERLAYER TO TOP SUBSTRATE LAYER
C  AND WILL BE VARIED
      DO 937 J=1,3
  937 ASV(J)=ASB(J)
C  LOOP 960 RUNS OVER GEOMETRIES
HE OVERLAYER SPACING ASV(1) IS
C  VARIED
      DO 960 I = 1, NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      A=AS(1)
      WRITE (6,430) (AS(J),J=1,3)
C  COMPUTE REFLECTED BEAM AMPLITUDES (XI) BY RFS
      CALL RFSO2(ROV,TOV,ROV,TOV,RA1,TA1,RA2,TA2,
     1NT,NB,KNBS,NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH LAYER SPACING A ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  960 ASV(1)=ASV(1)+STEP
C     ASW(1)=ASW(1)-SSTEP
  969 CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 W(100)+P(2*2)W, RFS, GLIDE PLANES,SSYM=69,5 PH. SH.
  4  2  2               IDEG NL1 NL2
  4  9  6               KNBS KNT NPUN
 12                     NPSI
 3.1600 0.0000          ARA1
 0.0000 3.1600          ARA2
 0.5000 0.5000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 1.5800 0.0000 0.0000   ASA
 6.3200 0.0000          ARB1
 0.0000 6.3200          ARB2
 0.5000 0.5000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.5800 0.0000 0.0000   ASB
 0.5000 0.4000 0.1000   FR ASE STEP
  1                     NSTEP
  4
 0.     0.      1  1
 0.     1.0000  2  2
 1.0000 0.      2  2
 1.0000 1.0000  9  9
  1
 1.0000  .5000 29 29
  1
  .5000 1.0000 49 49
  3
  .5000  .5000 69 69
  .5000 1.5000 69 69
 1.5000  .5000 69 69
 0.0020                 TST
  1  2  3  4  5  6      NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 400.0000 183.8500   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
5402.0000   1.0080   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
  .3000
 -.8877 -.3222-2.5871  .0032  .0001  .0000  .0000  .0000  .0000  .0000
 1.3979 0.0211 0.0003 0.0000 0.0000 0.0000 0.0000
  .4000
-1.0151 -.4178-1.5835  .0082  .0003  .0000  .0000  .0000  .0000  .0000
 1.3321 0.0320 0.0006 0.0000 0.0000 0.0000 0.0000
  .5000
-1.1255 -.5032-1.0993  .0169  .0008  .0000  .0000  .0000  .0000  .0000
 1.2785 0.0440 0.0010 0.0000 0.0000 0.0000 0.0000
  .7500
-1.3563 -.6825 -.9244  .0612  .0042  .0002  .0000  .0000  .0000  .0000
 1.1743 0.0772 0.0025 0.0001 0.0000 0.0000 0.0000
 1.0000
-1.5484 -.8282 -.9594  .1479  .0127  .0009  .0001  .0000  .0000  .0000
 1.0944 0.1125 0.0050 0.0001 0.0000 0.0000 0.0000
 1.5000
-1.8682-1.0650-1.0764  .4547  .0565  .0060  .0006  .0000  .0000  .0000
 0.9739 0.1818 0.0125 0.0006 0.0000 0.0000 0.0000
 2.0000
-2.1338-1.2639-1.1761  .7973  .1489  .0205  .0026  .0003  .0000  .0000
 0.8847 0.2416 0.0233 0.0014 0.0001 0.0000 0.0000
 3.0000
-2.5582-1.6008-1.3333 1.1383  .4604  .0950  .0180  .0028  .0004  .0000
 0.7610 0.3215 0.0527 0.0049 0.0003 0.0000 0.0000
 4.0000
-2.8837-1.8755-1.4771 1.2583  .7767  .2267  .0591  .0129  .0023  .0003
 0.6829 0.3567 0.0877 0.0113 0.0009 0.0001 0.0000
 5.0000
-3.1446-2.1007-1.6131 1.3196 1.0178  .3728  .1271  .0359  .0083  .0016
 0.6334 0.3644 0.1227 0.0207 0.0022 0.0002 0.0000
 6.0000
-3.3643-2.2904-1.7352 1.3479 1.2153  .4993  .2083  .0735  .0212  .0050
 0.6021 0.3577 0.1534 0.0328 0.0043 0.0004 0.0000
 7.0000
-3.5565-2.4564-1.8434 1.3564 1.3807  .6050  .2868  .1215  .0425  .0122
 0.5819 0.3447 0.1778 0.0469 0.0074 0.0008 0.0001
  4                     NLAY
 0.0000 1.8800 1.2800   FPOS(1,J)
 0.0000-1.2800 1.8800   FPOS(2,J)
 0.0000-1.8800-1.2800   FPOS(3,J)
 0.0000 1.2800-1.8800   FPOS(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  1                     NTAU
  1  1  1  1            LPS
  4  0                  NINV NLAY2R
  0  0  0  0            INV
  20.00  21.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C
C  --- M4.1.4
C
C     PROGRAM GLIDE(INPUT,OUTPUT,PUN,TAPE8,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN)
C  TEST PROGRAM FOR GLIDE PLANE SYMMETRY. TEST STRUCTURE HAS TOP LAYER  150382
C  WITH 4-FOLD AXIS AND 2 GLIDE PLANES PERPENDICULAR TO EACH OTHER
C  (P4GM). THIS AND 3 OTHER MAIN PROGRAMS EXPLOIT DIFFERENT DEGREES
C  OF SYMMETRY. NOTE THE PARTICULAR CHOICES OF LOCATIONS OF THE
C  REFERENCE POINTS WITH RESPECT TO THE 4-FOLD AXIS AND THE GLIDE
C  PLANES.
C  CAUTION - THE COMMENTS IN THE BODY OF THIS MAIN PROGRAM ARE NOT ALL
C  APPROPRIATE.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASW(3)
C  4=NL, 45=KLM
      COMPLEX VL(4,2),FLMS(4, 45),FLM( 45)
C  4(1ST DIMENSION)=NL=NL1*NL2, 4(2ND DIMENSION)=IDEG
      DIMENSION V(4,2),JJS(4,4)
C  3=KNBS=NO. OF BEAM SETS READ IN, 6=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(3),NB(3),SPQF(2,6),SPQ(2,6),PQF(2,6),PQ(2,6)
      INTEGER KSYM(2,6),SYM(2,6)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  12=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,10)
C  4=NLAY, VPOS NOT USED, 12 FIXED, 759 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(1,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM( 809),YLM( 81),FAC2( 81),FAC1( 9)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
      COMPLEX ROV(6,6),TOV(6,6)
C  3=KNP
      COMPLEX RA1(6,3),TA1(6,4),RA2(6,4),TA2(6,4)
C  25=LMT, 15=LEV, 300(IN GH)=LMG, 4=NLAY, 100(IN TS)=LMN, 200=LM2N
C  100(IN TH, IPL)=LMNI
      COMPLEX TAU(25,15),TAUG(25),TAUGM(25),GH(300,25),RG(3,4,6),
     1TS(100),TG(2,200),VT(200),TH(100,100)
      DIMENSION IPL(100)
C  15=LEV, 10=LOD
      COMPLEX AMULT(6),CYLM(6,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(6)
C  10 FIXED (FOR RFS2OV), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(6),PK(6,10),AW(6,2),ANEW(6,20)
C ***** FOR CDC ONLY  *********
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
C     COMMON/BIG/ GH,TH,TAU,XEV,XOD,ROV,TOV,RA1,TA1,RA2,TA2
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
      COMMON /NST/NST1,ASI(3,10),STPS(3,10,2),NSTS(10,2),NACV
      COMMON /ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     1 IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN,
     2 BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYER (0,IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
C  START WITH OVERLAYER - E BECOMES ENERGY IN OVERLAYER
      E = EC - VO
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FROM PHASE SHIFTS, CORRECTED FOR
C  THERMAL VIBRATION (CAF AND TSF) OR NOT (AF AND TSF0). AF AND CAF
C  ARE USED FOR BRAVAIS-LATTICE LAYERS. TSF0 AND TSF ARE USED FOR
C  COMPOSITE LAYERS.
C  THIS CALL IS FOR OVERLAYER (IEL=2 IN INPUT SEQUENCE OF PHASE SHIFTS)
C     CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
C    1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  CHOOSE PARAMETERS RELEVANT TO OVERLAYER
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
C  IT=(0),1 MEANS INCLUDE (NO) EXPLICIT DEBYE-WALLER FACTORS IN MSMF
      IT=0
      TV = TVB
      VPI = VPIO
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUM IN FMAT. IF MUFFIN-TIN CONSTANTS AND
C  DAMPINGS IN SUBSTRATE AND OVERLAYER ARE EQUAL, DO LATTICE SUMS FOR
C  BOTH TYPES OF LAYERS NOW (NLS=NL IMPLIES - DO ALL SUBLATTICES).
C  OTHERWISE DO ONLY OVERLAYER LATTICE SUM (NLS=1 IMPLIES - DO ONLY THE
C  SUBLATTICE EQUAL TO THE OVERLAYER LATTICE)
      NLS = 1
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  NLS = NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C  PRODUCE REFLECTION (ROV) AND TRANSMISSION (TOV) MATRICES FOR THE
C  OVERLAYER. ONLY ONE REGISTRY- ID=1. ONLY ONE SUBLATTICE
C  OVERLAYER SYMMETRIES AND REGISTRIES APPLY- LAY=1. TEMPERATURE-
C  DEPENDENT PHASE SHIFTS USED- CAF
C     CALL MSMF(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,NT,NT,NT,AMULT,CYLM,
C    1PQ,SYM,NT,FLMS,FLM,V,NL,0,0,1,1,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
C    2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,1)
C     WRITE (6,410)
C
C
C  CONSIDER SUBSTRATE NEXT. CHOOSE CORRECT ENERGY
      E = EC
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR SUBSTRATE
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      VPI = VPIS
      VPI1 = VPIS
      IF (ABS(VPIS-VPIO)+ABS(VO) .LE. 1.0E-4)  GO TO 930
C  PERFORM PLANAR LATTICE SUMS FOR SUBSTRATE IF NOT DONE BEFORE
      CALL  FMAT (FLMS, V, JJS, NL, NL, DCUTS, IDEG, LMAX,KLM)
  930 CONTINUE
C  SET PARAMETERS FOR  TOP SUBSTRATE LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=2
      NEW=1
      VPI1=VPIS
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR RUMPLED LAYER
      CALL MTINV(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,FPOS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,416)
      CALL CMPRTL(ROV,NT,NT,3HROV)
      CALL CMPRTL(TOV,NT,NT,3HTOV)
      CALL CMPRT(CYLM,NT,LMMAX,4HCYLM)
      CALL CMPRT(FLMS,NL,KLM,4HFLMS)
      CALL CMPRTL(TAU,LMT,LEV,3HTAU)
      CALL RMPRT(FPOS,NLAY,3,4HFPOS)
      CALL RMPRT(POSS,NLAY,3,4HPOSS)
      CALL RMPRT(DRL,NLAY2,3,3HDRL)
      CALL RMPRT(SDRL,NLAY2,3,4HSDRL)
      CALL IMPRT(NUGH,NLAY2,1,4HNUGH)
      CALL IMPRT(NGEQ,NLAY2,1,4HNGEQ)
      CALL IMPRT(NGOL,NLAY2,1,4HNGOL)
C  SET PARAMETERS FOR  BULK LAYERS
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA
C  PRODUCE REFLECTION (RA1,RA2) AND TRANSMISSION (TA1,TA2) MATRICES
C  FOR SUBSTRATE LAYERS. TWO REGISTRIES- ID=2 (RA1,TA1 FOR REGISTRY
C  SS1, RA2,TA2 FOR REGISTRY SS2). NLL=NL SUBLATTICES. SUBSTRATE LAYER
C  SYMMETRIES AND REGISTRIES APPLY- LAY=2.
C  FIRST BEAM SET FIRST (NAA BEAMS)
      NAA = NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS NA=NS=NAA)
      NBB = NB(2)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  THIRD BEAM SET NEXT (NCC BEAMS. NOTE OFFSETS NA=NS=NAA+NBB)
      N=NAA+NBB
      NCC = NB(3)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NCC,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  FOURTH BEAM SET NEXT (NDD BEAMS. NOTE OFFSETS NA=NS=NAA+NBB+NCC)
C     N=NAA+NBB+NCC
C     NDD = NB(4)
C     CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NDD,NT,NP,AMULT,CYLM,
C    1PQ,SYM,NT,FLMS,FLM,V,NL,N  ,N  ,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
C    2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
C     WRITE (6,410)
      CALL CMPRTL(RA1,NT,NP,3HRA1)
      CALL CMPRTL(TA1,NT,NP,3HTA1)
      CALL CMPRTL(RA2,NT,NP,3HRA2)
      CALL CMPRTL(TA2,NT,NP,3HTA2)
C
C
C  NOW STACK LAYERS.
C  ASW BECOMES VECTOR BETWEEN 1ST AND 2ND SUBSTRATE LAYERS, AND WILL
C  BE VARIED BY SSTEP IN LOOP 969
C     DO 936 J=2,3
C 936 ASW(J)=ASA(J)
C     ASW(1)=ASA(1)-FPOS(2,1)
C     SSTEP=0.05/0.529
C     DO 969 ISUB=1,3
C     DO 935 J=1,3
C 935 AS(J)=ASW(J)*0.529
C     WRITE(6,430)(AS(J),J=1,3)
C  ASV BECOMES THE 3-D VECTOR FROM OVERLAYER TO TOP SUBSTRATE LAYER
C  AND WILL BE VARIED
      DO 937 J=1,3
  937 ASV(J)=ASB(J)
C  LOOP 960 RUNS OVER GEOMETRIES
HE OVERLAYER SPACING ASV(1) IS
C  VARIED
      DO 960 I = 1, NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      A=AS(1)
      WRITE (6,430) (AS(J),J=1,3)
C  COMPUTE REFLECTED BEAM AMPLITUDES (XI) BY RFS
      CALL RFSO2(ROV,TOV,ROV,TOV,RA1,TA1,RA2,TA2,
     1NT,NB,KNBS,NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH LAYER SPACING A ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  960 ASV(1)=ASV(1)+STEP
C     ASW(1)=ASW(1)-SSTEP
  969 CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 W(100)+P(2*2)W, RFS, GLIDE PLANES,SSYM=30,5 PH. SH.
  4  2  2               IDEG NL1 NL2
  3  6  6               KNBS KNT NPUN
 12                     NPSI
 3.1600 0.0000          ARA1
 0.0000 3.1600          ARA2
 0.0000 0.0000          SS1
 0.5000 0.5000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 1.5800 0.0000 0.0000   ASA
 6.3200 0.0000          ARB1
 0.0000 6.3200          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.5800 0.0000 0.0000   ASB
 0.5000 0.4000 0.1000   FR ASE STEP
  1                     NSTEP
  3
 0.     0.      1  1
 1.0000 0.      7  7
 1.0000 1.0000  7  7
  1
  .5000 1.0000 30 69
  2
  .5000  .5000  7  7
 1.5000  .5000 10 10
 0.0020                 TST
  1  2  3  4  5  6      NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 400.0000 183.8500   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
5402.0000   1.0080   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
  .3000
 -.8877 -.3222-2.5871  .0032  .0001  .0000  .0000  .0000  .0000  .0000
 1.3979 0.0211 0.0003 0.0000 0.0000 0.0000 0.0000
  .4000
-1.0151 -.4178-1.5835  .0082  .0003  .0000  .0000  .0000  .0000  .0000
 1.3321 0.0320 0.0006 0.0000 0.0000 0.0000 0.0000
  .5000
-1.1255 -.5032-1.0993  .0169  .0008  .0000  .0000  .0000  .0000  .0000
 1.2785 0.0440 0.0010 0.0000 0.0000 0.0000 0.0000
  .7500
-1.3563 -.6825 -.9244  .0612  .0042  .0002  .0000  .0000  .0000  .0000
 1.1743 0.0772 0.0025 0.0001 0.0000 0.0000 0.0000
 1.0000
-1.5484 -.8282 -.9594  .1479  .0127  .0009  .0001  .0000  .0000  .0000
 1.0944 0.1125 0.0050 0.0001 0.0000 0.0000 0.0000
 1.5000
-1.8682-1.0650-1.0764  .4547  .0565  .0060  .0006  .0000  .0000  .0000
 0.9739 0.1818 0.0125 0.0006 0.0000 0.0000 0.0000
 2.0000
-2.1338-1.2639-1.1761  .7973  .1489  .0205  .0026  .0003  .0000  .0000
 0.8847 0.2416 0.0233 0.0014 0.0001 0.0000 0.0000
 3.0000
-2.5582-1.6008-1.3333 1.1383  .4604  .0950  .0180  .0028  .0004  .0000
 0.7610 0.3215 0.0527 0.0049 0.0003 0.0000 0.0000
 4.0000
-2.8837-1.8755-1.4771 1.2583  .7767  .2267  .0591  .0129  .0023  .0003
 0.6829 0.3567 0.0877 0.0113 0.0009 0.0001 0.0000
 5.0000
-3.1446-2.1007-1.6131 1.3196 1.0178  .3728  .1271  .0359  .0083  .0016
 0.6334 0.3644 0.1227 0.0207 0.0022 0.0002 0.0000
 6.0000
-3.3643-2.2904-1.7352 1.3479 1.2153  .4993  .2083  .0735  .0212  .0050
 0.6021 0.3577 0.1534 0.0328 0.0043 0.0004 0.0000
 7.0000
-3.5565-2.4564-1.8434 1.3564 1.3807  .6050  .2868  .1215  .0425  .0122
 0.5819 0.3447 0.1778 0.0469 0.0074 0.0008 0.0001
  4                     NLAY
 0.0000 1.8800 1.2800   FPOS(1,J)
 0.0000-1.2800 1.8800   FPOS(2,J)
 0.0000-1.8800-1.2800   FPOS(3,J)
 0.0000 1.2800-1.8800   FPOS(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  1                     NTAU
  1  1  1  1            LPS
  4  0                  NINV NLAY2R
  0  0  0  0            INV
  20.00  21.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C  --- M4.2.1
C
C     PROGRAM SIJN(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA FOR SI(111)(2X1),AS (1X1),TOP 2 LAY VAR,(XZ) M PL,RFS+RSP  150683
C
C  MAIN PROGRAM FOR SI(111)(2X1). EACH LAYER HAS 4 ATOMS PER UNIT CELL.
C  NO +-X SYMMETRY IS ASSUMED IN ANY LAYER. THE RELATIVE POSITIONS
C  OF THE 4 ATOMS IN EACH OF THE TOP TWO LAYERS IS VARIABLE, AS ARE
C  THE TOP TWO INTERLAYER VECTORS.
C  THE (XZ) PLANE IS ASSUMED TO BE A MIRROR PLANE (THIS ONLY AFFECTS
C  THE DIMENSION KNT, WITH RESPECT TO THE NON-SYMMETRIZED MAIN PROGRAM).
C  RENORMALIZED FORWARD SCATTERING IS USED BETWEEN LAYERS AND REVERSE
C  SCATTERING PERTURBATION WITHIN LAYERS.
C  THE FOLLOWING DIAGRAM SHOWS THE GEOMETRICAL ORGANIZATION OF THIS MAIN
C  PROGRAM AND THE MEANING OF SEVERAL QUANTITIES. A CUT ALONG AN
C  (XZ) SYMMETRY PLANE OF THE SURFACE IS SKETCHED. ATOMS BETWEEN
C  BRACKETS ARE IN A DIFFERENT PLANE THAN THE OTHERS (ALSO A MIRROR PLANE).
C  DASHED LINES CONNECTING ATOMS REPRESENT BONDS. DOTTED LINE CONNECTS
C  REFERENCE POINTS (CROSSES OR ATOMS) ON SUCCESSIVE LAYERS, SHOWING
C  INTERLAYER VECTORS. FPOS1,2,3 ARE ATOMIC POSITIONS INSIDE LAYERS.
C
C
C
C  LAYER NO.     INTER- AND INTRALAYER VECTORS        LAYER DIFFR. MATR.
C
C   VACUUM
C
C   0(SURF.)            X
C                       .
C                      ASE
C                       .
C   1***************** SI1 *************************** SI1 ****** )
C   1                   I                               I         )
C   1     I-------------I----(SI2)             I--------I----- -  )
C   1     I             .      I               I                  )
C   1     I     FPOS1   .      I--------I      I                  ) R1P,T1P
C   1     I             .               I      I                  ) R1M,T1M
C   1 - --I             .             (SI4)----I                  )
C   1     I             .               I      I                  )
C   1*** SI3 ********** X **************I**** SI3 *************** )
C         I             .               I      I
C         I             .               I      I
C         I         ASB1+STEP1          I      I
C         I             .               I      I
C         I-----I........            I--I      I----I
C               I                    I              I
C   2********** X **************** (SI6) ***********I************ )
C   2           I                    I              I             )
C   2 - -I-----SI5------------I------I--------I----SI5----- -     )
C   2    I      .             I               I                   ) R2P,T2P
C   2    I      .   FPOS2     I               I                   ) R2M,T2M
C   2    I      .             I               I                   )
C   2    I      .            SI7              I                   )
C   2    I      .             I               I                   )
C   2* (SI8) ** X ************I************ (SI8) *************** )
C        I      ........      I               I
C        I             .      I               I
C        I         ASB2+STEP2 I               I
C        I             .      I               I
C        I             .......I               I
C        I                    I               I
C   3****I***************** (SI9) ************I****************** )
C   3    I                    I               I                   )
C   3 -(SI10)----------I------I--------I---(SI10)---------- -     )
C   3                  I      .        I                          ) R3P,T3P
C   3                  I      .        I                          ) R3M,T3M
C   3                  I      .        I                          )
C   3                (SI12)   .        I                          )
C   3                  I      .        I                          )
C   3******************I***** X ***** SI11 ********************** )
C                      I      .        I
C                      I      .        I
C                      I     ASA       I
C                      I      .        I
C                      I.......        I
C                      I               I
C   4*************** (SI9) ************I************************* )
C   4                  I               I                          )
C        ETC. (LAYER 3 = LAYER 4 = LAYER 5 = ... )
C
C
C
C
C  NOTE - FOR ASB(1) THE SMALLEST PLANNED LAYER SPACING SHOULD BE INPUT
C         (ASB(1) WILL ONLY BE USED IN THE BEAM-SELECTION CRITERION).
C
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASW(3),AS1(3),AS2(3)
      DIMENSION FPOS1(5,4,3),FPOS2(5,4,3),FPOS3(4,3),
     1ASB1(5,3),STEP1(1,15,3),NSTEP1(5),
     1ASB2(5,3),STEP2(1,5,3),NSTEP2(5)
C  1=NL, 45=KLM
      COMPLEX VL(1,2),FLMS(1,45),FLM(45)
C  1(1ST DIMENSION)=NL=NL1*NL2, 2(2ND DIMENSION)=IDEG
      DIMENSION V(1,2),JJS(1,2)
C  1=KNBS=NO. OF BEAM SETS READ IN, 39=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(1),NB(1),SPQF(2,39),SPQ(2,39),PQF(2,39),PQ(2,39)
      INTEGER KSYM(2,39),SYM(2,39)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  13=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(13),PHSS(13,10)
C  4=NLAY, VPOS NOT USED, 12 FIXED, 759 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(1,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20),POS(4,3)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),YLM( 81),FAC2( 81),FAC1( 9)
      DIMENSION CLM( 809)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),CAF1(5),TSF0(6,10),TSF(6,10)
      COMPLEX R1P(39,39),T1P(39,39),R1M(39,39),T1M(39,39)
      COMPLEX R2P(39,39),T2P(39,39),R2M(39,39),T2M(39,39)
      COMPLEX R3P(39,39),T3P(39,39),R3M(39,39),T3M(39,39)
C  25=LMT, 15=LEV, 300(IN GH)=LMG, 4=NLAY, 100(IN TS)=LMN, 200=LM2N
C  1(IN TH, IPL)=LMNI
      COMPLEX TAU(25,15),TAUG(25),TAUGM(25),GH(300,25),RG(3,4,39),
     1TS(100),TG(2,200),VT(200),TH(1,1)
      DIMENSION IPL(1)
C  15=LEV, 10=LOD
      COMPLEX AMULT(39),CYLM(39,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(39)
C  10 FIXED (FOR RFT2V3), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(39),PK(39,10),AW(39,2),ANEW(39,20)
C  ****  FOR CDC ONLY  **********
C     LEVEL 2, GH,TH,TAU,XEV,XOD,R1P,T1P,R1M,T1M,R2P,T2P,R2M,T2M,
C    1R3P,T3P,R3M,T3M
C     COMMON/BIG/  GH,TH,TAU,XEV,XOD,R1P,T1P,R1M,T1M,R2P,T2P,R2M,T2M,
C    1R3P,T3P,R3M,T3M
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  160 FORMAT(3F7.4)
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG - EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1 NL2 -      LATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYERS
      READ(5,200)NLAY
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYERS
      CALL READCL(NLAY,NLAY2,FPOS3,VPOS,NVAR,NTAU,LPS,NINV,INV,
     1LMMAX,LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
C  ADDITIONAL INPUT OF GEOMETRICAL VARIABLES
      READ(5,200) NII1,NII2
      WRITE(6,200) NII1,NII2
      DO 481 II = 1,NII1
      READ(5,160) (ASB1(II,J),J =1,3)
 481  WRITE(6,160) (ASB1(II,J),J =1,3)
      DO 4811 II=1,NII2
      READ(5,160)(ASB2(II,J),J=1,3)
 4811 WRITE(6,160)(ASB2(II,J),J=1,3)
      DO 482 J = 1,3
      DO 482 II = 1,NII1
 482  ASB1(II,J) = ASB1(II,J)/0.529
      DO 4821 II=1,NII2
      DO 4821 J=1,3
 4821 ASB2(II,J)=ASB2(II,J)/0.529
      READ(5,200)(NSTEP1(II),II=1,NII1)
      WRITE(6,200)(NSTEP1(II),II=1,NII1)
      READ(5,200)(NSTEP2(II),II=1,NII2)
      WRITE(6,200)(NSTEP2(II),II=1,NII2)
      DO 483 II = 1,NII1
      NSTPD=NSTEP1(II)
      DO 484 NN = 1,NSTPD
      READ(5,160)(STEP1(II,NN,J),J =1,3)
 484  WRITE(6,160)(STEP1(II,NN,J),J =1,3)
      DO 485 NN = 1,NSTPD
      DO 485 J = 1,3
 485  STEP1(II,NN,J) = STEP1(II,NN,J)/0.529
 483  CONTINUE
      DO 4831 II=1,NII2
      NSTPD=NSTEP2(II)
      DO 4841 NN=1,NSTPD
      READ(5,160)(STEP2(II,NN,J),J=1,3)
 4841 WRITE(6,160)(STEP2(II,NN,J),J=1,3)
      DO 4851 NN=1,NSTPD
      DO 4851 J=1,3
 4851 STEP2(II,NN,J)=STEP2(II,NN,J)/0.529
 4831 CONTINUE
      DO 561 II =1,NII1
      DO 562 I = 1,NLAY
      READ(5,160)(FPOS1(II,I,J),J=1,3)
 562  WRITE(6,160)(FPOS1(II,I,J),J=1,3)
      DO 563 I = 1,NLAY
      DO 563 J = 1,3
 563  FPOS1(II,I,J)=FPOS1(II,I,J)/0.529
 561  CONTINUE
      DO 5611 II=1,NII2
      DO 5621 I=1,NLAY
      READ(5,160)(FPOS2(II,I,J),J=1,3)
 5621 WRITE(6,160)(FPOS2(II,I,J),J=1,3)
      DO 5631 I=1,NLAY
      DO 5631 J=1,3
 5631 FPOS2(II,I,J)=FPOS2(II,I,J)/0.529
 5611 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM - PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      E = EC
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FROM PHASE SHIFTS, CORRECTED FOR
C  THERMAL VIBRATION (CAF AND TSF) OR NOT (AF AND TSF0). AF AND CAF
C  ARE USED FOR BRAVAIS-LATTICE LAYERS. TSF0 AND TSF ARE USED FOR
C  COMPOSITE LAYERS.
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C  PERFORM BRAVAIS-LATTICE SUM IN FMAT.
      CALL  FMAT (FLMS, V, JJS, NL, NL, DCUTO, IDEG, LMAX,KLM)
C
C
C  SET PARAMETERS FOR SUBSTRATE LAYERS (LAY=2 FOR SUBSTRATE
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=2
      TV1=TVA
      DCUT=DCUTS
      EPSN=0.001
      NPERT=8
      NOPT=1
      NEW=1
      VPI1=VPIS
C  PRINT INTERNAL GEOMETRY (A.U.)
      CALL RMPRT(FPOS3,NLAY,3,9HFPOS3(AU))
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR SUBSTRATE LAYERS
      CALL MPERTI(R3P,T3P,R3M,T3M,R3P,T3P,R3M,T3M,R3P,T3P,R3M,T3M,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,
     3CLM,NLM,FPOS3,POSS,
     4MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     5GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,LMNI2)
      WRITE(6,415)
C
C
C  SET PARAMETERS FOR TOP TWO LAYERS
      DCUT=DCUTO
      NA=0
      NS=0
      ID=1
      LAY=1
      EPSN=0.001
      NPERT=8
      NOPT=1
      NEW=-1
      GEOM=1.
C
C
C  START LOOP OVER INTERNAL STRUCTURE OF 2ND LAYER
      DO 962 II2= 1,NII2
      DO 940 I=1,NLAY
      DO 940 J=1,3
  940 POS(I,J)=FPOS2(II2,I,J)
      CALL RMPRT(POS,NLAY,3,9HFPOS2(AU))
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR 2ND LAYER
      CALL MPERTI(R2P,T2P,R2M,T2M,R2P,T2P,R2M,T2M,R2P,T2P,R2M,T2M,
     1 NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,
     2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,
     3CLM,NLM,POS,POSS,MGH,NLAY,DRL,SDRL,NUGH,NGEQ,
     4NGOL,NLAY2,TEST,GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,
     5LMNI,LMNI2)
      WRITE(6,415)
C
C
C  START LOOP OVER INTERNAL SRUCTURE OF TOP LAYER
      DO 9621 II1=1,NII1
      DO 9401 IX=1,NLAY
      DO 9401 J=1,3
 9401 POS(IX,J)=FPOS1(II1,IX,J)
      CALL RMPRT(POS,NLAY,3,9HFPOS1(AU))
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR TOP LAYER
      CALL MPERTI(R1P,T1P,R1M,T1M,R1P,T1P,R1M,T1M,R1P,T1P,R1M,T1M,
     1NT,NT,NT,AMULT,
     2CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,KLM,XEV,LEV,
     3LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,POS,POSS,MGH,NLAY,DRL,
     4SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,GH,LMG,RG,TS,LMN,TG,
     5LM2N,VT,CAA,NCAA,TH,LMNI,LMNI2)
      WRITE(6,415)
      NEW=-1
C
C
C  START LOOP OVER 2ND INTERLAYER VECTOR
      NSTPD=NSTEP2(II2)
      DO 960 IS2=1,NSTPD
      DO 961 J = 1,3
      AS2(J) = ASB2(II2,J)+STEP2(II2,IS2,J)
961   AS(J)=AS2(J)*0.529
      WRITE(6,430)AS
C
C
C  START LOOP OVER TOP INTERLAYER VECTOR
      DO 9601 IS1=1,NSTPDT
      NSTPDT=NSTEP1(II1)
      DO 9611 J=1,3
      AS1(J)=ASB1(II1,J)+STEP1(II1,IS1,J)
9611  AS(J)=AS1(J)*0.529
      WRITE(6,430)AS
C  COMPUTE REFLECTED BEAM AMPLITUDES (XI) BY RFS
      CALL RFT2V3(R1P,T1P,R1M,T1M,R2P,T2P,R2M,T2M,R3P,T3P,R3M,T3M,
     1R3P,T3P,R3M,T3M,R3P,T3P,R3M,T3M,
     2NT,NB,KNBS,NP,XI,PQ,PK,AW,ANEW,20,AS1,AS2,ASA,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH GEOM. NO. GEOM ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,GEOM,1)
C
C
C  ENDS OF STRUCTURE, TEMPERATURE AND ENERGY LOOPS
      GEOM=GEOM+1.
 9601 CONTINUE
 960  CONTINUE
 9621 CONTINUE
 962  CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 SI(111)(2X1),UNRECON,AS (1X1),TOP 2 LAY.VAR,5PS,(XZ) MIRR PL,RSP+RFS
  2  1  1               IDEG NL1 NL2
  1 39 17               KNBS KNT NPUN
 13                     NPSI
 3.8396 0.0000          ARA1
 0.0000 6.6503          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.3500 1.9198-1.1035   ASA
 3.8396 0.0000          ARB1
 0.0000 6.6503          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 2.0000 0.0000 0.0000   ASB
 0.5000 1.1700 0.1000   FR ASE STEP
  1                     NSTEP
 39                     KNB(1)
 0.0000 0.0000  1  1    BEAMS
 0.0000 1.0000  1  1
 0.0000-1.0000  1  1
 1.0000 0.0000  6  6
 1.0000 1.0000  6  6
 1.0000-1.0000  6  6
 0.0000 2.0000  1  1
 0.0000-2.0000  1  1
 2.0000 0.0000  6  6
 1.0000 2.0000  6  6
 1.0000-2.0000  6  6
 2.0000 1.0000  6  6
 2.0000-1.0000  6  6
 0.0000 3.0000  1  1
 0.0000-3.0000  1  1
 2.0000 2.0000  6  6
 2.0000-2.0000  6  6
 1.0000 3.0000  6  6
 1.0000-3.0000  6  6
 3.0000 0.0000  6  6
 3.0000 1.0000  6  6
 3.0000-1.0000  6  6
 0.0000 4.0000  1  1
 0.0000-4.0000  1  1
 2.0000 3.0000  6  6
 2.0000-3.0000  6  6
 1.0000 4.0000  6  6
 1.0000-4.0000  6  6
 0.0000 5.0000  1  1
 0.0000-5.0000  1  1
 1.0000 5.0000  6  6
 1.0000-5.0000  6  6
 2.0000 4.0000  6  6
 2.0000-4.0000  6  6
 3.0000 2.0000  6  6
 3.0000-2.0000  6  6
 3.0000 3.0000  6  6
 3.0000-3.0000  6  6
 4.0000 0.0000  6  6
 0.0080                 TST
  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 18 19      NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 464.3500  28.0800   1.0000   1.0000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
 0.3676
  .5618  .6375  .0717  .0022  .0001  .0000  .0000  .0000  .0000  .0000  SI
 
 0.5515
  .3361  .7678  .1921  .0081  .0004  .0000  .0000  .0000  .0000  .0000
 
 0.7353
  .1549  .7848  .3740  .0197  .0012  .0001  .0000  .0000  .0000  .0000
 
 1.1029
 -.1283  .7073  .7890  .0649  .0058  .0004  .0000  .0000  .0000  .0000
 
 1.4706
 -.3441  .5980 1.0566  .1401  .0166  .0016  .0001  .0000  .0000  .0000
 
 2.0221
 -.5885  .4483 1.2243  .2874  .0490  .0066  .0007  .0001  .0000  .0000
 
 2.9412
 -.8709  .2678 1.3382  .4995  .1436  .0297  .0047  .0006  .0001  .0000
 
 4.0441
-1.1097  .1241 1.4315  .6247  .2731  .0865  .0200  .0036  .0005  .0001
 
 5.1471
-1.3027  .0075 1.4781  .6936  .3621  .1599  .0511  .0122  .0023  .0003
 
 6.0662
-1.4426 -.0812 1.4908  .7440  .4063  .2147  .0867  .0258  .0059  .0011
 
 6.9853
-1.5654 -.1607 1.4967  .7881  .4388  .2556  .1249  .0455  .0125  .0027
 
 8.0882
-1.6915 -.2414 1.5042  .8265  .4749  .2888  .1658  .0746  .0253  .0066
 
 9.0074
-1.7818 -.2976 1.5104  .8473  .5043  .3095  .1922  .1002  .0397  .0121
 
  4                     NLAY
 0.0000 0.0000 0.0000   FPOS3(1,J)
 0.0010-1.9198 3.3252   FPOS3(2,J)
 0.7838 0.0000 2.2168   FPOS3(3,J)
 0.7838-1.9198-1.1084   FPOS3(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  1                     NTAU
  1  1  1  1            LPS
  0                     NINV
  0  0  0  0            INV
  1  1                  NII1  NII2
 2.3513 0.0000 2.2168   ASB1
 2.3513 0.0000 2.2168   ASB2
  3                     NSTEP1
  1                     NSTEP2
 -.1000 0.0000 0.0000   STEP1
 0.0000 0.0000 0.0000   STEP1
 0.1000 0.0000 0.0000   STEP1
-0.0000 0.0000 0.0000   STEP2
 0.0000 0.0000 0.0000   FPOS1(1,J)
 0.0010-1.9198 3.3252   FPOS1(2,J)
 0.7838 0.0000 2.2168   FPOS1(3,J)
 0.7838-1.9198-1.1084   FPOS1(4,J)
 0.0000 0.0000 0.0000   FPOS2(1,J)
 0.0010-1.9198 3.3252   FPOS2(2,J)
 0.7838 0.0000 2.2168   FPOS2(3,J)
 0.7838-1.9198-1.1084   FPOS2(4,J)
  20.00 151.00   5.00   EI EF DE
 -10.00                 EI EF DE
 SI(111)(2X1),NORTHRUP,AS (1X1),TOP 2 LAY.VAR,5PS,(XZ) MIRR PL,RSP+RFS
  2  1  1               IDEG NL1 NL2
  1 39 17               KNBS KNT NPUN
 13                     NPSI
 3.8396 0.0000          ARA1
 0.0000 6.6503          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.3500 1.9198-1.1035   ASA
 3.8396 0.0000          ARB1
 0.0000 6.6503          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 2.0000 0.0000 0.0000   ASB
 0.5000 1.1700 0.1000   FR ASE STEP
  1                     NSTEP
 39                     KNB(1)
 0.0000 0.0000  1  1    BEAMS
 0.0000 1.0000  1  1
 0.0000-1.0000  1  1
 1.0000 0.0000  6  6
 1.0000 1.0000  6  6
 1.0000-1.0000  6  6
 0.0000 2.0000  1  1
 0.0000-2.0000  1  1
 2.0000 0.0000  6  6
 1.0000 2.0000  6  6
 1.0000-2.0000  6  6
 2.0000 1.0000  6  6
 2.0000-1.0000  6  6
 0.0000 3.0000  1  1
 0.0000-3.0000  1  1
 2.0000 2.0000  6  6
 2.0000-2.0000  6  6
 1.0000 3.0000  6  6
 1.0000-3.0000  6  6
 3.0000 0.0000  6  6
 3.0000 1.0000  6  6
 3.0000-1.0000  6  6
 0.0000 4.0000  1  1
 0.0000-4.0000  1  1
 2.0000 3.0000  6  6
 2.0000-3.0000  6  6
 1.0000 4.0000  6  6
 1.0000-4.0000  6  6
 0.0000 5.0000  1  1
 0.0000-5.0000  1  1
 1.0000 5.0000  6  6
 1.0000-5.0000  6  6
 2.0000 4.0000  6  6
 2.0000-4.0000  6  6
 3.0000 2.0000  6  6
 3.0000-2.0000  6  6
 3.0000 3.0000  6  6
 3.0000-3.0000  6  6
 4.0000 0.0000  6  6
 0.0080                 TST
  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 18 19      NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 464.3500  28.0800   1.0000   1.0000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
 0.3676
  .5618  .6375  .0717  .0022  .0001  .0000  .0000  .0000  .0000  .0000  SI
 
 0.5515
  .3361  .7678  .1921  .0081  .0004  .0000  .0000  .0000  .0000  .0000
 
 0.7353
  .1549  .7848  .3740  .0197  .0012  .0001  .0000  .0000  .0000  .0000
 
 1.1029
 -.1283  .7073  .7890  .0649  .0058  .0004  .0000  .0000  .0000  .0000
 
 1.4706
 -.3441  .5980 1.0566  .1401  .0166  .0016  .0001  .0000  .0000  .0000
 
 2.0221
 -.5885  .4483 1.2243  .2874  .0490  .0066  .0007  .0001  .0000  .0000
 
 2.9412
 -.8709  .2678 1.3382  .4995  .1436  .0297  .0047  .0006  .0001  .0000
 
 4.0441
-1.1097  .1241 1.4315  .6247  .2731  .0865  .0200  .0036  .0005  .0001
 
 5.1471
-1.3027  .0075 1.4781  .6936  .3621  .1599  .0511  .0122  .0023  .0003
 
 6.0662
-1.4426 -.0812 1.4908  .7440  .4063  .2147  .0867  .0258  .0059  .0011
 
 6.9853
-1.5654 -.1607 1.4967  .7881  .4388  .2556  .1249  .0455  .0125  .0027
 
 8.0882
-1.6915 -.2414 1.5042  .8265  .4749  .2888  .1658  .0746  .0253  .0066
 
 9.0074
-1.7818 -.2976 1.5104  .8473  .5043  .3095  .1922  .1002  .0397  .0121
 
  4                     NLAY
 0.0000 0.0000 0.0000   FPOS3(1,J)
 0.2010-1.9198 3.2848   FPOS3(2,J)
 0.8734 0.0000 2.2032   FPOS3(3,J)
 0.8734-1.9198-1.1208   FPOS3(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  1                     NTAU
  1  1  1  1            LPS
  0                     NINV
  0  0  0  0            INV
  1  1                  NII1  NII2
 2.1630 0.0000-1.1960   ASB1
 2.0965 0.0000 2.3165   ASB2
 15                     NSTEP1
  1                     NSTEP2
 -.0500 0.0000 -.2000   STEP1
 -.0500 0.0000 -.1000   STEP1
 -.0500 0.0000 0.0000   STEP1
 -.0500 0.0000 0.1000   STEP1
 -.0500 0.0000 0.2000   STEP1
 0.0000 0.0000 -.2000   STEP1
-0.0000 0.0000 -.1000   STEP1
-0.0000 0.0000 0.0000   STEP1
 0.0000 0.0000 0.1000   STEP1
-0.0000 0.0000 0.2000   STEP1
 0.0500 0.0000 -.2000   STEP1
 0.0500 0.0000 -.1000   STEP1
 0.0500 0.0000 0.0000   STEP1
 0.0500 0.0000 0.1000   STEP1
 0.0500 0.0000 0.2000   STEP1
-0.0000 0.0000 0.0000   STEP2
 0.000  0.000  0.000    FPOS1
 0.0979-1.9198 1.1357   FPOS1
 1.0572 0.000 -2.0777   FPOS1
 1.0043-1.9198 3.2244   FPOS1
 0.0778 0.0000 0.000    FPOS2
 0.0000-1.9198 3.4827   FPOS2
 0.6549 0.000  2.3112   FPOS2
 0.9565-1.9198-1.0256   FPOS2
  30.00  31.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C
C
C  --- M4.2.2
C
C     PROGRAM SIJNG(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA FOR SI(111)(2X1),AS (1X1),TOP 2 LAY VAR,NO SYMM,RFS+RSP    150683
C
C  MAIN PROGRAM FOR SI(111)(2X1). EACH LAYER HAS 4 ATOMS PER UNIT CELL.
C  NO +-X SYMMETRY IS ASSUMED IN ANY LAYER. THE RELATIVE POSITIONS
C  OF THE 4 ATOMS IN EACH OF THE TOP TWO LAYERS IS VARIABLE, AS ARE
C  THE TOP TWO INTERLAYER VECTORS.
C  THE (XZ) PLANE IS ASSUMED TO BE A MIRROR PLANE.
C  RENORMALIZED FORWARD SCATTERING IS USED BETWEEN LAYERS AND REVERSE
C  SCATTERING PERTURBATION WITHIN LAYERS.
C  THE FOLLOWING DIAGRAM SHOWS THE GEOMETRICAL ORGANIZATION OF THIS MAIN
C  PROGRAM AND THE MEANING OF SEVERAL QUANTITIES. A CUT ALONG AN
C  (XZ) SYMMETRY PLANE OF THE SURFACE IS SKETCHED. ATOMS BETWEEN
C  BRACKETS ARE IN A DIFFERENT PLANE THAN THE OTHERS (ALSO A MIRROR PLANE).
C  DASHED LINES CONNECTING ATOMS REPRESENT BONDS. DOTTED LINE CONNECTS
C  REFERENCE POINTS (CROSSES OR ATOMS) ON SUCCESSIVE LAYERS, SHOWING
C  INTERLAYER VECTORS. FPOS1,2,3 ARE ATOMIC POSITIONS INSIDE LAYERS.
C
C
C
C  LAYER NO.     INTER- AND INTRALAYER VECTORS        LAYER DIFFR. MATR.
C
C   VACUUM
C
C   0(SURF.)            X
C                       .
C                      ASE
C                       .
C   1***************** SI1 *************************** SI1 ****** )
C   1                   I                               I         )
C   1     I-------------I----(SI2)             I--------I----- -  )
C   1     I             .      I               I                  )
C   1     I     FPOS1   .      I--------I      I                  ) R1P,T1P
C   1     I             .               I      I                  ) R1M,T1M
C   1 - --I             .             (SI4)----I                  )
C   1     I             .               I      I                  )
C   1*** SI3 ********** X **************I**** SI3 *************** )
C         I             .               I      I
C         I             .               I      I
C         I         ASB1+STEP1          I      I
C         I             .               I      I
C         I-----I........            I--I      I----I
C               I                    I              I
C   2********** X **************** (SI6) ***********I************ )
C   2           I                    I              I             )
C   2 - -I-----SI5------------I------I--------I----SI5----- -     )
C   2    I      .             I               I                   ) R2P,T2P
C   2    I      .   FPOS2     I               I                   ) R2M,T2M
C   2    I      .             I               I                   )
C   2    I      .            SI7              I                   )
C   2    I      .             I               I                   )
C   2* (SI8) ** X ************I************ (SI8) *************** )
C        I      ........      I               I
C        I             .      I               I
C        I         ASB2+STEP2 I               I
C        I             .      I               I
C        I             .......I               I
C        I                    I               I
C   3****I***************** (SI9) ************I****************** )
C   3    I                    I               I                   )
C   3 -(SI10)----------I------I--------I---(SI10)---------- -     )
C   3                  I      .        I                          ) R3P,T3P
C   3                  I      .        I                          ) R3M,T3M
C   3                  I      .        I                          )
C   3                (SI12)   .        I                          )
C   3                  I      .        I                          )
C   3******************I***** X ***** SI11 ********************** )
C                      I      .        I
C                      I      .        I
C                      I     ASA       I
C                      I      .        I
C                      I.......        I
C                      I               I
C   4*************** (SI9) ************I************************* )
C   4                  I               I                          )
C        ETC. (LAYER 3 = LAYER 4 = LAYER 5 = ... )
C
C
C
C
C  NOTE - FOR ASB(1) THE SMALLEST PLANNED LAYER SPACING SHOULD BE INPUT
C         (ASB(1) WILL ONLY BE USED IN THE BEAM-SELECTION CRITERION).
C
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASW(3),AS1(3),AS2(3)
      DIMENSION FPOS1(5,4,3),FPOS2(5,4,3),FPOS3(4,3),
     1ASB1(5,3),STEP1(1,15,3),NSTEP1(5),
     1ASB2(5,3),STEP2(1,5,3),NSTEP2(5)
C  1=NL, 45=KLM
      COMPLEX VL(1,2),FLMS(1,45),FLM(45)
C  1(1ST DIMENSION)=NL=NL1*NL2, 2(2ND DIMENSION)=IDEG
      DIMENSION V(1,2),JJS(1,2)
C  1=KNBS=NO. OF BEAM SETS READ IN, 67=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(1),NB(1),SPQF(2,67),SPQ(2,67),PQF(2,67),PQ(2,67)
      INTEGER KSYM(2,67),SYM(2,67)
C  109 MUST BE .GE. NPUN
      DIMENSION NPU(109),NPUC(109)
C  13=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(13),PHSS(13,10)
C  4=NLAY, VPOS NOT USED, 12 FIXED, 759 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(1,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20),POS(4,3)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),YLM( 81),FAC2( 81),FAC1( 9)
      DIMENSION CLM( 809)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),CAF1(5),TSF0(6,10),TSF(6,10)
      COMPLEX R1P(67,67),T1P(67,67),R1M(67,67),T1M(67,67)
      COMPLEX R2P(67,67),T2P(67,67),R2M(67,67),T2M(67,67)
      COMPLEX R3P(67,67),T3P(67,67),R3M(67,67),T3M(67,67)
C  25=LMT, 15=LEV, 300(IN GH)=LMG, 4=NLAY, 100(IN TS)=LMN, 200=LM2N
C  1(IN TH, IPL)=LMNI
      COMPLEX TAU(25,15),TAUG(25),TAUGM(25),GH(300,25),RG(3,4,67),
     1TS(100),TG(2,200),VT(200),TH(1,1)
      DIMENSION IPL(1)
C  15=LEV, 10=LOD
      COMPLEX AMULT(67),CYLM(67,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(67)
C  10 FIXED (FOR RFT2V3), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(67),PK(67,10),AW(67,2),ANEW(67,20)
C  ****  FOR CDC ONLY  **********
C     LEVEL 2, GH,TH,TAU,XEV,XOD,R1P,T1P,R1M,T1M,R2P,T2P,R2M,T2M,
C    1R3P,T3P,R3M,T3M
C     COMMON/BIG/  GH,TH,TAU,XEV,XOD,R1P,T1P,R1M,T1M,R2P,T2P,R2M,T2M,
C    1R3P,T3P,R3M,T3M
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  160 FORMAT(3F7.4)
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG - EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1 NL2 -      LATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYERS
      READ(5,200)NLAY
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYERS
      CALL READCL(NLAY,NLAY2,FPOS3,VPOS,NVAR,NTAU,LPS,NINV,INV,
     1LMMAX,LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
C  ADDITIONAL INPUT OF GEOMETRICAL VARIABLES
      READ(5,200) NII1,NII2
      WRITE(6,200) NII1,NII2
      DO 481 II = 1,NII1
      READ(5,160) (ASB1(II,J),J =1,3)
 481  WRITE(6,160) (ASB1(II,J),J =1,3)
      DO 4811 II=1,NII2
      READ(5,160)(ASB2(II,J),J=1,3)
 4811 WRITE(6,160)(ASB2(II,J),J=1,3)
      DO 482 J = 1,3
      DO 482 II = 1,NII1
 482  ASB1(II,J) = ASB1(II,J)/0.529
      DO 4821 II=1,NII2
      DO 4821 J=1,3
 4821 ASB2(II,J)=ASB2(II,J)/0.529
      READ(5,200)(NSTEP1(II),II=1,NII1)
      WRITE(6,200)(NSTEP1(II),II=1,NII1)
      READ(5,200)(NSTEP2(II),II=1,NII2)
      WRITE(6,200)(NSTEP2(II),II=1,NII2)
      DO 483 II = 1,NII1
      NSTPD=NSTEP1(II)
      DO 484 NN = 1,NSTPD
      READ(5,160)(STEP1(II,NN,J),J =1,3)
 484  WRITE(6,160)(STEP1(II,NN,J),J =1,3)
      DO 485 NN = 1,NSTPD
      DO 485 J = 1,3
 485  STEP1(II,NN,J) = STEP1(II,NN,J)/0.529
 483  CONTINUE
      DO 4831 II=1,NII2
      NSTPD=NSTEP2(II)
      DO 4841 NN=1,NSTPD
      READ(5,160)(STEP2(II,NN,J),J=1,3)
 4841 WRITE(6,160)(STEP2(II,NN,J),J=1,3)
      DO 4851 NN=1,NSTPD
      DO 4851 J=1,3
 4851 STEP2(II,NN,J)=STEP2(II,NN,J)/0.529
 4831 CONTINUE
      DO 561 II =1,NII1
      DO 562 I = 1,NLAY
      READ(5,160)(FPOS1(II,I,J),J=1,3)
 562  WRITE(6,160)(FPOS1(II,I,J),J=1,3)
      DO 563 I = 1,NLAY
      DO 563 J = 1,3
 563  FPOS1(II,I,J)=FPOS1(II,I,J)/0.529
 561  CONTINUE
      DO 5611 II=1,NII2
      DO 5621 I=1,NLAY
      READ(5,160)(FPOS2(II,I,J),J=1,3)
 5621 WRITE(6,160)(FPOS2(II,I,J),J=1,3)
      DO 5631 I=1,NLAY
      DO 5631 J=1,3
 5631 FPOS2(II,I,J)=FPOS2(II,I,J)/0.529
 5611 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM - PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      E = EC
      E3 = E
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FROM PHASE SHIFTS, CORRECTED FOR
C  THERMAL VIBRATION (CAF AND TSF) OR NOT (AF AND TSF0). AF AND CAF
C  ARE USED FOR BRAVAIS-LATTICE LAYERS. TSF0 AND TSF ARE USED FOR
C  COMPOSITE LAYERS.
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C  PERFORM BRAVAIS-LATTICE SUM IN FMAT.
      CALL  FMAT (FLMS, V, JJS, NL, NL, DCUTO, IDEG, LMAX,KLM)
C
C
C  SET PARAMETERS FOR SUBSTRATE LAYERS (LAY=2 FOR SUBSTRATE
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=2
      TV1=TVA
      DCUT=DCUTS
      EPSN=0.001
      NPERT=8
      NOPT=1
      NEW=1
      VPI1=VPIS
C  PRINT INTERNAL GEOMETRY (A.U.)
      CALL RMPRT(FPOS3,NLAY,3,9HFPOS3(AU))
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR SUBSTRATE LAYERS
      CALL MPERTI(R3P,T3P,R3M,T3M,R3P,T3P,R3M,T3M,R3P,T3P,R3M,T3M,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,
     3CLM,NLM,FPOS3,POSS,
     4MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     5GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,LMNI2)
      WRITE(6,415)
C
C
C  SET PARAMETERS FOR TOP TWO LAYERS
      DCUT=DCUTO
      NA=0
      NS=0
      ID=1
      LAY=1
      EPSN=0.001
      NPERT=8
      NOPT=1
      NEW=-1
      GEOM=1.
C
C
C  START LOOP OVER INTERNAL STRUCTURE OF 2ND LAYER
      DO 962 II2= 1,NII2
      DO 940 I=1,NLAY
      DO 940 J=1,3
  940 POS(I,J)=FPOS2(II2,I,J)
      CALL RMPRT(POS,NLAY,3,9HFPOS2(AU))
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR 2ND LAYER
      CALL MPERTI(R2P,T2P,R2M,T2M,R2P,T2P,R2M,T2M,R2P,T2P,R2M,T2M,
     1 NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,
     2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,
     3CLM,NLM,POS,POSS,MGH,NLAY,DRL,SDRL,NUGH,NGEQ,
     4NGOL,NLAY2,TEST,GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,
     5LMNI,LMNI2)
      WRITE(6,415)
C
C
C  START LOOP OVER INTERNAL SRUCTURE OF TOP LAYER
      DO 9621 II1=1,NII1
      DO 9401 IX=1,NLAY
      DO 9401 J=1,3
 9401 POS(IX,J)=FPOS1(II1,IX,J)
      CALL RMPRT(POS,NLAY,3,9HFPOS1(AU))
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR TOP LAYER
      CALL MPERTI(R1P,T1P,R1M,T1M,R1P,T1P,R1M,T1M,R1P,T1P,R1M,T1M,
     1NT,NT,NT,AMULT,
     2CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,KLM,XEV,LEV,
     3LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,POS,POSS,MGH,NLAY,DRL,
     4SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,GH,LMG,RG,TS,LMN,TG,
     5LM2N,VT,CAA,NCAA,TH,LMNI,LMNI2)
      WRITE(6,415)
      NEW=-1
C
C
C  START LOOP OVER 2ND INTERLAYER VECTOR
      NSTPD=NSTEP2(II2)
      DO 960 IS2=1,NSTPD
      DO 961 J = 1,3
      AS2(J) = ASB2(II2,J)+STEP2(II2,IS2,J)
961   AS(J)=AS2(J)*0.529
      WRITE(6,430)AS
C
C
C  START LOOP OVER TOP INTERLAYER VECTOR
      DO 9601 IS1=1,NSTPDT
      NSTPDT=NSTEP1(II1)
      DO 9611 J=1,3
      AS1(J)=ASB1(II1,J)+STEP1(II1,IS1,J)
9611  AS(J)=AS1(J)*0.529
      WRITE(6,430)AS
C  COMPUTE REFLECTED BEAM AMPLITUDES (XI) BY RFS
      CALL RFT2V3(R1P,T1P,R1M,T1M,R2P,T2P,R2M,T2M,R3P,T3P,R3M,T3M,
     1R3P,T3P,R3M,T3M,R3P,T3P,R3M,T3M,
     2NT,NB,KNBS,NP,XI,PQ,PK,AW,ANEW,20,AS1,AS2,ASA,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH GEOM. NO. GEOM ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,GEOM,1)
C
C
C  ENDS OF STRUCTURE, TEMPERATURE AND ENERGY LOOPS
      GEOM=GEOM+1.
 9601 CONTINUE
 960  CONTINUE
 9621 CONTINUE
 962  CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 SI(111)(2X1),NORTHRUP,AS (1X1),TOP 2 LAY.VAR,5PS,NO SYMM,RSP+RFS
  2  1  1               IDEG NL1 NL2
  1 67 17               KNBS KNT NPUN
 13                     NPSI
 3.8396 0.0000          ARA1
 0.0000 6.6503          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.3500 1.9198-1.1035   ASA
 3.8396 0.0000          ARB1
 0.0000 6.6503          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 2.0000 0.0000 0.0000   ASB
 0.5000 1.1700 0.1000   FR ASE STEP
  1                     NSTEP
 39                     KNB(1)
 0.0000 0.0000  1  1    BEAMS
 0.0000 1.0000  1  1
 0.0000-1.0000  1  1
 1.0000 0.0000  1  1
-1.0000 0.0000  1  1
 1.0000 1.0000  1  1
-1.0000 1.0000  1  1
 1.0000-1.0000  1  1
-1.0000-1.0000  1  1
 0.0000 2.0000  1  1
 0.0000-2.0000  1  1
 2.0000 0.0000  1  1
-2.0000 0.0000  1  1
 1.0000 2.0000  1  1
-1.0000 2.0000  1  1
 1.0000-2.0000  1  1
-1.0000-2.0000  1  1
 2.0000 1.0000  1  1
-2.0000 1.0000  1  1
 2.0000-1.0000  1  1
-2.0000-1.0000  1  1
 0.0000 3.0000  1  1
 0.0000-3.0000  1  1
 2.0000 2.0000  1  1
-2.0000 2.0000  1  1
 2.0000-2.0000  1  1
-2.0000-2.0000  1  1
 1.0000 3.0000  1  1
-1.0000 3.0000  1  1
 1.0000-3.0000  1  1
-1.0000-3.0000  1  1
 3.0000 0.0000  1  1
-3.0000 0.0000  1  1
 3.0000 1.0000  1  1
-3.0000 1.0000  1  1
 3.0000-1.0000  1  1
-3.0000-1.0000  1  1
 0.0000 4.0000  1  1
 0.0000-4.0000  1  1
 2.0000 3.0000  1  1
-2.0000 3.0000  1  1
 2.0000-3.0000  1  1
-2.0000-3.0000  1  1
 1.0000 4.0000  1  1
-1.0000 4.0000  1  1
 1.0000-4.0000  1  1
-1.0000-4.0000  1  1
 0.0000 5.0000  1  1
 0.0000-5.0000  1  1
 1.0000 5.0000  1  1
-1.0000 5.0000  1  1
 1.0000-5.0000  1  1
-1.0000-5.0000  1  1
 2.0000 4.0000  1  1
-2.0000 4.0000  1  1
 2.0000-4.0000  1  1
-2.0000-4.0000  1  1
 3.0000 2.0000  1  1
-3.0000 2.0000  1  1
 3.0000-2.0000  1  1
-3.0000-2.0000  1  1
 3.0000 3.0000  1  1
-3.0000 3.0000  1  1
 3.0000-3.0000  1  1
-3.0000-3.0000  1  1
 4.0000 0.0000  1  1
-4.0000 0.0000  1  1
 0.0080                 TST
  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17      NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 464.3500  28.0800   1.0000   1.0000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
 0.3676
  .5618  .6375  .0717  .0022  .0001  .0000  .0000  .0000  .0000  .0000  SI
 
 0.5515
  .3361  .7678  .1921  .0081  .0004  .0000  .0000  .0000  .0000  .0000
 
 0.7353
  .1549  .7848  .3740  .0197  .0012  .0001  .0000  .0000  .0000  .0000
 
 1.1029
 -.1283  .7073  .7890  .0649  .0058  .0004  .0000  .0000  .0000  .0000
 
 1.4706
 -.3441  .5980 1.0566  .1401  .0166  .0016  .0001  .0000  .0000  .0000
 
 2.0221
 -.5885  .4483 1.2243  .2874  .0490  .0066  .0007  .0001  .0000  .0000
 
 2.9412
 -.8709  .2678 1.3382  .4995  .1436  .0297  .0047  .0006  .0001  .0000
 
 4.0441
-1.1097  .1241 1.4315  .6247  .2731  .0865  .0200  .0036  .0005  .0001
 
 5.1471
-1.3027  .0075 1.4781  .6936  .3621  .1599  .0511  .0122  .0023  .0003
 
 6.0662
-1.4426 -.0812 1.4908  .7440  .4063  .2147  .0867  .0258  .0059  .0011
 
 6.9853
-1.5654 -.1607 1.4967  .7881  .4388  .2556  .1249  .0455  .0125  .0027
 
 8.0882
-1.6915 -.2414 1.5042  .8265  .4749  .2888  .1658  .0746  .0253  .0066
 
 9.0074
-1.7818 -.2976 1.5104  .8473  .5043  .3095  .1922  .1002  .0397  .0121
 
  4                     NLAY
 0.0000 0.0000 0.0000   FPOS3(1,J)
 0.2010-1.9198 3.2848   FPOS3(2,J)
 0.8734 0.0000 2.2032   FPOS3(3,J)
 0.8734-1.9198-1.1208   FPOS3(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  1                     NTAU
  1  1  1  1            LPS
  0                     NINV
  0  0  0  0            INV
  1  1                  NII1  NII2
 2.1630 0.0000-1.1960   ASB1
 2.0965 0.0000 2.3165   ASB2
 15                     NSTEP1
  1                     NSTEP2
 -.0500 0.0000 -.2000   STEP1
 -.0500 0.0000 -.1000   STEP1
 -.0500 0.0000 0.0000   STEP1
 -.0500 0.0000 0.1000   STEP1
 -.0500 0.0000 0.2000   STEP1
 0.0000 0.0000 -.2000   STEP1
-0.0000 0.0000 -.1000   STEP1
-0.0000 0.0000 0.0000   STEP1
 0.0000 0.0000 0.1000   STEP1
-0.0000 0.0000 0.2000   STEP1
 0.0500 0.0000 -.2000   STEP1
 0.0500 0.0000 -.1000   STEP1
 0.0500 0.0000 0.0000   STEP1
 0.0500 0.0000 0.1000   STEP1
 0.0500 0.0000 0.2000   STEP1
-0.0000 0.0000 0.0000   STEP2
 0.000  0.000  0.000    FPOS1
 0.0979-1.9198 1.1357   FPOS1
 1.0572 0.000 -2.0777   FPOS1
 1.0043-1.9198 3.2244   FPOS1
 0.0778 0.0000 0.000    FPOS2
 0.0000-1.9198 3.4827   FPOS2
 0.6549 0.000  2.3112   FPOS2
 0.9565-1.9198-1.0256   FPOS2
  30.00  31.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C  --- M4.3.1
C
	PROGRAM RES22S
C  GH/11.02.91
C  LMAX = 7
C  KNT = 60
C  NPSI = 26
C
C  MAIN FOR RE(001)+(2*2)S, RFS, 3-FOLD ROT. SYMM., (XZ) MIRROR PL.
C
C  Main LEED program for a p(2*2)- overlayer on a hcp(001) surface. The
C  axis through the 1st layer atoms is assumed to be a rotational axis
C  in which all interlayer-vectors have to lie.
C
C  The (x-)distances adsorbate - 1st layer (DA1), 1st layer - 2nd layer 
C  (D12) and 2nd layer - 3rd layer (D23) are variable. The x-components
C  of these interlayer vectors are stored in the array asnp, their y/z-
C  components are read from SO1/2/3. 
C  The bulk interlayer vectors (input: ASA) are passed to the RFS sub-
C  routine via asp.
C
C  The first and second substrate layer allow to be buckled (matrices 
C  R/TOP/M(2/3)). From the 3rd substrate layer on the atoms are assumed 
C  to form single Bravais lattices (RB,TB). 
C  The adsorbate layer matrices are stored in ROP/M(1) and TOP/M(1)
C
C
C  Stacking:
C
C     overlayer       ROP/M(1) +++++++++++++++++++  --> SO1  (z -->)
C                                                   | ASNP(1) (DA1)
C     1st layer (t)   ROP/M(2) ===================  .   SO2 
C                                                   | ASNP(2) (D12)
C     2nd layer       ROP/M(3) ===================  --> SO3
C                                                   | ASNP(3) (D23)
C     3rd layer       RB(1) ======================  .   SS1
C                                                   | ASP(1)  (ASA)
C     4th layer       RB(2) ======================  --> SS2
C                                                   | ASP(2)  (ASA)
C     5th layer       RB(1) ======================  --> SS1
C
C  RFS is used to stack layers (RFSG).
C
C  Different adsorbate sites (registries):
C
C        hcp:                       fcc:
C       top hcp fcc                top hcp fcc top
C            
C            * SO1 = (0,0)                  * SO1 = (0,0)
C            |                              |
C            |ASNP(1) (DA1)                 |ASNP(1) (DA1)
C      (FPOS)|                     (FPOS)   |
C        * ^   SO2 = (0,0)          *  ^ ---> SO2 = (-1/3,1/3) (origin of
C            |                              |        unit c. is hcp site)
C            |ASNP(1) (D12)                 |ASNP(1) (D12)
C            |                              |
C            * SO3 = (0,0)              *---> SO3 = (-1/3,1/3)      (hcp)
C            |                              |
C            |ASNP(1) (D23)                 |ASNP(1) (D23)
C            |                              |
C        *---> SS1 = (-1/3,1/3)             <---* SS1 = (1/3,-1/3)  (top)
C            |                              |
C            |ASP(1)  (ASA)                 |ASP(1)  (ASA)
C            |                              |
C            * SS2 = (0,0)              *---> SS2 = (-1/3,1/3)      (hcp)
C            |                              |
C            |ASP(2)  (ASA)                 |ASP(2)  (ASA)
C            |                              |
C        *---> SS1 = (-1/3,1/3)             <---* SS1 = (1/3,-1/3)  (top)
C
C             ----------->  z-axis           ----------->  z-axis   
C            |                              |
C            | rotational axis (x)          | rotational axis (x)
C            |                              |
C
C  Labelling of atoms in first layer unit cell:
C
C                                  h (ARB2)   
C                                             
C                                  *(2)       
C                                             
C                                             
C                              *(1)    *(4)   
C                    (0,0)>h___|dz         h  
C                           dy                
C                                  *(3)       
C                                             
C                                             
C                                             
C                                  h (ARB1)   
C
C      h: corners of (2*2)unit cell (hcp site)
C      *: atoms in 1st layer (top site)
C
C      dy = a/2          = 1.3800 A
C      dz = a/(2*sqrt(3))= 0.7967 A
C
C      Re, no lateral distortion:
C      FPOST(1): dx1, 1.3800, 0.7967
C      FPOST(2): dx2, 2.7600, 3.1870
C      FPOST(3): dx3, 2.7600,-1.5935
C      FPOST(4): dx4, 4.1400, 0.7967
C
C      Changing positions of atoms in the unit cell (labels 900 - 1000):
C      In hcp - case: dx1 = dx2 = dx4
C               IATOMT=1: The dislocation vector for atom 2 is read in
C                        through VPOST. From this vector the move-
C                        ment for atoms 1 and 4 is calculated accor-
C                        ding to 3-fold symmetry.
C               IATOMT=3: Only dislocation vector for atom 3 is read in
C                        through VPOST. Atoms 1,2 and 4 remain unchanged.
C      In fcc - case: dx1 = dx3 = dx4
C               IATOMT=2: Only dislocation vector for atom 2 is read in
C                        through VPOST. Atoms 1,3 and 4 remain unchanged.
C               IATOMT=4: The dislocation vector for atom 3 is read in
C                        through VPOST. From this vector the move-
C                        ment for atoms 1 and 4 is calculated accor-
C                        ding to 3-fold symmetry.
C
C
C  Labelling of atoms in second layer unit cell:
C
C                                  + (ARB2)   
C                                             
C                                  *          
C                              +(2)    +      
C                                             
C                              *       *      
C                    (0,0)>+(1)    +(4)    +  
C                                             
C                          *       *       *  
C                              +(3)    +      
C                                             
C                              *       *      
C                                  + (ARB1)   
C
C
C      +: atoms in 2nd layer, i.e. corners of (2*2)unit cell and
C         hcp site of first layer
C      *: atoms in 1st layer (top site)
C
C
C      Re, no lateral distortion:
C      FPOSS(1): dx1, 0.0000, 0.0000
C      FPOSS(2): dx2, 1.3800, 2.3903
C      FPOSS(3): dx3, 1.3800,-2.3903
C      FPOSS(4): dx4, 2.7600, 0.0000
C
C      Changing positions of atoms in the unit cell (labels 1000 - 1100):
C      In hcp - case: dx2 = dx3 = dx4
C               IATOMS=1: Only dislocation vector for atom 1 is read in
C                        through VPOSS. Atoms 2,3 and 4 remain unchanged.
C               IATOMS=2: From 3-fold symmetry and llateral invariance,
C                        the dislocation vector for atoms 2,3 and 4 may
C                        only have a vertical component. This is read in
C                        through VPOSS for all three atoms.
C      In fcc - case: dx1 = dx2 = dx3
C               IATOMS=3: The dislocation vector for atom 1 is read in
C                        through VPOSS. From this vector the move-
C                        ment for atoms 2 and 3 is calculated accor-
C                        ding to 3-fold symmetry.
C               IATOMS=4: Only dislocation vector for atom 4 is read in
C                        through VPOSS. Atoms 1,2 and 3 remain unchanged.
C
C
C  Input:   res22sl.dnow(unit 5)
C  Output:  res22sl.res (unit 7)  beam intensities (results)
C           res22sl.out (unit 6)  protocoll output (most of the controll
C                                 output is suppressed by using MTINV0,
C                                 RINT0 and RFN- routines)
C           res22sl.geo (unit 10) geometry parameters 
C
C======================================================================
C
C  NL = NO OF SUBLAYERS NL = NL1*NL2
	PARAMETER(JNL=4)
C  IDEG = LOWEST SYMMETRY OF ALL LAYERS
	PARAMETER(JIDEG=3)
C  KNBS = NO OF BEAM SETS
	PARAMETER(JKNBS=2)
C  KNT=NO. OF BEAMS READ IN
	PARAMETER(JKNT=60)
C  NPUN=NO. OF BEAMS PUNCHED OUT
	PARAMETER(JNPUN=25)
C  NPSI= NO. OF ENERGY POINTS
	PARAMETER(JNPSI=26)
C  NEL = NO OF ELEMENTS FOR WHICH PHASE SHIFTS ARE READ IN
	PARAMETER(JNEL=2)
C  NTAU
	PARAMETER(JNTAU=3)
C  nlay = max. No of layers in composite layer 
C  (4 in substrat layers)
	PARAMETER(JNLAY=4)
C
C  ==========
C  LMAX-DEPENDING PARAMETERS
	PARAMETER(JLMAX=7)
C  NLM FROM DATA STATEMENT (lmax = 7)(7680)
	PARAMETER(JNLM=7680)
C  ncaa from data statement (lmax = 7)(7344)
        PARAMETER(JNCAA=7344)
C
	PARAMETER(JN=2*JLMAX+1)
	PARAMETER(JNN=JN*JN)
	PARAMETER(JKLM=JN*(JN+1)/2)
	PARAMETER(JL1=JLMAX+1)
	PARAMETER(JLMMAX=JL1*JL1)
	PARAMETER(JLEV=JL1*(JL1+1)/2)
	PARAMETER(JLOD=JLMMAX-JLEV)
	PARAMETER(JN1=2*JL1-1)
	PARAMETER(JN2=JL1,JN3=JL1)
C  parameters additionaly used for mtinv arrays
        PARAMETER(jlev2=2*jlev)
	PARAMETER(jnlay2= jnlay*(jnlay-1)/2)
	PARAMETER(jlmg=2*jnlay2*jlmmax)
	PARAMETER(jlmn = jnlay*jlmmax)
	PARAMETER(jlmni = jnlay*jlmmax)
	PARAMETER(jlm2n = 2*jlmn)
	PARAMETER(jlmt = jntau * jlmmax)
C
C  ==========
C  parameters used to define arrays for rfs(n)g
C  nd = deepest penetration in rfs (2nd dimension of anew)
        PARAMETER(jnd = 25)
C  mnp = number of layers in nonperiodic region (surface region)
        PARAMETER(jmnp = 3)
C  mp = number of layers in periodic region (bulk region)
        PARAMETER(jmp = 2)
C  mo = number of diffraction matrices different from bulklayers
        PARAMETER(jmo = 3)
C  ms = number of different matrices related to bulk layers
        PARAMETER(jms = 2)
C
        PARAMETER(jmnpp = 2*(jmnp + jmp + 1))
C======================================================================
C  declarations
C  real and reziprocal vectors
      REAL ARA1(2),ARA2(2),RAR1(2),RAR2(2),
     &     ARB1(2),ARB2(2),RBR1(2),RBR2(2),
     &     ss1(2),ss2(2),ss3(2),ss4(2),SO1(2),SO2(2),SO3(2),
     &     asa(3),asb(3),as(3),ASV(3),AS1(3),AS2(3),
     &     da1(3),da1x,da1z,d12(3),d12x,d23(3),d23x,
     &     REGA(2),REG1(2),REG2(2)
C 
C  4=JNL, 91=KLM
      COMPLEX VL(JNL,2),FLMS(JNL,JKLM),FLM(JKLM)
C  4=JNL, 3=JIDEG
      DIMENSION V(JNL,2),JJS(JNL,JIDEG)
C  2=KNBS=NO. OF BEAM SETS READ IN, 21=JKNT=NO. OF BEAMS READ IN
      DIMENSION KNB(JKNBS),NB(JKNBS),SPQF(2,JKNT),
     1          SPQ(2,JKNT),PQF(2,JKNT),PQ(2,JKNT)
      INTEGER KSYM(2,JKNT),SYM(2,JKNT)
C  JNPUN MUST BE .GE. NPUN
      DIMENSION NPU(JNPUN),NPUC(JNPUN)
C  13=JNPSI
C  30 (2nd dim. of PHSS) fixed in READIN and TSCATF
C     must be .gt. jnel*jl1
      DIMENSION ES(JNPSI),PHSS(JNPSI,30)
C  VPOS DECLARED AT THE BEGINNING
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(JNLM),YLM(JNN),FAC2(JNN),FAC1(JN)
C  15=NN1, 7=NN2=JL1, 7=NN3=JL1
      DIMENSION PPP(JN1,JN2,JN3)
C  49=LMMAX
      DIMENSION LX(JLMMAX),LXI(JLMMAX),LXM(JLMMAX),LT(JLMMAX)
C  FIX TSF(0) (6,10) IF COMMON BLOCK /MPT/ IS USED 
C  then: 6.gt.ntau; 10.gt.lmax+1
      COMPLEX AF(JL1),CAF(JL1),TSF0(6,10),TSF(6,10)
C
C  ==========
C
C  diffraction matrices (and arrays of matrices for rfs(n)g)
C  ro : array of overlayer matrices (JMO = 3); 
C  rb : array of bulk matrices (JMS = 2); 
C  ra : storage; 
      COMPLEX ROM(JKNT,JKNT,JMO),TOM(JKNT,JKNT,JMO)
      COMPLEX ROP(JKNT,JKNT,JMO),TOP(JKNT,JKNT,JMO)
      COMPLEX RB(JKNT,JKNT,JMS),TB(JKNT,JKNT,JMS)
      COMPLEX RAP(JKNT,JKNT),TAP(JKNT,JKNT)
      COMPLEX RAM(JKNT,JKNT),TAM(JKNT,JKNT)
C
C  storage for msmf and mtinv
C  2nd dimension of xev changed for mtinv
C  28=JLEV, 21=JLOD
      COMPLEX AMULT(JKNT),CYLM(JKNT,JLMMAX),
     &        XEV(JLEV,JLEV2),XOD(JLOD,JLOD),
     &        YLME(JLEV),YLMO(JLOD)
      DIMENSION IPLE(JLEV),IPLO(JLOD),AT(JKNT)
C
C  following arrays are used for mtinv only
      COMPLEX tau(jlmt,jlev),taug(jlmt),taugm(jlmt)
      COMPLEX gh(jlmg,jlmmax),rg(3,jnlay,jknt)
      COMPLEX ts(jlmn),tg(2,jlm2n),vt(jlm2n)
      COMPLEX th(jlmni,jlmni)
      REAL posst(jnlay,3)
      INTEGER mgh(jnlay,jnlay),ipl(jlmni)
      INTEGER nugh(jnlay2), ngeq(jnlay2), ngol(jnlay2)
      REAL drl(jnlay2,3),sdrl(jnlay2,3), test(jnlay2)
C
C  Specific for call 't' of mtinv:
C  20 in vpos and lps according to subr. readcl
C  amult, cylm, gh,tau and th must not be overwritten, when NEW = -1
      COMPLEX amultt(jknt),cylmt(jknt,jlmmax)
      COMPLEX ght(jlmg,jlmmax), taut(jlmt,jlev), tht(jlmni,jlmni)
      REAL post(jnlay,3),fpost(jnlay,3),vpost(20,3)
      INTEGER lpst(20)
C
C  Specific for call 's' of mtinv (second substr. layer):
C  20 in vpos and lps according to subr. readcl
C  amult, cylm, gh,tau and th must not be overwritten, when NEW = -1
      COMPLEX amults(jknt),cylms(jknt,jlmmax)
      COMPLEX ghs(jlmg,jlmmax), taus(jlmt,jlev), ths(jlmni,jlmni)
      REAL poss(jnlay,3),fposs(jnlay,3),vposs(20,3)
      INTEGER lpss(20)
C
C  used in caaa and mtinv:
      dimension caa(jncaa),nca(7)
C
C  arrays used in RFS(N)G subroutine
      COMPLEX XI(JKNT),PK(JKNT,JMNPP),AW(JKNT,2),ANEW(JKNT,JND)
      REAL ASNP(3,JMNP), ASP(3,JMP)
      INTEGER NRTNP(JMNP), NRTP(JMP)
C
C  in common block /mpt/ (inv not used)
      dimension inv(20)
      dimension lps(20),lpsst(20)
C  following arrays are necessary for common block /nst/ in subr readcl
      dimension asi(3,10),stps(3,10,2),nsts(10,2)	
C TITLE FROM INPUT FILE      
	CHARACTER*80 TEXT
C======================================================================
C
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2              1560
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV                         1600
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
C  used in mtinv
      common /mpt/na,ns,id,lay,l1,ntau,tsts,tv1,dcut,epsn,npert,
     &            nopt,
     &            NEW,lps,lpsst,inv,ninv,tsf
C  used in readcl
	common /nst/ nst1,asi,stps,nsts,nacv
	common /zmat/ ianz(40),iz(40,4),bl(40),alpha(40),beta(40),nz,
     &	              ipar(15,5),nipar(5),npar,dx(5),num,natoms,iscan,
     &                bls(40),alphas(40),betas(40),phir,phim1,phim2
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     1     0,      76,     284,    809,    1925,   4032,   7680/
C  nca is dimension of caa as function of lmax
      data nca(1),nca(2),nca(3),nca(4),nca(5),nca(6),nca(7)/
     &     1,     70,    264,   759,   1820,  3836,  7344/
C
C======================================================================
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)                    1760
  250 FORMAT(' USED OL - SUB. DIST. : ASV = ',3F7.4)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)                        1910
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =    1920
     1 ,F9.4)                                                               1930
  390 FORMAT(8H0TEMP = ,F9.4)                                               1940
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)                                                 1970
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)                                       2000
  460 FORMAT(20A4)
  461 FORMAT(1A80)
  465 FORMAT(1H1,20A4)
  466 FORMAT(1H1,1A80)
C======================================================================
C  OPEN STATEMENTS
C
	OPEN (UNIT= 5,FILE='res22sl.dnow',STATUS='OLD')
  	OPEN (UNIT= 6,FILE='/usr/photon/georg/res22sl.out',
     &        STATUS='UNKNOWN')
	OPEN (UNIT= 7,FILE='/usr/photon/georg/res22sl.res',
     &        STATUS='UNKNOWN')
	OPEN (UNIT=10,FILE='res22sl.geo',STATUS='UNKNOWN')
C======================================================================
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,461)TEXT
      WRITE(6,466)TEXT
      WRITE(7,466)TEXT
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  ============================================
C  read in additional data for composite layers
C  first set up parameters for not using geomv
      iscan = 0
      nst1 = 0
C  read parameters of top substrate layer (index t)
C  nlayt = No of subplanes in composite top substrate layer 
C  (0, if no comp.layer)
      read(5,200)nlayt,iatomt
      call readcl(nlayt,nlay2t,fpost,vpost,nvart,ntaut,lpst,ninvt,inv,
     &            lmmax,lmgt,lmnt,lm2nt,lmtt,ltaugt,lmnit,lmni2t)
C  Array dimensions used for MTINV (call 't').
      lmnit = nlayt*lmmax
      lmni2t = lmnit
      ninvt = nlayt
C
C  read parameters of 2nd substrate layer (index s)
C  nlays = No of subplanes in composite 2nd substrate layer 
C  (0, if no comp.layer)
      read(5,200)nlays,iatoms
      call readcl(nlays,nlay2s,fposs,vposs,nvars,ntaus,lpss,ninvs,inv,
     &            lmmax,lmgs,lmns,lm2ns,lmts,ltaugs,lmnis,lmni2s)
C  Array dimensions used for MTINV (call 's').
      lmnis = nlays*lmmax
      lmni2s = lmnis
      ninvs = nlays
C
C  Array dimensions used for MSMF.
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
C  ============================================
C  Read in additional parameters to control geometry loops: 
C
 530  format (3f7.4)
 532  format (1i3,1f7.4)
 534  format (2x,1a3,':',2x,'START:',3f7.4/
     &                   8x,'STEP :',1f7.4/
     &                   8x,'NSTEP:',i3)
 536  format (2x,1a3,':',2x,'START:',3f7.4/
     &                   8x,'X-STEP :',1f7.4,2x,'Z-STEP :'1f7.4/
     &                   8x,'X-NSTEP:',i3,   6x,'Z-NSTEP:'i3)
C
C  DA1: position of top-layer (1st atom) with respect to adsorbate layer
      read(5,530)(da1(j),j=1,3)
      read(5,532)nstpa1,stepa1
      write(6,534)'DA1',(da1(j),j=1,3),stepa1,nstpa1
      write(10,534)'DA1',(da1(j),j=1,3),stepa1,nstpa1
      DO 540 IC = 1,3
 540     da1(IC) = da1(IC)/0.529
      da1x = da1(1)
      stepa1 = stepa1/0.529
C
C  D12: position of 2nd layer with respect to top layer (projection of
C       first atom into bottom-most sublayer)
      read(5,530)(d12(IC),IC=1,3)
      read(5,532)nstp12,step12
      write(6,534)'D12',(d12(IC),IC=1,3),step12,nstp12
      write(10,534)'D12',(d12(IC),IC=1,3),step12,nstp12
      DO 550 IC = 1,3
 550     d12(IC) = d12(IC)/0.529
      d12x = d12(1)
      step12 = step12/0.529
C
C  D23: position of 3rd layer with respect to 2nd layer (projection of
C       first atom into bottom-most sublayer)
      read(5,530)(d23(IC),IC=1,3)
      read(5,532)nstp23,step23
      write(6,534)'D23',(d23(IC),IC=1,3),step23,nstp23
      write(10,534)'D23',(d23(IC),IC=1,3),step23,nstp23
      DO 560 IC = 1,3
 560     d23(IC) = d23(IC)/0.529
      d23x = d23(1)
      step23 = step23/0.529
C
C  Set up arrays ASP (bulk interlayer vectors) and ASNP (interlayer
C  vectors for first layers) and convergence criterion, used in rf(n)sg
C  and save registry shifts:
C  REGA - adsorbate layer (from SO1)
C  REG1 - 1st substrate layer (from SO2)
C  REG2 - 2nd substrate layer (from SO3)
      CRIT = 0.003
      DO 570 IC = 1,3
         ASP(IC,1) = ASA(IC) 
         ASP(IC,2) = ASA(IC) 
         ASNP(IC,1) = DA1(IC) 
         ASNP(IC,2) = D12(IC) 
         ASNP(IC,3) = D23(IC)
 570  CONTINUE 
         WRITE(10,573)'D34',(ASP(IC,1)*0.529,IC=1,3)
         WRITE(10,573)'D45',(ASP(IC,2)*0.529,IC=1,3)
 573  FORMAT('  ',A4,' = ',3F7.4)
C
      DO 580 IC = 1,2
         REGA(IC) = SO1(IC)
         REG1(IC) = SO2(IC)
         REG2(IC) = SO3(IC)
 580  CONTINUE 
C======================================================================
C  Calculate different sets of Clebsch-Gordon coefficients
C  First set only needed for composite layers:
      IF((NLAYT + NLAYS).EQ.0) GOTO 630
	lev2 = 2*lev
	ncaa= nca(lmax)
C  CAA = Clebsch-Gordon coefficients for composite layer
      call caaa(caa,ncaa,lmmax)
C  CLM= Clebsch-Gordon coefficients for matrices X and TAU
  630 CONTINUE
      N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
C  PPP = Clebsch-Gordon coefficients for computation of temperature-
C  dependent phase shifts (scipped if not needed, i.e. all IT = 0)
      IF ((IT1+IT2+IT3).EQ.0) GOTO 650
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
      CALL  CPPP (PPP, NN1, NN2, NN3)                                       2960
C
C======================================================================
C
  650 CONTINUE
C
C  READ ENERGY RANGE AND STEP; IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
C
  680 READ (5,161)  EI, EF, DE                                              3120
      IF (EI)  2000, 690, 690                                               3130
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI                                                                3140
      EC = E                                                                3150
      E3 = E                                                                3160
	loop = 0
C======================================================================
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
C======================================================================
C
  700 EEV=(E-VV)*27.21
	loop = loop + 1
      WRITE (6,370)  E,EEV                                                  3170
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)                                                 3200
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO                               3230
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI                                                                3390
  780 continue
C     WRITE (6,390)  T                                                      3410
C
C
C======================================================================
C    OVERLAYER
C======================================================================
C  Calculate overlayer diffraction matices ROP/M(1) and TOP/M(1)
C
C  Produce atomic T-matrix elements for adatoms
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
      VPI=VPIO
      VPI1=VPIO
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
      IT=0
      TV=TVB
C  Perform planar lattice sums in FMAT.(used for overlayer and bulk
C  layers, since VPIO is the same as VPIS)
      CALL  FMAT (FLMS, V, JJS, NL, NL, DCUTO, IDEG, LMAX,KLM)          
C  Set parameters and registry for overlayer (lay = 1 for overlayer 
C  symmetries and  registry)
      SO1(1) = REGA(1)
      SO1(2) = REGA(2)
      ID =1
      LAY = 1
      CALL MSMF(RAP,TAP,RAP,TAP,RAP,TAP,RAP,TAP,NT,NT,NT,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL, 0, 0,ID,NLL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,LAY)
      WRITE (6,*) 'MSMF  OVER OK'
C  Write overlayer matrices at 1st position into R/TO- arrays;
C  used as 1st layer:
        CALL mkarr (rap,rop,nt,nt,jmo,1)
        CALL mkarr (tap,top,nt,nt,jmo,1)
        CALL mkarr (rap,rom,nt,nt,jmo,1)
        CALL mkarr (tap,tom,nt,nt,jmo,1)
        nrtnp(1) = 1
C       CALL SHOW (rap,nt,'over.rmat')
C       CALL SHOW (tap,nt,'over.tmat')
C  Set RAP/M and TAP/M to zero before they are used again.
      CALL CZERO (RAP,JKNT)
      CALL CZERO (TAP,JKNT)
      CALL CZERO (RAM,JKNT)
      CALL CZERO (TAM,JKNT)
C======================================================================
C    SUBSTRAT
C======================================================================
C  Calculate diffraction matrices for bulk layers (not changed for
C  any geometry)
C  PRODUCE ATOMIC T-MATRIX ELEMENTS
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      VPI = VPIS                                                            4070
      VPI1 = VPIS                                                           4080
C	
C  set parameters for unrumpled bulk layers
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA                                                              4060
C  Produce reflection (RB) and transmmission(TB) mmatrices for not buck-
C  led substrate layers. Two registries - ID =2. NLL = NL = 4 sublattices.
C  Substrate layer symmetries and registries apply - LAY = 2. Temperature 
C  dependent phase shifts - CAF.
      ID = 2
      LAY = 2
C  1st beam set (NAA beams)
      NAA = NB(1)                                                           4110
      CALL MSMF(RAP,TAP,RAM,TAM,RAP,TAP,RAP,TAP,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,ID,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,LAY)
      WRITE (6,*) 'MSMF  BULK1 OK'
C      CALL SHOW(RAP,NT,'bulk1.1mat')
C      CALL SHOW(RAM,NT,'bulk2.1mat')
C  2nd beam set next (NBB beams; note offsets:NA=NS=NAA)
      NBB=NB(2)
      CALL MSMF(RAP,TAP,RAM,TAM,RAP,TAP,RAP,TAP,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,ID,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,LAY)
      WRITE (6,*) 'MSMF  BULK2 OK'
C
C      CALL SHOW(RAP,NT,'bulk1.rmat')
C      CALL SHOW(RAM,NT,'bulk2.rmat')
C  RB/TB contains matrices for both bulk layers:
      NRTP(1) = 101
      CALL mkarr (RAP,RB,NT,NP,JMS,1)
      CALL mkarr (TAP,TB,NT,NP,JMS,1)
      NRTP(2) = 102
      CALL mkarr (RAM,RB,NT,NP,JMS,2)
      CALL mkarr (TAM,TB,NT,NP,JMS,2)
C  Set RAP/M and TAP/M to zero before they are used again.
      CALL CZERO (RAP,JKNT)
      CALL CZERO (TAP,JKNT)
      CALL CZERO (RAM,JKNT)
      CALL CZERO (TAM,JKNT)
C
      IGEO = 1
C======================================================================
C  L O O P  over different geometries
C======================================================================
C  Set NEW (optimisation) and IGEO (number of geometry) for first geometry
      NEW = 1
C  If IGEO > 1 (first layer matrices calculated more than once per energy 
C  point) NEW can be set to -1.
C======================================================================
C  TOPLAYER
C======================================================================
C  Loop 1600 over 1st layer buckling
      DO 1600 IVART = 1,NVART     
C  ==========================================
C  Write atom positions in top layer to POST.
C  ==========================================
C  In hcp - case atom No. 3 is independent from 1,2 and 4, in fcc - case 
C  atom No. 2 is independent from 1,3 and 4. IATOM = 2,3 means that only
C  the position of this independent atom is varied.
           IF ((IATOMT.EQ.2).OR.(IATOMT.EQ.3)) THEN
              DO 940 IL = 1,NLAYT
              DO 940 IC = 1,3
                 POST(IL,IC) = FPOST(IL,IC)
 940          CONTINUE
              DO 950 IC = 1,3
	         POST(IATOMT,IC) = FPOST(IATOMT,IC) + VPOST(IVART,IC)
 950          CONTINUE
           END IF
C
C  IATOM = 1: Move 3 correlated atoms(1,2,4) in hcp case 
	   IF (IATOMT.EQ.1) THEN
C          calculate lateral dislocation vector for atoms 1 and 4 from
C          VPOST(IATOM,*) according to 3-fold rotational symmetry.
C          VPOST(IATOM,*) is assumed to be the dislocation vector of atom 
C          No. 3. (POSST is here only used as storage space)
              POSST(1,1) =  VPOST(IVART,1) 
              POSST(1,2) = -0.5*VPOST(IVART,2) -0.8660254*VPOST(IVART,3) 
              POSST(1,3) =  0.8660254*VPOST(IVART,2) -0.5*VPOST(IVART,3) 
              POSST(2,1) =  VPOST(IVART,1) 
              POSST(2,2) =  VPOST(IVART,2) 
              POSST(2,3) =  VPOST(IVART,3) 
              POSST(3,1) =  0.0
              POSST(3,2) =  0.0
              POSST(3,3) =  0.0
              POSST(4,1) =  VPOST(IVART,1)
              POSST(4,2) = -0.5*VPOST(IVART,2) +0.8660254*VPOST(IVART,3) 
              POSST(4,3) = -0.8660254*VPOST(IVART,2) -0.5*VPOST(IVART,3) 
C
              DO 960 IL = 1,NLAYT
              DO 960 IC=1,3
                 POST(IL,IC) = FPOST(IL,IC) + POSST(IL,IC)
 960          CONTINUE
           END IF
C
C  IATOM = 4: Move 3 correlated atoms(1,3,4) in fcc case 
	   IF (IATOMT.EQ.4) THEN
C          calculate lateral dislocation vector for atoms 1 and 4 from
C          VPOST(IATOM,*) according to 3-fold rotational symmetry.
C          VPOST(IATOM,*) is assumed to be the dislocation vector of atom 
C          No. 3. (POSST is here only used as storage space)
              POSST(1,1) =  VPOST(IVART,1) 
              POSST(1,2) = -0.5*VPOST(IVART,2) +0.8660254*VPOST(IVART,3) 
              POSST(1,3) = -0.8660254*VPOST(IVART,2) -0.5*VPOST(IVART,3) 
              POSST(2,1) =  0.0
              POSST(2,2) =  0.0
              POSST(2,3) =  0.0
              POSST(3,1) =  VPOST(IVART,1) 
              POSST(3,2) =  VPOST(IVART,2) 
              POSST(3,3) =  VPOST(IVART,3) 
              POSST(4,1) =  VPOST(IVART,1)
              POSST(4,2) = -0.5*VPOST(IVART,2) -0.8660254*VPOST(IVART,3) 
              POSST(4,3) =  0.8660254*VPOST(IVART,2) -0.5*VPOST(IVART,3) 
C
              DO 970 IL = 1,NLAYT
              DO 970 IC=1,3
                 POST(IL,IC) = FPOST(IL,IC) + POSST(IL,IC)
 970          CONTINUE
           END IF
C  ==============================
C  set parameters and registry for rumpled top substrate layer (lay = 1 
C  for overlayer symmetries and registry)
      SO1(1) = REG1(1)
      SO1(2) = REG1(2)
	na =0
	ns =0
	id =1
	lay = 1
	ntau = ntaut
	tv1 = tvb
	dcut = dcuts
	epsn = 0.01
	npert = 5
	nopt = 1
C  NEW = 1 for first call per each energy point
C      = -1 for following calls
	vpi1 = vpis	
	do 980 i = 1,nlayt
	lps(i) = lpst(i)
 980	continue
	ninv = ninvt
C  compute reflection and transmission matrices for rumpled top layer
C  (index t).
C  mtinv0 produces no output to channel 6 and uses subroutines sh0 and
C  sphrm0.
	call mtinv  (rap,tap,ram,tam,rap,tap,ram,tam,rap,tap,ram,tam,
     &              nt,nt,nt,amultt,cylmt,pq,sym,nt,
     &              flms,nl,lx,lxi,lt,lxm,lmmax,
     &              klm,xev,lev,lev2,taut,lmtt,taug,taugm,clm,nlm,
     &              post,POSST,mgh,nlayt,drl,sdrl,nugh,ngeq,ngol,nlay2t,
     &              test,ght,lmgt,rg,ts,lmnt,tg,lm2nt,vt,
     &              caa,ncaa,tht,lmnit,ipl)
      WRITE (6,*) 'MTINV  T OK'
C  Write top layer matrices at 2nd position into RO- arrays;
C  used for 2nd layer:
        call mkarr (rap,rop,nt,nt,jmo,2)
        call mkarr (tap,top,nt,nt,jmo,2)
        call mkarr (ram,rom,nt,nt,jmo,2)
        call mkarr (tam,tom,nt,nt,jmo,2)
        nrtnp(2) = 2
C
C        CALL SHOW(rap,nt,'first.rmat')
C        CALL SHOW(tap,nt,'first.tmat')
C
C  Do not calculate the 2nd layer diffraction matrix, if the same geo-
C  metry is used for more than one first layer geometry.
C
	IF ((NVARS.EQ.1).AND.(IGEO.NE.1)) GOTO 1200
C
	NEW = 1
C======================================================================
C  SECOND LAYER
C======================================================================
C
C  loop 1500 over different buckling positions in 2nd substrate layer
C
	DO 1500 IVARS = 1,NVARS
C  ============================================
C  Write atom positions in second layer to POSS.
C  ============================================
C  In hcp - case atom No. 1 is independent from 2,3 and 4, in fcc - case 
C  atom No. 4 is independent from 1,2 and 3. IATOM = 1,4 means that only
C  the position of this independent atom is varied.
           IF ((IATOMS.EQ.1).OR.(IATOMS.EQ.4)) THEN
              DO 1040 IL = 1,NLAYS
              DO 1040 IC = 1,3
                 POSS(IL,IC) = FPOSS(IL,IC)
 1040          CONTINUE
              DO 1050 IC = 1,3
	         POSS(IATOMS,IC) = FPOSS(IATOMS,IC) + VPOSS(IVARS,IC)
 1050          CONTINUE
           END IF
C
C  IATOM = 2: Move 3 correlated atoms(2,3,4) in hcp case 
	   IF (IATOMS.EQ.2) THEN
C          For symmetry reasons only a vertical movement of these atoms is
C          allowed. Therefore POSST(*,2) = POSST(*,3) = 0.0.
              POSST(1,1) =  0.0
              POSST(1,2) =  0.0
              POSST(1,3) =  0.0
              POSST(2,1) =  VPOSS(IVARS,1) 
              POSST(2,2) =  0.0
              POSST(2,3) =  0.0
              POSST(3,1) =  VPOSS(IVARS,1) 
              POSST(3,2) =  0.0
              POSST(3,3) =  0.0
              POSST(4,1) =  VPOSS(IVARS,1)
              POSST(4,2) =  0.0
              POSST(4,3) =  0.0
C
              DO 1060 IL = 1,NLAYS
                 POSS(IL,1) = FPOSS(IL,1) + POSST(IL,1)
 1060          CONTINUE
           END IF
C
C  IATOM = 3: Move 3 correlated atoms(1,2,3) in fcc case 
	   IF (IATOMS.EQ.3) THEN
C          calculate lateral dislocation vector for atoms 2 and 3 from
C          VPOSS(IATOM,*) according to 3-fold rotational symmetry.
C          VPOSS(IATOM,*) is assumed to be the dislocation vector of atom 
C          No. 1. (POSST is here only used as storage space)
              POSST(1,1) =  VPOSS(IVARS,1) 
              POSST(1,2) =  VPOSS(IVARS,2) 
              POSST(1,3) =  VPOSS(IVARS,3) 
              POSST(2,1) =  VPOSS(IVARS,1)
              POSST(2,2) = -0.5*VPOSS(IVARS,2) -0.8660254*VPOSS(IVARS,3) 
              POSST(2,3) =  0.8660254*VPOSS(IVARS,2) -0.5*VPOSS(IVARS,3) 
              POSST(3,1) =  VPOSS(IVARS,1) 
              POSST(3,2) = -0.5*VPOSS(IVARS,2) +0.8660254*VPOSS(IVARS,3) 
              POSST(3,3) = -0.8660254*VPOSS(IVARS,2) -0.5*VPOSS(IVARS,3) 
              POSST(4,1) =  0.0
              POSST(4,2) =  0.0
              POSST(4,3) =  0.0
C
              DO 1070 IL = 1,NLAYS
              DO 1070 IC=1,3
                 POSS(IL,IC) = FPOSS(IL,IC) + POSST(IL,IC)
 1070          CONTINUE
           END IF
C  ==============================
C  Set parameters and registry for rumpled 2nd substrate layer (lay = 1 
C  for overlayer symmetries and registry)
      SO1(1) = REG2(1)
      SO1(2) = REG2(2)
	na =0
	ns =0
	id =1
	lay = 1
	ntau = ntaus
	tv1 = tvb
	dcut = dcuts
	epsn = 0.01
	npert = 5
	nopt = 1
C  NEW = 1 for first call per each energy point
C      = -1 for following calls
	vpi1 = vpis	
	do 1080 i = 1,nlayS
	lps(i) = lpss(i)
 1080	continue
	ninv = ninvs
C  compute reflection and transmission matrices for rumpled 2nd layer
C  (index s).
C  mtinv0 produces no output to channel 6 and uses subroutines sh0 and
C  sphrm0.
        call mtinv  (rap,tap,ram,tam,rap,tap,ram,tam,rap,tap,ram,tam,
     &              nt,nt,nt,amults,cylms,pq,sym,nt,
     &              flms,nl,lx,lxi,lt,lxm,lmmax,
     &              klm,xev,lev,lev2,taus,lmts,taug,taugm,clm,nlm,
     &              poss,posst,mgh,nlays,drl,sdrl,nugh,ngeq,ngol,nlay2s,
     &              test,ghs,lmgs,rg,ts,lmns,tg,lm2ns,vt,
     &              caa,ncaa,ths,lmnis,ipl)
      WRITE (6,*) 'MTINV  S OK'
C
C  Write 2nd layer matrices at 3rd position into RO- arrays;
C  used for 3rd layer:
        call mkarr (rap,rop,nt,nt,jmo,3)
        call mkarr (tap,top,nt,nt,jmo,3)
        call mkarr (ram,rom,nt,nt,jmo,3)
        call mkarr (tam,tom,nt,nt,jmo,3)
        nrtnp(3) = 3
C
C        CALL SHOW(rap,nt,'scnd.rmat')
C        CALL SHOW(tap,nt,'scnd.tmat')
C  Set RAP/M and TAP/M to zero befor they are used again.
	CALL CZERO (RAP,JKNT)
	CALL CZERO (TAP,JKNT)
	CALL CZERO (RAM,JKNT)
	CALL CZERO (TAM,JKNT)
C  From now on: NEW = -1 (only possible, if cylm,tau,amult,th and gh
C  are not overwritten)
C       NEW = -1
C======================================================================
C  Jump to this label, if there are more than one 1st layer geometries
C  per 2nd layer geometry.
C
 1200   CONTINUE
C======================================================================
C  RFS - ROUTINE
C======================================================================
C  loop 1450 over 2nd layer - 3rd layer distance
C  
      asnp(1,3) = d23x
      DO 1450 istp23 = 1,nstp23
C  loop 1400 over 1st layer - 2nd layer distance
         asnp(1,2) = d12x
         DO 1400 istp12 = 1,nstp12
C  loop 1350 over adsorbate - 1st layer distance
            asnp(1,1) = da1x 
            DO 1350 istpa1 = 1,nstpa1
C
C  Compute reflected beam amplitudes by RFS. RFSG0 instead
C  of RFSG means: no output to channel 6
               CALL RFSG (rop,top,rom,tom,rb,tb,rb,tb,
     &		         NT,NP,jmo,jms,nrtnp,jmnp,nrtp,jmp,
     &                   NT,nb,knbs,xi,pq,pk,jmnpp,aw,anew,jnd,
     &                   asnp,asp,2,liter,crit)
C  A = geometry identifier:
C  1st digit before decimal point = ivars (2nd layer buckling)
C  2nd digit before decimal point = ivart (1st layer buckling)
C  1st digit after decimal point = istp23
C  2nd digit after decimal point = istp12
C  digit 3 and 4 after decimal point = istpa1
               A = float(ivars)*10.  + float(ivart) 
     &         + float(istp23)*0.1
     &         + float(istp12)*0.01 + float(istpa1)*0.0001 
C  Compute reflected intensities (AT) from amplitudes (XI), 
C  print and punch (NPNCH=1); rint0: no output to channel 6. 
               CALL RINT (NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,
     &                   MPU,NPUC,EEV,A,1)
C              write geometry to file *.geo
	       IF (loop.eq.1) THEN
	          write(10,1572) IGEO,A
	          write(10,1573)'DA1',(asnp(i,1)*0.529,i=1,3)
	          do 1260 il = 1,nlayt
		  write(10,1574)'POST',il,(post(il,i)*0.529,i=1,3)
1260	          continue
	          write(10,1573)'D12',(asnp(i,2)*0.529,i=1,3)
	          do 1270 il = 1,nlays
		  write(10,1574)'POSS',il,(poss(il,i)*0.529,i=1,3)
1270	          continue
	          write(10,1573)'D23',(asnp(i,3)*0.529,i=1,3)
	          write(10,*)
	       END IF
               IGEO = IGEO + 1
C
C  da1: adsorbate - 1st layer distance (increase asnp(1,1))
               asnp(1,1) = asnp(1,1) + stepa1
 1350	    CONTINUE
C  d12: 1st layer - 2nd layer distance (increase asnp(1,2))
            asnp(1,2) = asnp(1,2) + step12
 1400    CONTINUE
C  d32: 2nd layer - 3rd layer distance (increase asnp(1,3))
         asnp(1,3) = asnp(1,3) + step23
 1450 CONTINUE
C  2nd layer buckling
 1500 CONTINUE
C  1st layer buckling
 1600 CONTINUE
C  End of geometry loop
C  Close geometry output after first geometry loop is through.
      IF (loop.eq.1) CLOSE(UNIT=10)
C======================================================================
 1572	format('  GEOMETRY: ',i4,2x,f7.4)
 1573	format('  ',a4,' = ',3f7.4)
 1574   format(' ',a4,i1,' = ',3f7.4)
C======================================================================
C
 1990 E = E + DE                                                            4440
      EC = E                                                                4450
      E3 = E                                                                4460
      IF (E-EF)  700, 700, 680                                              4470
 2000 WRITE (6,450)                                                         4480
 2222 STOP                                                                  4490
      END                                                                   4500
C=======================================================================
	SUBROUTINE czero(r,n)
  
C+ GH/25.09.90
C 
C FUNCTIONAL DESCRIPTION:	
C 
C    Subroutine produces complex zero matrix
C 
C FORMAL PARAMETERS:
C  
C     r(n,n)  output
C 
C-
        INTEGER n,i,j
	COMPLEX r(n,n)
	COMPLEX zero
C             
        zero = cmplx(0.0,0.0)
C 
	DO 100 i = 1,n
        DO 100 j = 1,n
           r(i,j) = zero
 100    CONTINUE
C
	RETURN
	END
C======================================================================
	SUBROUTINE mkarr(mat,arr,nr,nc,nm,im)
C+ GH/05.09.90
C 
C FUNCTIONAL DESCRIPTION:	
C 
C     Write complex matrix mat(nr,nc) at im-th position into array of 
C     matrices arr(nr,nc,nm).
C
C FORMAL PARAMETERS:
C  
C     mat(nr,nc)    complex matrix
C     arr(nr,nc,nm) array of complex matrices
C     im            position of mat in arr 
C-
        INTEGER nr,nc,nm,ir,ic,im
	COMPLEX arr(nr,nc,nm), mat(nr,nc)
C
      DO 100 ir = 1,nr
      DO 100 ic = 1,nc
         arr(ir,ic,im) = mat(ir,ic)
 100  CONTINUE
      RETURN
      END
C=======================================================================
	SUBROUTINE show(r,n,name)
C+ GH/26.09.90
C 
C FUNCTIONAL DESCRIPTION:	
C 
C    Print out complex matrix r in actual form:
C    0 for zeros (cabs< 1.0E-3),
C    * for nonzeros cabs<1.0,
C    ! for nonzeros 1.0<cabs<10.0,
C    # for nonzeros cabs>10.0.
C    Output is written to unit 19 (file: name)
C 
C FORMAL PARAMETERS:
C  
C     r(n,n)  complex matrix
C     name    name of output file 
C-
	COMPLEX r(n,n)
        CHARACTER*70 string
	CHARACTER*(*) name
c
        write(19,*)name
c
        IF (n.gt.70) THEN
 20        format(' Sorry, matrix dimension is too large: ',i4)
 30        format(' **** SHOW: DIMENSION TOO LARGE')
           write(19,20)n
           write(6,30)
           goto 999
        END IF
c
        open (unit=19, file=name, status='unknown')
c               
        zero = cmplx(0.0,0.0)
c
	DO 100 i1=1,n
	    DO 50 i2=1,n
		if (cabs(r(i1,i2)).lt.1.0E-03) then
                   string(i2:i2)='0'
                   goto 50
                end if
		if (cabs(r(i1,i2)).lt.1.0) then
                   string(i2:i2)='*'
                   goto 50
                end if
		if (cabs(r(i1,i2)).lt.10.0) then
                   string(i2:i2)='!'
                   goto 50
                end if
                string(i2:i2)='#'
50		CONTINUE
	    write(19,'(2x,a70)')string(1:n)
100	    CONTINUE
        close (unit=19)
999	RETURN
	END
C======================================================================
 GH/25.02.91, p(2*2)S on Re(001) hcp:1st lay:0.057/lat.sh 2nd:-0.047/057/067
  3  2  2               IDEG NL1 NL2
  2 55 21               KNBS KNT NPUN
 26                     NPSI (NO OF ENERGY POINTS)
 1.3800-2.3903          ARA1 SUBSTRATE LATTICE VECTORS
 1.3800 2.3903          ARA2
-0.3333 0.3333          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.2290 0.0000 0.0000   ASA
 2.7600-4.7806          ARB1 OVERLAYER LATTICE VECTORS
 2.7600 4.7806          ARB2
 0.0000 0.0000          SO1 (adsorbate layer)
 0.0000 0.0000          SO2 (1st substrate layer)
 0.0000 0.0000          SO3 (2nd substrate layer)
 2.2290 0.0000 0.0000   ASB 
 0.5000 1.2450 0.0000   FR ASE STEP(REAL NOT USED)
  0                     NSTEP(INTEGER NOT USED)
 13                          KNB(1)
 0.     0.      1  1  (  1)  NORM: 0.     *
-1.0000 1.0000 11 11  (  2)  NORM: 1.0000 *
 1.0000-1.0000 11 11  (  3)  NORM: 1.0000 *
-1.0000 2.0000 11 11  (  4)  NORM: 1.7321 *
 1.0000-2.0000 11 11  (  5)  NORM: 1.7321 *
-2.0000 2.0000 11 11  (  6)  NORM: 2.0000 *
 2.0000-2.0000 11 11  (  7)  NORM: 2.0000 *
-2.0000 3.0000 11 11  (  8)  NORM: 2.6458
 2.0000-3.0000 11 11  (  9)  NORM: 2.6458
-3.0000 2.0000 11 11  ( 10)  NORM: 2.6458
 3.0000-2.0000 11 11  ( 11)  NORM: 2.6458
-3.0000 3.0000 11 11  ( 12)  NORM: 3.0000
 3.0000-3.0000 11 11  ( 13)  NORM: 3.0000
 42                          KNB(2)
-0.5000 0.5000 11  1  ( 14)  NORM: 0.5000 *
 0.5000-0.5000 11  1  ( 15)  NORM: 0.5000 *
 0.5000 0.5000 11  1  ( 16)  NORM: 0.8660 *
-0.5000-0.5000 11  1  ( 17)  NORM: 0.8660 *
-0.5000 1.5000 11  1  ( 18)  NORM: 1.3229 *
 0.5000-1.5000 11  1  ( 19)  NORM: 1.3229 *
-1.5000 0.5000 11  1  ( 20)  NORM: 1.3229 *
 1.5000-0.5000 11  1  ( 21)  NORM: 1.3229 *
-1.5000 1.5000 11  1  ( 22)  NORM: 1.5000 *
 1.5000-1.5000 11  1  ( 23)  NORM: 1.5000 *
 0.5000 1.5000 11  1  ( 24)  NORM: 1.8028 *
-0.5000-1.5000 11  1  ( 25)  NORM: 1.8028 *
 1.5000 0.5000 11  1  ( 26)  NORM: 1.8028 *
-1.5000-0.5000 11  1  ( 27)  NORM: 1.8028 *
-1.5000 2.5000 11  1  ( 28)  NORM: 2.1794
 1.5000-2.5000 11  1  ( 29)  NORM: 2.1794
-2.5000 1.5000 11  1  ( 30)  NORM: 2.1794
 2.5000-1.5000 11  1  ( 31)  NORM: 2.1794
-0.5000 2.5000 11  1  ( 32)  NORM: 2.2913
 0.5000-2.5000 11  1  ( 33)  NORM: 2.2913
-2.5000 0.5000 11  1  ( 34)  NORM: 2.2913
 2.5000-0.5000 11  1  ( 35)  NORM: 2.2913
-2.5000 2.5000 11  1  ( 36)  NORM: 2.5000
 2.5000-2.5000 11  1  ( 37)  NORM: 2.5000
 1.5000 1.5000 11  1  ( 38)  NORM: 2.5981
-1.5000-1.5000 11  1  ( 39)  NORM: 2.5981
 0.5000 2.5000 11  1  ( 40)  NORM: 2.7839
-0.5000-2.5000 11  1  ( 41)  NORM: 2.7839
 2.5000 0.5000 11  1  ( 42)  NORM: 2.7839
-2.5000-0.5000 11  1  ( 43)  NORM: 2.7839
-1.5000 3.5000 11  1  ( 44)  NORM: 3.0414
 1.5000-3.5000 11  1  ( 45)  NORM: 3.0414
-3.5000 1.5000 11  1  ( 46)  NORM: 3.0414
 3.5000-1.5000 11  1  ( 47)  NORM: 3.0414
-2.5000 3.5000 11  1  ( 48)  NORM: 3.1225
 2.5000-3.5000 11  1  ( 49)  NORM: 3.1225
-3.5000 2.5000 11  1  ( 50)  NORM: 3.1225
 3.5000-2.5000 11  1  ( 51)  NORM: 3.1225
-0.5000 3.5000 11  1  ( 52)  NORM: 3.2787
 0.5000-3.5000 11  1  ( 53)  NORM: 3.2787
-3.5000 0.5000 11  1  ( 54)  NORM: 3.2787
 3.5000-0.5000 11  1  ( 55)  NORM: 3.2787
 0.0020                 TST
  1  2  3  4  5  6  7 14 15 16 17 18 19 20 21 22 23 24 25 26 27   NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
 10                     LITER (No of iterations for rfsg)
  1  1  0               IT1 IT2 IT3
 430.0000 186.2070   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
 440.0000  32.0600   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPER3 DR03
 300.0000                                        TI TF DT
  6                     LMAX
  2                     NEL El 1 = Re El 2 = S
 0.5000               1 = Re  2 = S (NiS)
 1.9897-0.4925 1.7550 0.0112 0.0005 0.0000 0.0000 0.0000 0.0000 0.0000
 0.7791 4.1560 0.0980 0.0028 0.0000 0.0000 0.0000 0.0000
 0.7500
 1.7607-0.6750 2.1870 0.0408 0.0024 0.0001 0.0000 0.0000 0.0000 0.0000
 0.5196 4.2295 0.2711 0.0107 0.0006 0.0000 0.0000 0.0000
 1.0000
 1.5741-0.8238 2.1960 0.1003 0.0075 0.0005 0.0000 0.0000 0.0000 0.0000
 0.3204 4.1969 0.5369 0.0254 0.0016 0.0000 0.0000 0.0000
 1.2500
 1.4133-0.9502 2.1518 0.1970 0.0176 0.0014 0.0001 0.0000 0.0000 0.0000
 0.1611 4.1320 0.8000 0.0540 0.0047 0.0003 0.0000 0.0000
 1.5000
 1.2701-1.0611 2.0988 0.3322 0.0344 0.0033 0.0003 0.0000 0.0000 0.0000
 0.0019 4.0671 1.0631 0.0826 0.0079 0.0006 0.0000 0.0000
 1.7500
 1.1400-1.1613 2.0469 0.4953 0.0594 0.0065 0.0006 0.0000 0.0000 0.0000
-0.0992 4.0023 1.1918 0.1289 0.0149 0.0014 0.0002 0.0000
 2.0000
 1.0203-1.2536 1.9987 0.6646 0.0940 0.0116 0.0013 0.0001 0.0000 0.0000
-0.2004 3.9374 1.3204 0.1753 0.0220 0.0022 0.0003 0.0000
 2.2500
 0.9092-1.3398 1.9543 0.8181 0.1386 0.0189 0.0024 0.0002 0.0000 0.0000
-0.2788 3.8869 1.3629 0.2325 0.0369 0.0049 0.0006 0.0001
 2.5000
 0.8055-1.4211 1.9132 0.9443 0.1931 0.0289 0.0040 0.0005 0.0000 0.0000
-0.3572 3.8364 1.4054 0.2897 0.0518 0.0077 0.0010 0.0002
 2.7500
 0.7085-1.4983 1.8747 1.0423 0.2567 0.0417 0.0064 0.0008 0.0001 0.0000
-0.4356 3.7859 1.4479 0.3468 0.0668 0.0104 0.0013 0.0002
 3.0000
 0.6172-1.5717 1.8380 1.1168 0.3275 0.0577 0.0097 0.0014 0.0002 0.0000
-0.5140 3.7354 1.4904 0.4040 0.0817 0.0132 0.0016 0.0003
 3.2500
 0.5313-1.6418 1.8027 1.1738 0.4034 0.0767 0.0140 0.0021 0.0003 0.0000
-0.5696 3.6998 1.5099 0.4479 0.1048 0.0197 0.0029 0.0005
 3.5000
 0.4502-1.7087 1.7684 1.2180 0.4818 0.0988 0.0194 0.0032 0.0004 0.0000
-0.6252 3.6642 1.5294 0.4918 0.1278 0.0262 0.0042 0.0006
 3.7500
 0.3735-1.7727 1.7347 1.2530 0.5602 0.1236 0.0261 0.0047 0.0007 0.0001
-0.6808 3.6286 1.5488 0.5357 0.1509 0.0328 0.0056 0.0008
 4.0000
 0.3007-1.8338 1.7016 1.2815 0.6369 0.1509 0.0341 0.0066 0.0010 0.0001
-0.7364 3.5930 1.5683 0.5796 0.1740 0.0393 0.0069 0.0009
 4.2500
 0.2316-1.8924 1.6691 1.3051 0.7106 0.1802 0.0434 0.0089 0.0015 0.0002
-0.7808 3.5650 1.5811 0.6055 0.1982 0.0499 0.0099 0.0016
 4.5000
 0.1659-1.9484 1.6370 1.3250 0.7807 0.2110 0.0541 0.0118 0.0021 0.0003
-0.8252 3.5371 1.5939 0.6314 0.2224 0.0605 0.0129 0.0022
 4.7500
 0.1031-2.0021 1.6054 1.3418 0.8471 0.2427 0.0661 0.0154 0.0030 0.0005
-0.8695 3.5092 1.6067 0.6574 0.2466 0.0711 0.0158 0.0029
 5.0000
 0.0431-2.0537 1.5745 1.3560 0.9099 0.2750 0.0792 0.0195 0.0040 0.0007
-0.9139 3.4812 1.6195 0.6833 0.2708 0.0817 0.0188 0.0035
 5.2500
-0.0143-2.1032 1.5441 1.3680 0.9693 0.3073 0.0935 0.0243 0.0053 0.0009
-0.9519 3.4568 1.6263 0.7004 0.2905 0.0947 0.0237 0.0048
 5.5000
-0.0695-2.1508 1.5145 1.3781 1.0258 0.3393 0.1087 0.0298 0.0068 0.0013
-0.9899 3.4324 1.6330 0.7174 0.3103 0.1076 0.0287 0.0062
 5.7500
-0.1227-2.1967 1.4855 1.3864 1.0796 0.3707 0.1248 0.0360 0.0087 0.0017
-1.0279 3.4079 1.6398 0.7345 0.3300 0.1205 0.0337 0.0075
 6.0000
-0.1739-2.2409 1.4573 1.3932 1.1310 0.4014 0.1414 0.0428 0.0108 0.0023
-1.0659 3.3835 1.6465 0.7515 0.3497 0.1335 0.0386 0.0088
 6.2500
-0.2233-2.2837 1.4297 1.3987 1.1802 0.4312 0.1585 0.0503 0.0133 0.0029
-1.1039 3.3591 1.6532 0.7685 0.3694 0.1465 0.0436 0.0101
 6.5000
-0.2712-2.3251 1.4029 1.4030 1.2272 0.4600 0.1759 0.0584 0.0162 0.0037
-1.1420 3.3347 1.6600 0.7855 0.3891 0.1594 0.0485 0.0115
 6.7500
-0.3176-2.3653 1.3768 1.4062 1.2722 0.4879 0.1935 0.0670 0.0195 0.0047
-1.1800 3.3102 1.6667 0.8026 0.4088 0.1724 0.0535 0.0128
  4  1			NLAYT (NO OF SUBLAYERS IN TOP LAYER), IATOMT(hcp)
 0.0000 1.3800 0.7967   FPOST(1,J)	) RELATIVE POSITION OF ATOMS
 0.0000 2.7600 3.1870   FPOST(2,J)	) IN COMP. LAYER
 0.0570 2.7600-1.5935   FPOST(3,J)	) 
 0.0000 4.1400 0.7967   FPOST(4,J)	) 
  1			NVART (= NO OF VPOST)
 0.0000 0.0650 0.0000   VPOST(1,J)
  2			NTAUT (NO OF ELTS. AT ALL, EQUAL TO NTAUO)
  1  1  1  1		LPST (DIM = NLAY) (SIC)
  4  0			NINVT,NLAY2R (SIC)
  1  1  1  1		INVT (DIM = NLAY, 1 FOR MTINV)
  4  1			NLAYS (NO OF SUBLAYERS IN TOP LAYER), IATOMS(hcp)
 0.0000 0.0000 0.0000   FPOSS(1,J)	) RELATIVE POSITION OF ATOMS
 0.0000 1.3800 2.3902   FPOSS(2,J)	) IN COMP. LAYER
 0.0000 1.3800-2.3902   FPOSS(3,J)	) 
 0.0000 2.7600 0.0000   FPOSS(4,J)	) 
  3			NVARS (= NO OF VPOST)
-0.0470 0.0000 0.0000   VPOSS(1,J)
-0.0570 0.0000 0.0000   VPOSS(2,J)
-0.0670 0.0000 0.0000   VPOSS(3,J)
  2			NTAUS (NO OF ELTS. AT ALL, EQUAL TO NTAUO)
  1  1  1  1		LPSS (DIM = NLAY) (SIC)
  4  0			NINVS,NLAY2R (SIC)
  1  1  1  1		INVS (DIM = NLAY, 1 FOR MTINV)
 1.6900 0.0000 0.0000   DA1 (ADS - 1ST LAYER)
  5 0.0100              NSTPA1 STEPA1
 2.0700 0.0000 0.0000   D12  (1ST - 2ND LAYER)
  5 0.0100              NSTP12 STEP12 (2%) (Re3-Re4)
 2.2300 0.0000 0.0000   D23  (2ND - 3RD LAYER)
  3 0.0100              NSTP23 STEP23 (2%) (Re3-Re4)
  64.00 233.00  04.00   EI EF DE
 -10.00                 EI EF DE
C
C  --- M4.5.1
C
C     PROGRAM MIR22S(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,      160784
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA FOR IR(110)+(2X2)2S,RSP + LAY.DBLG., MIRR.PL.+GL.PL.
C  MAIN LEED PROGRAM FOR FCC(110), NORMAL INCIDENCE.
C  (2X2) UNIT CELL DUE TO MISSING ROW AND 2 ADATOMS PER UNIT CELL IN
C  TOP LAYER (TREATED AS 4 AT/U.C. LAYER WITH RSP).
C  FULL SYMMETRY EXPLOITED (1 MIRROR PLANE AND 1 GLIDE PLANE).
C  LAYER DOUBLING BETWEEN LAYERS.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),AS1(3),AS2(3)
C  4=NL, 45=KLM
      COMPLEX VL(4,2),FLMS(4,45),FLM(45)
C  4=NL,  2=IDEG
      DIMENSION V(4,2),JJS(4,2)
C  4=KNBS=NO. OF BEAM SETS, 64=KNT=NO. OF BEAMS READ
      DIMENSION KNB(4),NB(4),SPQF(2,64),SPQ(2,64),PQF(2,64),PQ(2,64)
      INTEGER KSYM(2,64),SYM(2,64),INT(64)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  11=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(11),PHSS(11,10)
C  4=NLAY, 12 FIXED, 759 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(20,3),LPS(20),INV(20),CAA(759),NCA(7),
     1POS(4,3),LPSS(20)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C  809=NLM FROM DATA STATEMENT, 81=NN, 9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(809),YLM(81),FAC2(81),FAC1(9)
C  9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP(9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3.GE.NTAU (FOR COMPOSITE LAYERS), 10 MUST BE .GE. L1
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
C  19=KNB(1), 17=KNB(2), 13=KNB(3), 15=KNB(4), 64=KNT
      COMPLEX ROP(64,64),TOP(64,64)
      COMPLEX ROV(64,64),TOV(64,64),RS(64,64)
      COMPLEX RA1(19,19),TA1(19,19),RA2(19,19),TA2(19,19)
      COMPLEX RB1(17,17),TB1(17,17),RB2(17,17),TB2(17,17)
      COMPLEX RC1(13,13),TC1(13,13),RC2(13,13),TC2(13,13)
      COMPLEX RD1(15,15),TD1(15,15),RD2(15,15),TD2(15,15)
      COMPLEX S1(64,64),S2(19,19),S3(19,19),S4(19,19),PP(2,19),XS(64)
      COMPLEX AMULT(64),CYLM(64,25)
      COMPLEX XI(64)
C  50=LMT, 15=LEV, 300(IN GH)=LMG, 4=NLAY, 100(IN TS)=LMN, 200=LM2N
C  TH AND IPL NOT USED (NO INVERSION)
      COMPLEX TAU(50,15),TAUG(50),TAUGM(50),GH(300,25),RG(3,4,64),
     1TS(100),TG(2,200),VT(200),TH(1,1)
      DIMENSION IPL(1)
C  15=LEV, 30=LEV2, 10=LOD
      COMPLEX XEV(15,30),XOD(10,10),YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(64)
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2              1560
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV                         1600
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
C  FOR CDC ONLY  ********************************
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROV,TOV,ROP,TOP,RA1,TA1,RA2,TA2,
C    1RB1,TB1,RB2,TB2,RC1,TC1,RC2,TC2,RD1,TD1,RD2,TD2,RS,S1,S2,S3,S4
C     COMMON /BIG/ GH,TH,TAU,XEV,XOD,ROV,TOV,ROP,TOP,RA1,TA1,RA2,TA2,
C    1RB1,TB1,RB2,TB2,RC1,TC1,RC2,TC2,RD1,TD1,RD2,TD2,RS,S1,S2,S3,S4
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)                    1760
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)                        1910
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =    1920
     1 ,F9.4)                                                               1930
  390 FORMAT(8H0TEMP = ,F9.4)                                               1940
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)                                                 1970
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)                                       2000
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYER (0,IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)                                       2960
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE                                              3120
      IF (EI)  1000, 690, 690                                               3130
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI                                                                3140
      EC = E                                                                3150
      E3 = E                                                                3160
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV                                                  3170
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  THIS CARD SPECIAL FOR IRIDIUM
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)                                                 3200
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO                               3230
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI                                                                3390
  780 WRITE (6,390)  T                                                      3410
C
      VPI1 = VPIO                                                           3720
C  PERFORM PLANAR LATTICE SUM IN FMAT, ASSUMING MUFFIN-TIN CONSTANTS AND
C  DAMPINGS IN SUBSTRATE AND OVERLAYER ARE EQUAL
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)             3750
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR SUBSTRATE
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
C
C  SET PARAMETERS FOR SUBSTRATE LAYERS
      VPI = VPIS                                                            4070
      VPI1 = VPIS                                                           4080
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA                                                              4060
C
C  PRODUCE REFLECTION (RA1,RA2) AND TRANSMISSION (TA1,TA2) MATRICES
C  FOR SUBSTRATE LAYERS USING FIRST BEAM SUBSET.
C  TWO REGISTRIES- ID=2. FOUR SUBLATTICES- NLL=NL=4. SUBSTRATE SYMMETRIES
C  APPLY- LAY=2.  FIRST BEAM SET DIMENSION- NAA=NB(1)
      NAA=NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA2,TA2,NAA,NAA,NAA,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,0,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  REPEAT FOR SECOND BEAM SUBSET.
      NBB=NB(2)
      CALL MSMF(RB1,TB1,RB2,TB2,RB1,TB1,RB2,TB2,NBB,NBB,NBB,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,NAA,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  REPEAT FOR THIRD BEAM SUBSET.
      NCC=NB(3)
      N=NAA+NBB
      CALL MSMF(RC1,TC1,RC2,TC2,RC1,TC1,RC2,TC2,NCC,NCC,NCC,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,N,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  REPEAT FOR FOURTH BEAM SUBSET.
      NDD=NB(4)
      N=NAA+NBB+NCC
      CALL MSMF(RD1,TD1,RD2,TD2,RD1,TD1,RD2,TD2,NDD,NDD,NDD,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,N,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  STACK SUBSTRATE LAYERS BY LAYER DOUBLING
C  LAYER DOUBLING FOR FIRST BEAM SET
      CALL SUBREF(RA1,TA1,RA2,TA2,NAA,S1,S2,S3,S4,PP,XS,INT,NP,0,NT,PQ)
      WRITE(6,420)
C
C  LAYER DOUBLING FOR SECOND BEAM SET
      CALL SUBREF(RB1,TB1,RB2,TB2,NBB,S1,S2,S3,S4,PP,XS,INT,NP,
     1  NAA,NT,PQ)
      WRITE(6,420)
C
C  LAYER DOUBLING FOR THIRD BEAM SET
      N=NAA+NBB
      CALL SUBREF(RC1,TC1,RC2,TC2,NCC,S1,S2,S3,S4,PP,XS,INT,NP,
     1  N,NT,PQ)
      WRITE(6,420)
C
C  LAYER DOUBLING FOR FOURTH BEAM SET
      N=NAA+NBB+NCC
      CALL SUBREF(RD1,TD1,RD2,TD2,NDD,S1,S2,S3,S4,PP,XS,INT,NP,
     1  N,NT,PQ)
      WRITE(6,420)
C
C  COPY SUBSTRATE REFLECTION MATRICES ONTO LARGER BLOCK DIAGONAL
C  MATRIX RS
      CALL MATCOP(RA1,NAA,RB1,NBB,RC1,NCC,RD1,NDD,RS,NT,4)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  SET PARAMETERS FOR COMPOSITE LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=8
      NOPT=1
      NEW=1
C
C
C  START LOOP OVER INTERNAL GEOMETRY OF COMPOSITE (TOP) LAYER
      DO 900 J=1,3
      DO 900 I=1,NLAY
  900 POS(I,J)=FPOS(I,J)
      DO 970 IVAR=1,NVAR
      POS(1,3)=1.9999
      POS(2,3)=-POS(1,3)
      POS(3,1)=0.8888
      POS(4,1)=POS(3,1)
C
C
C  PRODUCE DIFFRACTION MATRICES FOR COMPOSITE LAYER.
      CALL MPERTI(ROV,TOV,ROP,TOP,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,POS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1,1)
      WRITE(6,415)
      NEW=-1
C
C
C  ASV BECOMES THE 3-D VECTOR FROM TOP LAYER TO NEXT LAYER AND WILL BE
C  VARIED
      DO 937 J=1,3
  937 ASV(J)=ASB(J)
C
C  LOOP 960 VARIES THE SPACING ASV(1) BETWEEN THE TOP (COMPOSITE) LAYER
C  AND THE NEXT (SUBSTRATE) LAYER
      DO 960 I=1,NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      A=AS(1)
      WRITE (6,430) (AS(J),J=1,3)
C
C  ADD TOP LAYER BY LAYER DOUBLING
      CALL ADREF1(ROV,TOV,ROP,TOP,RS,S1,S2,XS,INT,XI,PQ,NT,EMACH,ASV)
C
C  GET INTENSITIES (AT) FROM AMPLITUDES (XI) AND OUTPUT
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
C
C
  960 ASV(1)=ASV(1)+STEP
  970 CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT                                                            4420
      IF (T-TF)  780, 780, 990                                              4430
C
  990 E = E + DE                                                            4440
      EC = E                                                                4450
      E3 = E                                                                4460
      IF (E-EF)  700, 700, 680                                              4470
 1000 WRITE (6,450)                                                         4480
      STOP                                                                  4490
      END                                                                   4500
 IR(110)+(2X2)2S, MISS ROW + 2S, 5 PS, TH=0, MIRR PL + GL PL
  2  2  2               IDEG NL1 NL2
  4 64 11               KNBS KNT NPUN
 11                     NPSI
 2.7170 0.0000          ARA1
 0.0000 3.8424          ARA2
 0.5000 0.5000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 1.3585 0.0000 0.0000   ASA
 5.4340 0.0000          ARB1
 0.0000 7.6848          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.2585 0.0000 0.0000   ASB
 0.5000 1.0000 0.1000   FR ASE STEP
  5                     NSTEP
 19                     KNB(1)
 0.     0.      1  1    BEAMS
 0.     1.0000  2  2
 1.0000 0.      2  2
 1.0000 1.0000  9  9
 0.     2.0000  2  2
 1.0000 2.0000  9  9
 2.0000 0.      2  2
 2.0000 1.0000  9  9
 0.     3.0000  2  2
 1.0000 3.0000  9  9
 2.0000 2.0000  9  9
 0.     4.0000  2  2
 2.0000 3.0000  9  9
 3.0000 0.      2  2
 1.0000 4.0000  9  9
 3.0000 1.0000  9  9
 3.0000 2.0000  9  9
 2.0000 4.0000  9  9
 0.     5.0000  2  2
 17
 0.      .5000  2  2
 1.0000  .5000  9  9
 0.     1.5000  2  2
 1.0000 1.5000  9  9
 0.     2.5000  2  2
 2.0000  .5000  9  9
 1.0000 2.5000  9  9
 2.0000 1.5000  9  9
 0.     3.5000  2  2
 2.0000 2.5000  9  9
 1.0000 3.5000  9  9
 3.0000  .5000  9  9
 3.0000 1.5000  9  9
 2.0000 3.5000  9  9
 0.     4.5000  2  2
 1.0000 4.5000  9  9
 3.0000 2.5000  9  9
 13
  .5000 1.0000 49 49
  .5000 2.0000 49 49
 1.5000 1.0000 49 49
 1.5000 2.0000 49 49
  .5000 3.0000 49 49
 2.5000 1.0000 49 49
 1.5000 3.0000 49 49
 2.5000 2.0000 49 49
  .5000 4.0000 49 49
 1.5000 4.0000 49 49
 2.5000 3.0000 49 49
 3.5000 1.0000 49 49
  .5000 5.0000 49 49
 15
  .5000  .5000 49 49
  .5000 1.5000 49 49
 1.5000  .5000 49 49
 1.5000 1.5000 49 49
  .5000 2.5000 49 49
 1.5000 2.5000 49 49
 2.5000  .5000 49 49
  .5000 3.5000 49 49
 2.5000 1.5000 49 49
 1.5000 3.5000 49 49
 2.5000 2.5000 49 49
  .5000 4.5000 49 49
 3.5000  .5000 49 49
 2.5000 3.5000 49 49
 1.5000 4.5000 49 49
 0.0020                 TST
  1  2  3  4 20 21 22 23 37 50 51         NPU
   0.00   0.00          THETA FI
   0.00  15.00          VO VV
 0.0010                 EPS
  8                    LITER
  1  0  0               IT1 IT2 IT3
 280.0000 192.2000   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
 685.5300  32.0640   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPER3 DR03
 300.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
 0.3676
 2.3699-0.2750-0.8449 0.0073 0.0003 0.0000 0.0000 0.0000 0.0000 0.0000 IR
 0.9640 3.9828 0.0466 0.0011 0.0000 0.0000 0.0000 0.0000               S
 0.5515
 2.1813-0.3964-0.6762 0.0269 0.0014 0.0001 0.0000 0.0000 0.0000 0.0000
 0.7256 4.1711 0.1337 0.0044 0.0001 0.0000 0.0000 0.0000
 0.7353
 2.0172-0.5030-0.7061 0.0669 0.0043 0.0002 0.0000 0.0000 0.0000 0.0000
 0.5349 4.2252 0.2609 0.0102 0.0006 0.0000 0.0000 0.0000
 1.1029
 1.7345-0.6893-0.8084 0.2310 0.0204 0.0017 0.0001 0.0000 0.0000 0.0000
 0.2549 4.1702 0.6452 0.0372 0.0029 0.0001 0.0000 0.0000
 1.4706
 1.4938-0.8555-0.8970 0.5053 0.0576 0.0063 0.0006 0.0000 0.0000 0.0000
 0.0206 4.0747 1.0322 0.0792 0.0075 0.0006 0.0000 0.0000
 2.0221
 1.1895-1.0811-1.0003 0.9196 0.1654 0.0241 0.0031 0.0003 0.0000 0.0000
-0.2073 3.9329 1.3242 0.1804 0.0233 0.0024 0.0003 0.0000
 2.9412
 0.7917-1.4029-1.1455 1.2503 0.4555 0.0970 0.0188 0.0030 0.0004 0.0000
-0.4956 3.7473 1.4804 0.3906 0.0782 0.0126 0.0015 0.0003
 4.0441
 0.4337-1.7092-1.3149 1.4021 0.7990 0.2452 0.0684 0.0158 0.0029 0.0004
-0.7442 3.5881 1.5706 0.5842 0.1783 0.0412 0.0074 0.0010
 4.9632
 0.1954-1.9147-1.4444 1.4627 1.0283 0.3758 0.1342 0.0396 0.0095 0.0018
-0.9074 3.4853 1.6176 0.6795 0.2672 0.0801 0.0184 0.0034
 6.0662
-0.0484-2.1238-1.5794 1.4903 1.2629 0.5092 0.2231 0.0845 0.0260 0.0065
-1.0760 3.3770 1.6483 0.7560 0.3549 0.1369 0.0399 0.0092
 6.9853
-0.2272-2.2780-1.6786 1.4955 1.4239 0.6057 0.2915 0.1300 0.0479 0.0143
-1.2158 3.2872 1.6731 0.8186 0.4273 0.1846 0.0581 0.0140
  4                      NLAY
 0.0000 1.3585 1.9999   FPOS(1,J)
 0.0000-1.3585-1.9999   FPOS(2,J)
 0.8888 0.0000 0.0000   FPOS(3,J)
 0.8888 2.7170 0.0000   FPOS(4,J)
  3                     NVAR
 1.3585 0.0000 0.0000   VPOS(1,J)
 0.0000 0.0000 0.0000   VPOS(2,J)
 0.0000 0.0000 0.0000   VPOS(3,J)
  2                     NTAU
  2  2  1  1            LPS
  0                     NINV
  0  0  0  0            INV
  40.00  41.00  25.00   EI EF DE
 -10.00                 EI EF DE
C
C
C  --- M4.5.2
C
C    MAIN+DATA FOR IR(110)+(2X2)2S,RSP + LAY.DBLG., MIRR.PL.+GL.PL.
C  MAIN LEED PROGRAM FOR FCC(110), NORMAL INCIDENCE.
C  ****************************************************************
C  THIS PROGRAM ALSO CONSIDERS A PAIRED ROW IN THE SECOND LAYER AND
C  A BUCKLED ROW IN THE THIRD LAYER
C  ****************************************************************
C  (2X2) UNIT CELL DUE TO MISSING ROW AND 2 ADATOMS PER UNIT CELL IN
C  TOP LAYER (TREATED AS 4 AT/U.C. LAYER WITH RSP).
C  FULL SYMMETRY EXPLOITED (1 MIRROR PLANE AND 1 GLIDE PLANE).
C  LAYER DOUBLING BETWEEN LAYERS.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),AS1(3),AS2(3)
C  4=NL, 91=KLM
      COMPLEX VL(4,2),FLMS(4,91),FLM(91)
C  4=NL,  2=IDEG
      DIMENSION V(4,2),JJS(4,2)
C  4=KNBS=NO. OF BEAM SETS, 64=KNT=NO. OF BEAMS READ
      DIMENSION KNB(4),NB(4),SPQF(2,64),SPQ(2,64),PQF(2,64),PQ(2,64)
      INTEGER KSYM(2,64),SYM(2,64),INT(64)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  11=NPSI, 14=NEL*(LMAX+1)
C  CHAN
C  NEL = NUMBER OF ELEMENTS   
      DIMENSION ES(11),PHSS(11,14)
C  4=NLAY, 12 FIXED, 3836 FROM DATA STATEMENT.
      DIMENSION FPOS(4,3),VPOS(20,3),LPS(12),INV(12),CAA(3836),NCA(7),
     1POS(4,3),POS2(4,3),POS3(4,3),WPOS(4,3),LPSS(12)
C  4=NLAY, 6=NLAY2
      DIMENSION POSS(4,3),MGH(4,4),DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),
     1NGOL(6),TEST(6)
C  4032=NLM FROM DATA STATEMENT, 169=NN, 13=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(4032),YLM(169),FAC2(169),FAC1(13)
C  13=NN1, 7=NN2, 7=NN3
      DIMENSION PPP(13,7,7)
C  49=LMMAX
      DIMENSION LX(49),LXI(49),LXM(49),LT(49)
C  7=LMAX+1=L1, 3.GE.NTAU (FOR COMPOSITE LAYERS), 10 MUST BE .GE. L1
      COMPLEX AF(7),CAF(7),TSF0(3,10),TSF(3,10)
C  19=KNB(1), 17=KNB(2), 13=KNB(3), 15=KNB(4), 64=KNT
      COMPLEX ROP(64,64),TOP(64,64),ROQ(64,64),TOQ(64,64)
      COMPLEX ROU(64,64),TOU(64,64), ROM(64,64),TOM(64,64)
      COMPLEX ROV(64,64),TOV(64,64),RS(64,64),RU(64,64),RN(64,64)
      COMPLEX RA1(19,19),TA1(19,19),RA2(19,19),TA2(19,19)
      COMPLEX RB1(17,17),TB1(17,17),RB2(17,17),TB2(17,17)
      COMPLEX RC1(13,13),TC1(13,13),RC2(13,13),TC2(13,13)
      COMPLEX RD1(15,15),TD1(15,15),RD2(15,15),TD2(15,15)
      COMPLEX S1(64,64),S2(64,64),S3(19,19),S4(19,19),PP(2,64),XS(64)
      COMPLEX AMULT(64),CYLM(64,49)
      COMPLEX XI(64)
C  98=LMT, 28=LEV, 588(IN GH)=LMG, 4=NLAY, 196(IN TS)=LMN, 392 =LM2N
C  TH AND IPL NOT USED (NO INVERSION)
      COMPLEX TAU(98,28),TAUG(98),TAUGM(98),GH(588,49),RG(3,4,64),
     1TS(196),TG(2,392),VT(392),TH(196,196)
      DIMENSION IPL(196)
C  28=LEV, 56 =LEV2, 28=LOD
      COMPLEX XEV(28,56),XOD(21,21),YLME(28),YLMO(21)
      DIMENSION IPLE(28),IPLO(21),AT(64)
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2              1560
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV                         1600
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
      COMMON /BIG/ GH,TH,TAU,XEV,XOD,ROV,TOV,ROP,TOP,RA1,TA1,RA2,TA2,
     1RB1,TB1,RB2,TB2,RC1,TC1,RC2,TC2,RD1,TD1,RD2,TD2,RS,S1,S2,S3,S4
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)                    1760
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)                        1910
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =    1920
     1 ,F9.4)                                                               1930
  390 FORMAT(8H0TEMP = ,F9.4)                                               1940
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)                                                 1970
  430 FORMAT(20H0SURFACE GEOMETRY   ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)                                       2000
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
      OPEN(UNIT=5,FILE='INPUT2SLD3.DAT',STATUS='OLD')
      OPEN(UNIT=6,FILE='[CCHAN.IR1102S]OUTPUT.DAT',STATUS='NEW')
      OPEN(UNIT=7,FILE='[CCHAN.IR1102S]OUTPUN.DAT',STATUS='NEW')
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG  EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2  SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYER (0,IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM  PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)                                       2960
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP; IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE                                              3120
      IF (EI)  1000, 690, 690                                               3130
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI                                                                3140
      EC = E                                                                3150
      E3 = E                                                                3160
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV                                                  3170
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  THIS CARD SPECIAL FOR IRIDIUM
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)                                                 3200
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO                               3230
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI                                                                3390
  780 WRITE (6,390)  T                                                      3410
C
      VPI1 = VPIO                                                           3720
C  PERFORM PLANAR LATTICE SUM IN FMAT, ASSUMING MUFFIN-TIN CONSTANTS AND
C  DAMPINGS IN SUBSTRATE AND OVERLAYER ARE EQUAL
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)             3750
C  *******************************************************************
C                     SUBSTRATE 
C  *******************************************************************
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR SUBSTRATE
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
C
C  SET PARAMETERS FOR SUBSTRATE LAYERS
      VPI = VPIS                                                            4070
      VPI1 = VPIS                                                           4080
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA                                                              4060
C
C  PRODUCE REFLECTION (RA1,RA2) AND TRANSMISSION (TA1,TA2) MATRICES
C  FOR SUBSTRATE LAYERS USING FIRST BEAM SUBSET.
C  TWO REGISTRIES- ID=2. FOUR SUBLATTICES- NLL=NL=4. SUBSTRATE SYMMETRIES
C  APPLY- LAY=2.  FIRST BEAM SET DIMENSION- NAA=NB(1)
      NAA=NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA2,TA2,NAA,NAA,NAA,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,0,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  REPEAT FOR SECOND BEAM SUBSET.
      NBB=NB(2)
      CALL MSMF(RB1,TB1,RB2,TB2,RB1,TB1,RB2,TB2,NBB,NBB,NBB,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,NAA,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  REPEAT FOR THIRD BEAM SUBSET.
      NCC=NB(3)
      N=NAA+NBB
      CALL MSMF(RC1,TC1,RC2,TC2,RC1,TC1,RC2,TC2,NCC,NCC,NCC,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,N,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  REPEAT FOR FOURTH BEAM SUBSET.
      NDD=NB(4)
      N=NAA+NBB+NCC
      CALL MSMF(RD1,TD1,RD2,TD2,RD1,TD1,RD2,TD2,NDD,NDD,NDD,AMULT,CYLM,
     1 PQ,SYM,NT,FLMS,FLM,V,NL,N,0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2 XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE(6,410)
C
C  STACK SUBSTRATE LAYERS BY LAYER DOUBLING
C  LAYER DOUBLING FOR FIRST BEAM SET
      CALL SUBREF(RA1,TA1,RA2,TA2,NAA,S1,S2,S3,S4,PP,XS,INT,NP,0,NT,PQ)
      WRITE(6,420)
C
C  LAYER DOUBLING FOR SECOND BEAM SET
      CALL SUBREF(RB1,TB1,RB2,TB2,NBB,S1,S2,S3,S4,PP,XS,INT,NP,
     1  NAA,NT,PQ)
      WRITE(6,420)
C
C  LAYER DOUBLING FOR THIRD BEAM SET
      N=NAA+NBB
      CALL SUBREF(RC1,TC1,RC2,TC2,NCC,S1,S2,S3,S4,PP,XS,INT,NP,
     1  N,NT,PQ)
      WRITE(6,420)
C
C  LAYER DOUBLING FOR FOURTH BEAM SET
      N=NAA+NBB+NCC
      CALL SUBREF(RD1,TD1,RD2,TD2,NDD,S1,S2,S3,S4,PP,XS,INT,NP,
     1  N,NT,PQ)
      WRITE(6,420)
C
C  COPY SUBSTRATE REFLECTION MATRICES ONTO LARGER BLOCK DIAGONAL
C  MATRIX RS
      CALL MATCOP(RA1,NAA,RB1,NBB,RC1,NCC,RD1,NDD,RS,NT,4)
C
C********************************************************************
C       TOP COMPOSITE LAYER IR + S ATOMS
C*******************************************************************
C 
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)

C
C  SET PARAMETERS FOR COMPOSITE LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
      LPS(1)=2
      LPS(2)=2
      NTAU=2
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=8
      NOPT=1
      NEW=1
C
C
C  START LOOP OVER INTERNAL GEOMETRY OF COMPOSITE (TOP) LAYER
C  ---------------------------------------------------------
C  PUT IN THE GEOMERTY OF THE TOP LAYER IR AND S ATOMS
C  ---------------------------------------------------------
      DO 905 J=1,3
      DO 905 I=1,NLAY
  905 POS(I,J)=FPOS(I,J)
      DO 969 IVAT=11,11
      POS(1,3)=VPOS(IVAT,3)
      POS(2,3)=-POS(1,3)
      POS(3,1)=VPOS(IVAT,1)
      POS(4,1)=POS(3,1)
  969 CONTINUE
C   ----------------------------------------------------------
C
C  PRODUCE DIFFRACTION MATRICES FOR COMPOSITE LAYER.
      CALL MTINV(ROQ,TOQ,ROP,TOP,ROQ,TOQ,ROQ,TOQ,ROQ,TOQ,ROQ,TOQ,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,POS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,415)
C
C **********************************************************************
C                      SECOND AND THIRD LAYER
C **********************************************************************
C
C
C  
C  PRODUCE DIFFRACTION MATRICES FOR 2ND LAYER (OF COMPOSITE TYPE)
C  
C  PUT IN THE SECOND LAYER GEOMETRY
C  ---------------------------------
      DO 900 J=1,3
      POS2(1,J)=VPOS(1,J)
      POS2(2,J)=VPOS(2,J)
      POS2(3,J)=VPOS(3,J)
  900 POS2(4,J)=VPOS(4,J)
C ---------------------------------- 
      DO 890 J=1,3
      WPOS(1,J)=POS(1,J)*0.529
      WPOS(2,J)=POS(2,J)*0.529
  890 CONTINUE
      DO 891 I=1,2
  891 WRITE(6,430) (WPOS(I,J), J=1,3)
C
C  SET PARAMETERS FOR 2ND LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
C    
C     LOOP THE PARAMETERS IN THE SECOND LAYER
      DO 975 JJ=1,1
C
      LPS(1)=1
      LPS(2)=1
      NTAU=1
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=8
      NOPT=2
      NEW=1
      CALL MTINV(ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,ROV,TOV,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,POS2,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,415)
C  ----------------------------------------------------------------
C  -----------------------------------------------------------------
C  PRODUCE DIFFRACTION MATRICES FOR THE 3RD LAYER (BUCKLED)
C  ------------------------------------------------------------------
C  -------------------------------------------------------------------
C  PUT IN THE THIRD LAYER GOEMETRY
C  -----------------------------------------------------------------
C
C
C
      DO 901 J=1,3
      POS3(1,J)=VPOS(5,J)
      POS3(2,J)=VPOS(6,J)
      POS3(3,J)=VPOS(7,J)
  901 POS3(4,J)=VPOS(8,J)
C
C     DO VARIATION IN THE UP AND DOWN DISPLACEMENT OF THE THIRD LAYER ATOM
      DO 977 II=1,1
C
      NEW=-1     
      NOPT=1
C
C
C
      DO 892 J=1,3
      WPOS(1,J)=POS3(1,J)*0.529
  892 WPOS(2,J)=POS3(2,J)*0.529
      DO 893 I=1,2
  893 WRITE(6,430) (WPOS(I,J),J=1,3)
C     
C
      CALL MTINV(ROU,TOU,ROM,TOM,ROU,TOU,ROU,TOU,ROU,TOU,ROU,TOU,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,POS3,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
C
C
C  NOW ADD THE 3RD LAYER (BUCKLED) ONTO THE SUBSTRATE, BY LAYER
C  DOUBLING.
C  AS1 BECOMES THE 3-D VECTOR FROM 3RD LAYER TO SUBSTRATE AND WILL BE
C  VARIED IN LOOP 970
      DO 931 J=1,3
  931 AS1(J)=VPOS(9,J)
C
      DO 970 IVAU=1,1
      DO 932 J=1,3
  932 AS(J)=AS1(J)*0.529
      WRITE(6,430)(AS(J),J=1,3)
C  RU BECOMES THE REFLECTION MATRIX FOR SUBSTRATE + 3RD LAYER
      CALL DBG(ROU,TOU,ROM,TOM,RS,RU,AS1,NT,0,PQ,NT,S1,S2,XS,PP,INT,
     1NT,EMACH)
C
C  NOW ADD THE 2ND LAYER (ROW PAIRING) ON TO THE SUBSTRATE+3RD LAYER
C  AS2 BECOMES THE 3-D VECTOR FROM THE 2ND LAUER TO THE SUBSTRATE
C
      DO 933 J=1,3
  933 AS2(J)=VPOS(10,J)
C
      DO 971 IVAR3=1,1
C     
      DO 934 J=1,3
  934 AS(J)=AS2(J)*0.529
      WRITE(6,430) AS
C
C RN BECOMES THE REFLECTION MATRIX FOR THE SUBSTRATE + 2ND LAYER
C     
      CALL DBG(ROV,TOV,ROV,TOV,RU,RN,AS2,NT,0,PQ,NT,S1,S2,XS,PP,INT,
     1NT,EMACH) 
C
C
C
C
C
C  ASV BECOMES THE 3-D VECTOR FROM TOP LAYER TO NEXT LAYER AND WILL BE
C  VARIED
      DO 937 J=1,3
  937 ASV(J)=ASB(J)
C
C  LOOP 960 VARIES THE SPACING ASV(1) BETWEEN THE TOP (COMPOSITE) LAYER
C  AND THE NEXT (SUBSTRATE) LAYER
      DO 960 I=1,NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      A=AS(1)
      WRITE (6,430) (AS(J),J=1,3)
C
C  ADD TOP LAYER BY LAYER DOUBLING
      CALL ADREF1(ROQ,TOQ,ROP,TOP,RN,S1,S2,XS,INT,XI,PQ,NT,EMACH,ASV)
C
C  GET INTENSITIES (AT) FROM AMPLITUDES (XI) AND OUTPUT
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
C
C
  960 ASV(1)=ASV(1)+STEP
  971 AS2(1)=AS2(1)+STEP
  970 AS1(1)=AS1(1)+STEP
      POS3(1,1)=POS3(1,1)+STEP
      POS3(2,1)=POS3(2,1)-STEP
      POS3(3,1)=POS3(3,1)-STEP
  977 POS3(4,1)=POS3(4,1)+STEP
      POS2(1,3)=POS2(1,3)-STEP
      POS2(2,3)=POS2(2,3)+STEP
      POS2(3,3)=POS2(3,3)-STEP
  975 POS2(4,3)=POS2(4,3)+STEP
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT                                                            4420
      IF (T-TF)  780, 780, 990                                              4430
C
  990 E = E + DE                                                            4440
      EC = E                                                                4450
      E3 = E                                                                4460
      IF (E-EF)  700, 700, 680                                              4470
 1000 WRITE (6,450)                                                         4480
      STOP                                                                  4490
      END                                                                   4500
 IR(110)+(2X2)2S, MISS ROW + 2S, 5 PS, TH=0, MIRR PL + GL PL(SAW1003A, LD3)
  2  2  2               IDEG NL1 NL2
  4 64 11               KNBS KNT NPUN
 11                     NPSI
 2.7170 0.0000          ARA1
 0.0000 3.8424          ARA2
 0.5000 0.5000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 1.3585 0.0000 0.0000   ASA
 5.4340 0.0000          ARB1
 0.0000 7.6848          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.3135 0.0000 0.0000   ASB
 0.5000 1.0000 0.050   FR ASE STEP
  1                     NSTEP
 19                     KNB(1)
 0.     0.      1  1    BEAMS
 0.     1.0000  2  2
 1.0000 0.      2  2
 1.0000 1.0000  9  9
 0.     2.0000  2  2
 1.0000 2.0000  9  9
 2.0000 0.      2  2
 2.0000 1.0000  9  9
 0.     3.0000  2  2
 1.0000 3.0000  9  9
 2.0000 2.0000  9  9
 0.     4.0000  2  2
 2.0000 3.0000  9  9
 3.0000 0.      2  2
 1.0000 4.0000  9  9
 3.0000 1.0000  9  9
 3.0000 2.0000  9  9
 2.0000 4.0000  9  9
 0.     5.0000  2  2
 17
 0.      .5000  2  2
 1.0000  .5000  9  9
 0.     1.5000  2  2
 1.0000 1.5000  9  9
 0.     2.5000  2  2
 2.0000  .5000  9  9
 1.0000 2.5000  9  9
 2.0000 1.5000  9  9
 0.     3.5000  2  2
 2.0000 2.5000  9  9
 1.0000 3.5000  9  9
 3.0000  .5000  9  9
 3.0000 1.5000  9  9
 2.0000 3.5000  9  9
 0.     4.5000  2  2
 1.0000 4.5000  9  9
 3.0000 2.5000  9  9
 13
  .5000 1.0000 49 49
  .5000 2.0000 49 49
 1.5000 1.0000 49 49
 1.5000 2.0000 49 49
  .5000 3.0000 49 49
 2.5000 1.0000 49 49
 1.5000 3.0000 49 49
 2.5000 2.0000 49 49
  .5000 4.0000 49 49
 1.5000 4.0000 49 49
 2.5000 3.0000 49 49
 3.5000 1.0000 49 49
  .5000 5.0000 49 49
 15
  .5000  .5000 49 49
  .5000 1.5000 49 49
 1.5000  .5000 49 49
 1.5000 1.5000 49 49
  .5000 2.5000 49 49
 1.5000 2.5000 49 49
 2.5000  .5000 49 49
  .5000 3.5000 49 49
 2.5000 1.5000 49 49
 1.5000 3.5000 49 49
 2.5000 2.5000 49 49
  .5000 4.5000 49 49
 3.5000  .5000 49 49
 2.5000 3.5000 49 49
 1.5000 4.5000 49 49
 0.0020                 TST
  1  2  3  4 20 21 22 23 37 50 51         NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  8                    LITER
  1  0  0               IT1 IT2 IT3
 280.0000 192.2000   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
 685.5300  32.0640   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPER3 DR03
 300.0000                                        TI TF DT
  6                     LMAX
  2                     NEL
 0.3676
 2.3699-0.2750-0.8449 0.0073 0.0003 0.0000 0.0000 0.0000 0.0000 0.0000 IR
 0.9640 3.9828 0.0466 0.0011 0.0000 0.0000 0.0000 0.0000               S
 0.5515
 2.1813-0.3964-0.6762 0.0269 0.0014 0.0001 0.0000 0.0000 0.0000 0.0000
 0.7256 4.1711 0.1337 0.0044 0.0001 0.0000 0.0000 0.0000
 0.7353
 2.0172-0.5030-0.7061 0.0669 0.0043 0.0002 0.0000 0.0000 0.0000 0.0000
 0.5349 4.2252 0.2609 0.0102 0.0006 0.0000 0.0000 0.0000
 1.1029
 1.7345-0.6893-0.8084 0.2310 0.0204 0.0017 0.0001 0.0000 0.0000 0.0000
 0.2549 4.1702 0.6452 0.0372 0.0029 0.0001 0.0000 0.0000
 1.4706
 1.4938-0.8555-0.8970 0.5053 0.0576 0.0063 0.0006 0.0000 0.0000 0.0000
 0.0206 4.0747 1.0322 0.0792 0.0075 0.0006 0.0000 0.0000
 2.0221
 1.1895-1.0811-1.0003 0.9196 0.1654 0.0241 0.0031 0.0003 0.0000 0.0000
-0.2073 3.9329 1.3242 0.1804 0.0233 0.0024 0.0003 0.0000
 2.9412
 0.7917-1.4029-1.1455 1.2503 0.4555 0.0970 0.0188 0.0030 0.0004 0.0000
-0.4956 3.7473 1.4804 0.3906 0.0782 0.0126 0.0015 0.0003
 4.0441
 0.4337-1.7092-1.3149 1.4021 0.7990 0.2452 0.0684 0.0158 0.0029 0.0004
-0.7442 3.5881 1.5706 0.5842 0.1783 0.0412 0.0074 0.0010
 4.9632
 0.1954-1.9147-1.4444 1.4627 1.0283 0.3758 0.1342 0.0396 0.0095 0.0018
-0.9074 3.4853 1.6176 0.6795 0.2672 0.0801 0.0184 0.0034
 6.0662
-0.0484-2.1238-1.5794 1.4903 1.2629 0.5092 0.2231 0.0845 0.0260 0.0065
-1.0760 3.3770 1.6483 0.7560 0.3549 0.1369 0.0399 0.0092
 6.9853
-0.2272-2.2780-1.6786 1.4955 1.4239 0.6057 0.2915 0.1300 0.0479 0.0143
-1.2158 3.2872 1.6731 0.8186 0.4273 0.1846 0.0581 0.0140
  4                     NLAY
 0.0000 1.3585 1.9999   FPOS(1,J)
 0.0000-1.3585-1.9999   FPOS(2,J)
 0.8888 0.0000 0.0000   FPOS(3,J)
 0.8888 2.7170 0.0000   FPOS(4,J)
 11                     NVAR
 0.0000-1.3585-1.9712   VPOS(1,J)
 0.0000-1.3585 1.9712   VPOS(2,J)
 0.0000 1.3585-1.9712   VPOS(3,J)
 0.0000 1.3585 1.9712   VPOS(4,J)
 0.0000 0.0000 0.0000   VPOS(5,J)
-0.0050 0.0000 3.8424   VPOS(6,J)
-0.0050 2.7170 3.8424   VPOS(7,J)
 0.0000 2.7170 0.0000   VPOS(8,J)
 1.3585 0.0000 0.0000   VPOS(9,J)
 1.3769 0.0000 0.0000   VPOS(10,J)
 0.9360 0.0000 1.7230   VPOS(11,J)
  2                     NATAU
  2  2  1  1            LPS
  4                     NINV
  0  0  0  0            INV
140.00  185.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C  --- M4.6.1
C
C     PROGRAM P42CO(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,       160784
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA FCC(111)+C(4X2)2CO, APPROX. RSP+RFS,(XZ) MIRR.PL.
C  MAIN LEED PROGRAM FOR A C(4X2) 4 ATOM/UNIT CELL OVERLAYER ON A FCC(111)
C  SURFACE, WITH APPROX. RSP IN THE OVERLAYER. THE (XZ) PLANE IS MIRROR
C  PLANE. RENORMALIZED FORWARD SCATTERING IS USED TO STACK LAYERS.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASI(3,10),STPS(3,10,2),
     3NSTS(10,2)
C  4=NL, 66=KLM
      COMPLEX VL(4,2),FLMS(4,66),FLM(66)
C  4=NL, 2=IDEG
      DIMENSION V(4,2),JJS(4,2)
C  3=KNBS=NO. OF BEAM SETS READ IN, 67=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(3),NB(3),SPQF(2,67),SPQ(2,67),PQF(2,67),PQ(2,67)
      INTEGER KSYM(2,67),SYM(2,67)
C  106 MUST BE .GE. NPUN
      DIMENSION NPU(106),NPUC(106)
C  12=NPSI, 18=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,18)
C  4(1ST DIM)=NLAY, 20,12,7 FIXED, 1820=NCAA FROM DATA STATEMENT
      DIMENSION FPOS(4,3),VPOS(20,3),LPS(20),INV(20),LPSS(20),NCA(7)
      DIMENSION CAA(1820)
C  4=NLAY
      DIMENSION POSS(4,3),MGH(4,4)
C  6=NLAY2
      DIMENSION DRL(6,3),SDRL(6,3),NUGH(6),NGEQ(6),NGOL(6)
      DIMENSION TEST(6)
C  1925=NLM FROM DATA STATEMENT, 121=NN, 11=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(1925),YLM(121),FAC2(121),FAC1(11)
C  11=NN1, 6=NN2, 6=NN3
      DIMENSION PPP(11,6,6)
C  36=LMMAX
      DIMENSION LX(36),LXI(36),LXM(36),LT(36)
C  6=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(6),CAF(6),TSF0(6,10),TSF(6,10),AF1(6),CAF1(6)
      COMPLEX ROP(67,67),TOP(67,67),ROM(67,67),TOM(67,67)
C  31=KNP
      COMPLEX RA1(67,31),TA1(67,31)
C  72=LMT, 432(IN GH)=LMG, 4(2ND DIM IN RG)=NLAY, 144(IN TS)=LMN,
C  288(IN TG)=LM2N
      COMPLEX RG(3,4,67),VT(288),TS(144)
      COMPLEX TAU(72,1),TAUG(72),TAUGM(72),GH(432,36),
     1TG(2,288)
C  21=LEV, 42=LEV2, 15=LOD
      COMPLEX AMULT(67),CYLM(67,36),XEV(21,21),XOD(15,15),
     1YLME(21),YLMO(15)
      DIMENSION IPLE(21),IPLO(15),AT(67)
C  8 FIXED, 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(67),PK(67,8),AW(67,2),ANEW(67,20)
C  FOR CDC ONLY  *********************************
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROP,TOP,ROM,TOM,RA1,TA1
C     COMMON /BIG/ GH,TH,TAU,XEV,XOD,ROP,TOP,ROM,TOM,RA1,TA1
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPTA/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF,IAPX
      COMMON/NST/NST1,ASI,STPS,NSTS,NACV
      COMMON/ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     *IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN
     * ,BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  170 FORMAT(3F7.4,2(I3,3F7.4))
  171 FORMAT(7H ASI = ,3F8.4,/,2(10X,7HNSTS = ,I3,8H STPS = ,3F8.4,/))
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  417 FORMAT(10H MKINY  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
      WRITE(8,465)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY= NO. OF SUBPLANES IN COMPOSITE LAYER (0, IF NO COMP. LAYER)
C  NST1= NO. OF SETS OF GEOMETRIES IN SCAN OVER INTERLAYER VECTORS (SEE
C        ROUTINE GEOMV)
C  ISCAN= NO. OF GEOMETRIES IN SCAN OVER MOLECULAR STRUCTURES
C         (SEE ROUTINE GEOMV)
      READ(5,200)NLAY,NST1,ISCAN
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
      WRITE (8,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUMS IN FMAT. ASSUME SAME MUFFIN-TIN CONSTANTS
C  AND DAMPINGS IN SUBSTRATE AND ADLAYER
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C
C
C  CONSIDER SUBSTRATE LAYERS FIRST
C  PRODUCE ATOMIC T-MATRIX ELEMENTS
      CALL TSCATF(3,L1,ES,PHSS,NPSI,IT3,E,0.,PPP,NN1,NN2,NN3,DR03,
     1DRPER3,DRPAR3,T0,T,TSF0,TSF,AF,CAF)
      DRPER=DRPER3
      DRPAR=DRPAR3
      DR0=DR03
      IT=0
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C  PRODUCE REFLECTION (RA1) AND TRANSMISSION (TA1) MATRICES FOR
C  ATOMIC LAYERS. 1 REGISTRY- ID=1. NLL=NL=4 SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRIES APPLY - LAY=2. TEMPERATURE-DEPENDENT
C  PHASE SHIFTS- CAF
C  FIRST BEAM SET FIRST (NAA BEAMS)
  930 NAA = NB(1)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND (AND 3RD) BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS
C  NA=NS=NAA)
      NBB=NB(2)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  FOURTH BEAM SET NEXT (NCC BEAMS. OFFSETS NA=NS=NAA+NBB)
      N=NAA+NBB
      NCC=NB(3)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NCC,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  N,  N,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF1,CAF1)
C  SET PARAMETERS FOR COMPOSITE LAYER (OVERLAYER)
C  ONLY 1 REGISTRY (ID=1), OVERLAYER SYMMETRIES (LAY=1)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=2.0/0.529
      EPSN=0.01
      NPERT=5
      NOPT=1
      NEW=1
      IAPX=2
C  SCAN OVER STRUCTURES WITHIN OVERLAYER
      DO 975 ISC=1,ISCAN
      CALL GEOMV(ISC,0,FPOS,NLAY,0,ASV)
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE COMPOSITE
C  OVERLAYER BY RSP, NEGLECTING INTRA-SUBPLANE MULT.SCATT. AND
C  BETWEEN ATOMS SEPARATED BY MORE THAN 2A (IAPX=2 AND DCUT=2A)
      CALL MPERTA(ROP,TOP,ROM,TOM,ROP,TOP,ROP,TOP,ROP,TOP,ROP,TOP,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,KLM,XEV,
     2LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,
     3FPOS,POSS,MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,GH,LMG,
     4RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1,1)
      WRITE(6,415)
      NEW=-1
C
C
C  NOW STACK LAYERS
C  ASV BECOMES VECTOR BETWEEN OVERLAYER AND SUBSTRATE
      DO 970 NSC=1,NACV
      CALL GEOMV(0,1,FPOS,NLAY,NSC,ASV)
      A=ASV(1)*0.529
C
C  COMPUTE REFLECTED BEAM AMPLITUDES BY RFS
      CALL RFSO3(ROP,TOP,ROM,TOM,RA1,TA1,RA1,TA1,RA1,TA1,NT,NB,KNBS,
     1NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH A ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
C     CALL RFSO3(ROM,TOM,ROP,TOP,RA1,TA1,RA1,TA1,RA1,TA1,NT,NB,KNBS,
C    1NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH A ALSO FOR LATER IDENTIFICATION)
C     CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  970 CONTINUE
  975 CONTINUE
C
C
      WRITE(8,370)E,EEV
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 PT(111)+C(4X2)2CO,RSP+RFS,(XZ) MIRR.PL.
  2  1  4               IDEG NL1 NL2
  3 67 54               KNBS KNT NPUN
 12                     NPSI
 1.3873-2.4029          ARA1
 1.3873 2.4029          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.2655 0.0000 1.6019   ASA
 5.5492 0.0000          ARB1
 0.0000 4.8058          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 2.0000 0.0000 0.0000   ASB
 0.5000 0.6000 0.0000   FR ASE STEP
  0                     NSTEP
 18                     KNB(1)
 0.     0.      1  1
 0.     1.0000  6  6
 0.    -1.0000  6  6
-1.0000 1.0000  1  1
 1.0000-1.0000  1  1
 1.0000 1.0000  6  6
-1.0000 2.0000  6  6
 1.0000-2.0000  6  6
 0.     2.0000  6  6
 0.    -2.0000  6  6
-2.0000 2.0000  1  1
 2.0000-2.0000  1  1
 1.0000 2.0000  6  6
-1.0000-2.0000  6  6
-1.0000 3.0000  6  6
 1.0000-3.0000  6  6
-2.0000 3.0000  6  6
 2.0000-3.0000  6  6
 31                     KNB(2)
  .2500  .2500  6  1
 -.7500  .2500  6  1
  .2500 -.7500  6  1
 -.7500 1.2500  6  1
 1.2500 -.7500  6  1
 -.7500 -.7500  6  1
  .2500 1.2500  6  1
 1.2500  .2500  6  1
-1.7500 1.2500  6  1
 1.2500-1.7500  6  1
-1.7500  .2500  6  1
  .2500-1.7500  6  1
 -.7500 2.2500  6  1
 2.2500 -.7500  6  1
-1.7500 2.2500  6  1
 2.2500-1.7500  6  1
 1.2500 1.2500  6  1
-1.7500 -.7500  6  1
 -.7500-1.7500  6  1
  .2500 2.2500  6  1
 2.2500  .2500  6  1
-2.7500 1.2500  6  1
 1.2500-2.7500  6  1
-2.7500 2.2500  6  1
 2.2500-2.7500  6  1
-2.7500  .2500  6  1
  .2500-2.7500  6  1
-1.7500 3.2500  6  1
 3.2500-1.7500  6  1
 -.7500 3.2500  6  1
 3.2500 -.7500  6  1
 18                     KNB(3)
 -.5000  .5000  1  1
  .5000 -.5000  1  1
  .5000  .5000  6  6
 -.5000 1.5000  6  6
  .5000-1.5000  6  6
-1.5000 1.5000  1  1
 1.5000-1.5000  1  1
  .5000 1.5000  6  6
 -.5000-1.5000  6  6
-1.5000 2.5000  6  6
 1.5000-2.5000  6  6
 -.5000 2.5000  6  6
  .5000-2.5000  6  6
-2.5000 2.5000  1  1
 2.5000-2.5000  1  1
 1.5000 1.5000  6  6
  .5000 2.5000  6  6
 -.5000-2.5000  6  6
 0.0020                 TST
  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26
 27 28 29 30 31 32 33 34 35 36 37 38 39 50 51 52 53 54 55 56 57 58 59 60 61 62
 63 64    NPU
   0.00   0.00          THETA FI
   0.00  14.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  1               IT1 IT2 IT3
1404.9675  12.0112   2.0000   2.0000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
1217.3280  15.9994   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
 302.0000 195.0900   1.4000   1.4000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 150.0000                                        TI TF DT
  5                     LMAX
  3                     NEL
  .3000
 1.5917-3.9436  .0031  .0000  .0000  .0000  .0000  .0000  .0000  .0000  C
-1.1163 -.4218  .0014  .0000  .0000  .0000  .0000  .0000  .0000  .0000  O
 -.7327 -.2348  .8943  .0029  .0001  .0000  .0000  .0000  .0000  .0000  PT SWW
  .4000
 1.4461-3.9485  .0062  .0001  .0000  .0000  .0000  .0000  .0000  .0000
-1.2556 -.4845  .0029  .0000  .0000  .0000  .0000  .0000  .0000  .0000
 -.8472 -.3102 2.0844  .0074  .0003  .0000  .0000  .0000  .0000  .0000
  .5000
 1.3281-3.9767  .0108  .0002  .0000  .0000  .0000  .0000  .0000  .0000
-1.3712 -.5393  .0051  .0001  .0000  .0000  .0000  .0000  .0000  .0000
 -.9490 -.3793 2.3386  .0153  .0007  .0000  .0000  .0000  .0000  .0000
  .7500
 1.1005-4.0665  .0290  .0007  .0000  .0000  .0000  .0000  .0000  .0000
-1.5981 -.6541  .0137  .0002  .0000  .0000  .0000  .0000  .0000  .0000
-1.1688 -.5305 2.3921  .0555  .0035  .0002  .0000  .0000  .0000  .0000
 1.0000
  .9270-4.1547  .0584  .0017  .0000  .0000  .0000  .0000  .0000  .0000
-1.7720 -.7485  .0278  .0006  .0000  .0000  .0000  .0000  .0000  .0000
-1.3570 -.6600 2.3398  .1349  .0107  .0008  .0000  .0000  .0000  .0000
 1.5000
  .6625-4.3074  .1544  .0064  .0002  .0000  .0000  .0000  .0000  .0000
-2.0353 -.9003  .0749  .0023  .0001  .0000  .0000  .0000  .0000  .0000
-1.6754 -.8833 2.2242  .4291  .0473  .0050  .0005  .0000  .0000  .0000
 2.0000
  .4596-4.4309  .2967  .0160  .0008  .0000  .0000  .0000  .0000  .0000
-2.2350-1.0203  .1500  .0059  .0002  .0000  .0000  .0000  .0000  .0000
-1.9403-1.0790 2.1311  .7927  .1246  .0172  .0021  .0002  .0000  .0000
 3.0000
  .1540-4.6112  .6224  .0555  .0040  .0002  .0000  .0000  .0000  .0000
-2.5333-1.1996  .3759  .0213  .0011  .0000  .0000  .0000  .0000  .0000
-2.3610-1.4138 1.9791 1.2037  .3945  .0798  .0150  .0023  .0003  .0000
 4.0000
 -.0708-4.7234  .8338  .1262  .0121  .0009  .0001  .0000  .0000  .0000
-2.7534-1.3232  .6301  .0513  .0035  .0002  .0000  .0000  .0000  .0000
-2.6821-1.6855 1.8360 1.3608  .6983  .1932  .0496  .0107  .0019  .0003
 5.0000
 -.2423-4.7849  .9157  .2238  .0277  .0026  .0002  .0000  .0000  .0000
-2.9246-1.4062  .8174  .0984  .0085  .0006  .0000  .0000  .0000  .0000
-2.9405-1.9081 1.7014 1.4397  .9531  .3249  .1077  .0300  .0069  .0013
 6.0000
 -.3743-4.8110  .9283  .3326  .0524  .0060  .0005  .0000  .0000  .0000
-3.0610-1.4581  .9203  .1622  .0169  .0014  .0001  .0000  .0000  .0000
-3.1591-2.0965 1.5809 1.4768 1.1701  .4457  .1791  .0619  .0176  .0041
 7.0000
 -.4760-4.8175  .9108  .4326  .0871  .0118  .0012  .0001  .0000  .0000
-3.1710-1.4869  .9645  .2385  .0297  .0028  .0002  .0000  .0000  .0000
-3.3507-2.2619 1.4735 1.4903 1.3551  .5510  .2507  .1033  .0356  .0101
  4  1  5               NLAY NST1 ISCAN
 0.0000-0.0000 0.0000   FPOS(1,J)
 0.0000 0.0000 0.0000   FPOS(2,J)
 0.0000 0.0000 0.0000   FPOS(3,J)
 0.0000 0.0000 0.0000   FPOS(4,J)
  0                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  2                     NTAU
  1  2  1  2            LPS
  0                     NINV
  0  0  0  0            INV
  5                     NATOMS
406   1 2.7746   2  90.000000   3   0.000000        IANZ Z BLS Z ALPHAS Z BETAS
508   4 1.1500   1  90.000000   2 180.000000
000   1 2.4029   2  90.000000   3  90.000000
706   6 0.2500   1  90.000000   2 180.000000
808   7 1.1500   6 180.000000   1   0.000000
 400.00 400.00 400.00   PHIR PHIM1 PHIM2
 7                                0.0500 IPAR DX
 1.4000 0.0000-2.4029  1 0.0000 0.0000 0.0000  4 0.1000 0.0000 0.0000 BRIDGE
  20.00 176.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C
C  --- M4.7.1
C
C
C     PROGRAM R42EC(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA FCC(111)+C(4x2)C2(H3)+CO,BSN+M INV+KSLA+RFS,(XZ) M.PL.
C  MAIN LEED PROGRAM FOR A C(4x2) 4 ATOM/UNIT CELL OVERLAYER ON A
C  FCC(111) SURFACE, WITH M INV AND KIN. SUBL. ADD.(KSLA) FOR
C  THE OVERLAYER. AN (XZ) MIRROR PLANE IS ASSUMED.
C  RENORMALIZED FORWARD SCATTERING IS USED TO STACK LAYERS.
C  BEAM SET NEGLECT IS APPLIED.
C  OVERLAYER IS HANDLED AS ONE CC SUBLAYER (1 ETHYLIDYNE/CELL) AND ONE
C  CO SUBLAYER REQUIRING 2 SEPARATE MATRIX INVERSION CALCULATIONS.
C  READCL ENTERS ETHYLIDYNE STRUCTURES THROUGH FPOSF,VPOSF, CO INTERNAL
C  STRUCTURE THROUGH FPOSG, RELATIVE MOLECULAR POSITIONS THROUGH VPOSG.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASI(3,10),STPS(3,10,2),
     3NSTS(10,2),ASS(3,1)
      DIMENSION DRPERI(6),DRPARI(6),DR0I(6),ITI(6),NPSI(6),AR(3,2,1),
     1AD(3,2,1),AL(3,1),NRTK(2,1),ML(2),NRTNP(1),NRTP(1)
C  4=NL, 66=KLM
      COMPLEX VL(4,2),FLMS(4,66),FLM(66)
C  4=NL, 2=IDEG
      DIMENSION V(4,2),JJS(4,2)
C  3=KNBS=NO. OF BEAM SETS READ IN, 67=KNT=NO. OF BEAMS READ IN
C  49=KNTB=KNB(1)+KNP
      DIMENSION KNB(3),NB(3),SPQF(2,67),SPQ(2,67),PQF(2,67),PQ(2,67)
      INTEGER KSYM(2,67),SYM(2,67),PQB(2,49),PQFB(2,49),SYMB(2,49),
     1 NBS(2)
C  106 MUST BE .GE. NPUN
      DIMENSION NPU(106),NPUC(106)
C  15,6,48 FIXED
      DIMENSION ES(15,6),PHSS(15,48)
C  2=NLAYF, 2=NLAYG, 20,7 FIXED, 1820=NCAA FROM DATA STATEMENT
      DIMENSION LPS(20),INV(20),FPOS(2,3)
      DIMENSION FPOSF(2,3),VPOSF(20,3),LPSF(20),INVF(20),LPSS(20),NCA(7)
      DIMENSION LPSG(20),INVG(20),VPOSG(20,3),FPOSG(2,3)
      DIMENSION CAA(1820)
C  2=NLAYF, 2=NLAYG
      DIMENSION POSS(2,3),MGHF(2,2),MGHG(2,2)
C  1=NLAY2F, 1=NLAY2G
      DIMENSION DRLF(1,3),SDRLF(1,3),NUGHF(1),NGEQF(1),NGOLF(1)
      DIMENSION DRLG(1,3),SDRLG(1,3),NUGHG(1),NGEQG(1),NGOLG(1)
      DIMENSION TEST(1)
C  1925=NLM FROM DATA STATEMENT, 121=NN, 11=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(1925),YLM(121),FAC2(121),FAC1(11)
C  11=NN1, 6=NN2, 6=NN3
      DIMENSION PPP(11,6,6)
C  36=LMMAX
      DIMENSION LX(36),LXI(36),LXM(36),LT(36)
C  6=LMAX+1=L1, 6 AND 10 FIXED FOR COMMON /MPTA/
      COMPLEX AF(6),CAF(6),TSF0(6,10),TSF(6,10)
      COMPLEX RIP(49,49,2),TIP(49,49,2),RIM(49,49,2),TIM(49,49,2)
C 31=KNP
      COMPLEX RA1(49,31),TA1(49,31)
C  108=LMT, 72(IN GHF)=LMGRF, 2,2(2ND DIM IN RGF,G)=NLAYF,G, 72(IN TS)=LMNF,
C  144(IN TG,VT)=LM2NF, 72(IN GHG)=LMGRG, 108(IN TAUG,TAUGM)=LTAUG
C  72 (IN TH,IPL)=MAX(LMNIF,LMNIG)
      COMPLEX RGF(3,2,49),RGG(3,2,49),VT(144),TS(72)
      COMPLEX TAU(108,1),TAUG(108),TAUGM(108),GHF(72,36),
     1TG(2,144),GHG(72,36),TH(72,72)
C  21=LEV, 42=LEV2, 15=LOD
      COMPLEX AMULT(49),CYLM(49,36),XEV(21,42),XOD(15,15),
     1YLME(21),YLMO(15)
      DIMENSION IPLE(21),IPLO(15),AT(49),ATS(67,48),AAA(48),IPL(72)
C  8=MAX(MNPP,8), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(49),PK(49,16),AW(49,2),ANEW(49,20)
C  FOR CDC ONLY  *********************************
C     LEVEL 2, GHF,GHG,TH,TAU,XEV,XOD,RIP,TIP,RIM,TIM,
C    1RA1,TA1
C     COMMON /BIG/ TH,TAU,XEV,XOD,RIP,TIP,RIM,TIM,RA1,TA1
C     COMMON /BIG2/ GHF,GHG
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMPT/ES,PHSS,TI,TF,DT,T01,DRPERI,DRPARI,DR0I,ITI,NPSI
      COMMON /MPTA/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF,IAPX
      COMMON/NST/NST1,ASI,STPS,NSTS,NACV
      COMMON/ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     *IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN
     * ,BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  170 FORMAT(3F7.4,2(I3,3F7.4))
  171 FORMAT(7H ASI = ,3F8.4,/,2(10X,7HNSTS = ,I3,8H STPS = ,3F8.4,/))
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  417 FORMAT(10H MKINY  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
      CALL LINK("unit5=(data,open,text),
     1           unit6=(output,create,hc),
     2           unit7=(name7,create,text),
     3           unit8=(name8,create,hc)//")
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
      WRITE(8,465)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG  EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2  SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIT(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NATH,L1)
      T0=T01
C  READ IN ADDITIONAL DATA FOR ONE SUBLAYER OF COMPOSITE LAYER
C  NLAYF= NO. OF SUBPLANES IN ONE SUBLAYER OF COMPOSITE LAYER
C  NST1F= NO. OF SETS OF GEOMETRIES IN SCAN OVER INTERLAYER VECTORS (SEE
C        ROUTINE GEOMV)
C  ISCANF= NO. OF GEOMETRIES IN SCAN OVER MOLECULAR STRUCTURES
C         (SEE ROUTINE GEOMV)
      READ(5,200)NLAYF,NST1F,ISCANF
      NST1=NST1F
      ISCAN=ISCANF
      CALL READCL(NLAYF,NLAY2F,FPOSF,VPOSF,NVARF,NTAU,LPSF,NINVF,INVF,
     1LMMAX,LMGF,LMNF,LM2NF,LMT,LTAUG,LMNIF,LMNI2F)
C  READ IN ADDITIONAL DATA FOR OTHER SUBLAYER OF COMPOSITE LAYER
      READ(5,200)NLAYG,NST1G,ISCANG
      NST1=NST1G
      ISCAN=ISCANG
      CALL READCL(NLAYG,NLAY2G,FPOSG,VPOSG,NVARG,NTAU,LPSG,NINVG,INVG,
     1LMMAX,LMGG,LMNG,LM2NG,LMT,LTAUG,LMNIG,LMNI2G)
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM  PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      DO 635 I=1,NATH
  635 IF (ITI(I).EQ.1) GO TO 640
      GO TO 650
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP; IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
      WRITE (8,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUMS IN FMAT. ASSUME SAME MUFFIN-TIN CONSTANTS
C  AND DAMPINGS IN SUBSTRATE AND ADLAYER
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      E=EC-VO
      E3=E
      CALL TSCATT(2,1,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(2),DRPERI(2),DRPARI(2),T0,T,TSF0,TSF,AF,CAF)
      CALL TSCATT(3,2,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(3),DRPERI(3),DRPARI(3),T0,T,TSF0,TSF,AF,CAF)
      CALL TSCATT(4,3,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(4),DRPERI(4),DRPARI(4),T0,T,TSF0,TSF,AF,CAF)
C
C
C  CONSIDER SUBSTRATE LAYERS
C  PRODUCE ATOMIC T-MATRIX ELEMENTS.
C  AF AND CAF ARE OVERWRITTEN, BUT NOT TSF0 AND TSF
      E=EC
      E3=E
      CALL TSCATT(1,4,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(1),DRPERI(1),DRPARI(1),T0,T,TSF0,TSF,AF,CAF)
      DRPER=DRPERI(1)
      DRPAR=DRPARI(1)
      DR0=DR0I(1)
      IT=0
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C
C
C  APPLY BSN APPROXIMATION
C
C  PRODUCE REFLECTION (RA1) AND TRANSMISSION (TA1) MATRICES FOR
C  ATOMIC LAYERS. 1 REGISTRY- ID=1. NLL=NL=8 SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRIES APPLY- LAY=2. TEMPERATURE-DEPENDENT
C  PHASE SHIFTS- CAF
C  FIRST BEAM SET FIRST- INT.-ORDER BEAMS (NAA BEAMS)
      NAA = NB(1)
      NAA1=NAA+1
      NTP=NB(1)+NP
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,
     1RA1,TA1,NAA,NTP,NP,AMULT,CYLM,
     1PQ,SYM,NAA,FLMS,FLM,V,NL,  0,  0,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  START BSN LOOP OVER FRACT.-ORDER BEAM SETS (NORMALLY STARTS WITH
C  NBSN=2)
      DO 978 NBSN=2,KNBS
      WRITE(6,892)NBSN,KNBS
      WRITE(8,892)NBSN,KNBS
  892 FORMAT(13H0BSN LOOP NO.,1I3,7H OUT OF,1I3,6H LOOPS)
C  IAPX WILL BE USED BY MPERTA/MTINVA, AFTER MODIFICATION BY BSN1
      IAPX=2
      CALL BSN1(NBSN,PQ,PQF,SYM,NT,PQB,PQFB,SYMB,NTB,NB,KNBS,NBS,IAPX)
      IF (NBSN.EQ.1) GO TO 900
C
C
C  NEXT, REFLECTION AND TRANSMISSION MATRICES FOR SUBSTRATE LAYERS FOR
C  ONE FRACT.-ORDER BEAM SET (MAY BE SYMMETRIZED)
      NBB=NB(NBSN)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,
     1RA1,TA1,NBB,NTP,NP,AMULT(NAA1),
     1CYLM(NAA1,1),PQB,SYMB,NTP,FLMS,FLM,V,NL,NAA,NAA,1,NL,CAF,CAF,L1,
     2LX,LXI,LMMAX,KLM,XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,
     3CLM,NLM,2)
      WRITE (6,410)
C
C
C  SET PARAMETERS FOR COMPOSITE OVERLAYER
C  ONLY 1 REGISTRY (ID=1), OVERLAYER SYMMETRIES (LAY=1)
  900 NA=NAA
      IF (NBSN.EQ.1) NA=0
      E=EC-VO
      E3=E
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=2.0/0.529
      EPSN=0.01
      NPERT=5
C  START WITH ONE SUBLAYER, GEOMETRY DEFINED BY FPOSG
      NOPT=1
      NINV=0
      DO 910 I=1,NLAYG
      INV(I)=INVG(I)
  910 LPS(I)=LPSG(I)
      CALL RMPRT(FPOSG,NLAYG,3,5HFPOSG)
C  COMPUTE REFL. AND TRANSM. MATRICES FOR ONE SUBLAYER WITH PARTIAL
C  MULT. SCATT. (MPERTA) OR FULL MULT. SCATT. (MTINVA)
      MOFF2=NTP*NTP+1
C     CALL MPERTA(RIP(MOFF2),TIP(MOFF2),RIM(MOFF2),TIM(MOFF2),
C    1RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,
C    1NTB,NTP,NTP,AMULT,CYLM,PQB,SYMB,NTB,FLMS,NL,LX,LXI,
C    2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,
C    3FPOSG,POSS,MGHG,NLAYG,DRLG,SDRLG,NUGHG,NGEQG,NGOLG,NLAY2G,TEST,
C    4GHG,LMGG,RGG,TS,LMNG,TG,LM2NG,VT,CAA,NCAA,TH,1,1)
C     WRITE(6,415)
      NINV=NINVG
      CALL MTINVA(RIP(MOFF2),TIP(MOFF2),RIM(MOFF2),TIM(MOFF2),
     1RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,
     1NTB,NTP,NTP,AMULT,CYLM,PQB,SYMB,NTB,FLMS,NL,LX,LXI,
     2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,
     3FPOSG,POSS,MGHG,NLAYG,DRLG,SDRLG,NUGHG,NGEQG,NGOLG,NLAY2G,TEST,
     4GHG,LMGG,RGG,TS,LMNG,TG,LM2NG,VT,CAA,NCAA,TH,LMNIG,IPL)
      WRITE(6,416)
c     call imprt(ntb,1,1,3hntb)
c     call imprt(ntp,1,1,3hntp)
c     call imprt(nughg,1,nlay2g,5hnughg)
c     call imprt(ngeqg,1,nlay2g,5hngeqg)
c     call imprt(ngolg,1,nlay2g,5hngolg)
c     call imprt(mghg,nlayg,nlayg,4hmghg)
c     call rmprt(pqb,2,ntp,3hpqb)
c     call rmprt(drlg,nlay2g,3,4hdrlg)
c     call rmprt(sdrlg,nlay2g,3,5hsdrlg)
c     call cmprt(rip(moff2),ntp,ntp,4hrip2)
c     call cmprt(tip(moff2),ntp,ntp,4htip2)
c     call cmprt(rim(moff2),ntp,ntp,4hrim2)
c     call cmprt(tim(moff2),ntp,ntp,4htim2)
c     call cmprt(amult,ntp,1,5hamult)
c     call cmprt(cylm,ntp,2,4hcylm)
c     call cmprt(tau,lmt,1,3htau)
c     call cmprt(ghg,lmgg,2,3hghg)
c     call cmprt(rgg,18,4,3hrgg)
c     call cmprt(th,lmnig,4,2hth)
C
C  NEXT OTHER SUBLAYER, WHOSE INTERNAL STRUCTURE MAY VARY (LOOP 975)
      NOPT=1
      NINV=0
      DO 915 I=1,NLAYF
      DO 916 J=1,3
  916 FPOS(I,J)=FPOSF(I,J)
      INV(I)=INVF(I)
  915 LPS(I)=LPSF(I)
      NSTR=0
      DO 975 IVARF=1,NVARF
      FPOS(2,1)=FPOSF(2,1)+(IVARF-1)*VPOSF(4,1)
      CALL RMPRT(FPOS,NLAYF,3,4HFPOS)
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE OTHER SUB-
C  LAYER WITH PARTIAL MULT. SCATT. (MPERTA)
C  OR FULL MULT. SCATT. (MTINVA)
C     CALL MPERTA(RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,
C    1NTB,NTP,NTP,AMULT,CYLM,PQB,SYMB,NTB,FLMS,NL,LX,LXI,
C    2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,
C    3FPOS,POSS,MGHF,NLAYF,DRLF,SDRLF,NUGHF,NGEQF,NGOLF,NLAY2F,TEST,
C    4GHF,LMGF,RGF,TS,LMNF,TG,LM2NF,VT,CAA,NCAA,TH,1,1)
C     WRITE(6,415)
      NINV=NINVF
      CALL MTINVA(RIP,TIP,RIM,TIM,RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,
     1NTB,NTP,NTP,AMULT,CYLM,PQB,SYMB,NTB,FLMS,NL,LX,LXI,
     2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,
     3FPOS,POSS,MGHF,NLAYF,DRLF,SDRLF,NUGHF,NGEQF,NGOLF,NLAY2F,TEST,
     4GHF,LMGF,RGF,TS,LMNF,TG,LM2NF,VT,CAA,NCAA,TH,LMNIF,IPL)
      WRITE(6,416)
c     call imprt(ntb,1,1,3hntb)
c     call imprt(ntp,1,1,3hntp)
c     call imprt(nughf,1,nlay2f,5hnughf)
c     call imprt(ngeqf,1,nlay2f,5hngeqf)
c     call imprt(ngolf,1,nlay2f,5hngolf)
c     call imprt(mghf,nlayf,nlayf,4hmghf)
c     call rmprt(pqb,2,ntp,3hpqb)
c     call rmprt(drlf,nlay2f,3,4hdrlf)
c     call rmprt(sdrlf,nlay2f,3,5hsdrlf)
c     call cmprt(rip,ntp,ntp,4hrip1)
c     call cmprt(tip,ntp,ntp,4htip1)
c     call cmprt(rim,ntp,ntp,4hrim1)
c     call cmprt(tim,ntp,ntp,4htim1)
c     call cmprt(amult,ntp,1,5hamult)
c     call cmprt(cylm,ntp,2,4hcylm)
c     call cmprt(tau,lmt,1,3htau)
c     call cmprt(ghf,lmgf,2,3hghf)
c     call cmprt(rgf,18,4,3hrgf)
c     call cmprt(th,lmnif,4,2hth)
C
C
C  SCAN OVER STRUCTURES WITHIN COMPOSITE OVERLAYER BY KINEMATIC ADDITION
C  OF SUBLAYERS (LOOP 972)
      ML(1)=2
      ML1=ML(1)
      NRTK(1,1)=-1
      NRTK(2,1)=-2
      NRTNP(1)=-1
      NRTP(1)=101
      DO 972 IVARG=1,NVARG
      DO 930 J=1,3
      AD(J,1,1)=FPOS(1,J)-FPOS(2,J)
      AD(J,2,1)=FPOSG(1,J)-FPOSG(2,J)
      DO 920 I=1,ML1
      AR(J,I,1)=VPOSG(I,J)
  920 CONTINUE
  930 CONTINUE
      AR(1,2,1)=VPOSG(2,1)+(IVARG-1)*VPOSG(3,1)
      A=0.
      IK=1
      DO 935 I=1,ML1
      AP=AR(1,I,1)+AD(1,I,1)
      IF (AP.LT.A) GO TO 935
      IK=I
      A=AP
  935 CONTINUE
      DO 940 J=1,3
C 940 AL(J,1)=AR(J,IK,1)+AD(J,IK,1)
  940 AL(J,1)=0.
      AL(1,1)=A
      CALL RMPRT(AR,3,ML1,2HAR)
      CALL RMPRT(AD,3,ML1,2HAD)
      CALL RMPRT(AL,1,3,2HAL)
C
C
C  NOW STACK LAYERS
      NLR=2
      IF (NBSN.EQ.1) NLR=1
C  SUBSTRATE INTERLAYER VECTORS
      DO 950 I=1,3
      DO 950 J=1,1
  950 ASS(I,J)=ASA(I)
C  ASV BECOMES VECTOR BETWEEN OVERLAYER AND SUBSTRATE
      NST1=NST1F
      DO 970 NSC=1,NACV
      CALL GEOMV(0,1,FPOSF,NLAYF,NSC,ASV)
      A=ASV(1)*0.529
C
C  COMPUTE REFLECTED BEAM AMPLITUDES BY RFS
      CALL RFSK(RIP,TIP,RIM,TIM,RIP,TIP,RIM,TIM,RA1,TA1,RA1,TA1,NTP,NP,
     11,1,2,NRTNP,1,
     2NRTP,1,NTB,NBS,NLR,XI,PQB,PK,16,AW,ANEW,20,ASV,ASS,1,6,0.003,
     3ML,NRTK,2,AR,AD,AL)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI) AND PRINT
      CALL RINT(NTB,XI,AT,PQB,PQFB,SYMB,VV,THETA,FI,MPU,NPUC,EEV,
     1A,0)
C  STORE INTENSITIES AT IN ATS FOR LATER PUNCHING BY RINTB
      NSTRUC=48
      NSTR=NSTR+1
      IF (NSTR.LE.NSTRUC) GO TO 966
      WRITE(6,965)NSTR,NSTRUC
      WRITE(8,965)NSTR,NSTRUC
C     STOP
      CALL EXIT
  965 FORMAT(31H *** TOO MANY STRUCTURES, NSTR=,I4,9H, NSTRUC=,I4)
  966 CONTINUE
      CALL BSN2(NBSN,NSTR,NB,KNBS,NBS,AT,NTB,ATS,NT,NSTRUC,A,AAA)
  970 CONTINUE
  972 CONTINUE
  975 CONTINUE
C  END OF BSN LOOP, FOLLOWING END OF STRUCTURE LOOP(S)
  978 CONTINUE
C  PUNCH OUT INTENSITIES IN STANDARD NON-BSN SEQUENCE
      DO 979 ISTR=1,NSTR
  979 CALL RINTB(NT,ATS,NT,NSTRUC,ISTR,MPU,NPUC,EEV,AAA)
C
C
  985 WRITE(8,370)E,EEV
      DO 981 I=1,NATH
  981 IF (ITI(I).EQ.1) GO TO 980
      GO TO 990
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
C     STOP
      CALL EXIT
      END
 RH(111)+C(4x2)C2H3+CO,(XZ)MIRR PL,M INV+BSN+KSLA,6PS
  2  4  1               IDEG NL1 NL2
  3 67 27               KNBS KNT NPUN
 1.3424-2.3251          ARA1
 1.3424 2.3251          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.1921 0.0000-1.5501   ASA
 5.3696 0.0000
 0.0000 4.6502          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.5000 0.0000 0.0000   ASB
 0.5000 0.6000 0.0000   FR ASE STEP
  0                     NSTEP
 18                     KNB(1)
 0.     0.      1  1
 0.     1.0000  6  6
 0.    -1.0000  6  6
-1.0000 1.0000  1  1
 1.0000-1.0000  1  1
 1.0000 1.0000  6  6
-1.0000 2.0000  6  6
 1.0000-2.0000  6  6
 0.     2.0000  6  6
 0.    -2.0000  6  6
-2.0000 2.0000  1  1
 2.0000-2.0000  1  1
 1.0000 2.0000  6  6
-1.0000-2.0000  6  6
-1.0000 3.0000  6  6
 1.0000-3.0000  6  6
-2.0000 3.0000  6  6
 2.0000-3.0000  6  6
 31                     KNB(2)
  .2500  .2500  6  1
 -.7500  .2500  6  1
  .2500 -.7500  6  1
 -.7500 1.2500  6  1
 1.2500 -.7500  6  1
 -.7500 -.7500  6  1
  .2500 1.2500  6  1
 1.2500  .2500  6  1
-1.7500 1.2500  6  1
 1.2500-1.7500  6  1
-1.7500  .2500  6  1
  .2500-1.7500  6  1
 -.7500 2.2500  6  1
 2.2500 -.7500  6  1
-1.7500 2.2500  6  1
 2.2500-1.7500  6  1
 1.2500 1.2500  6  1
-1.7500 -.7500  6  1
 -.7500-1.7500  6  1
  .2500 2.2500  6  1
 2.2500  .2500  6  1
-2.7500 1.2500  6  1
 1.2500-2.7500  6  1
-2.7500 2.2500  6  1
 2.2500-2.7500  6  1
-2.7500  .2500  6  1
  .2500-2.7500  6  1
-1.7500 3.2500  6  1
 3.2500-1.7500  6  1
 -.7500 3.2500  6  1
 3.2500 -.7500  6  1
 18                     KNB(3)
 -.5000  .5000  1  1
  .5000 -.5000  1  1
  .5000  .5000  6  6
 -.5000 1.5000  6  6
  .5000-1.5000  6  6
-1.5000 1.5000  1  1
 1.5000-1.5000  1  1
  .5000 1.5000  6  6
 -.5000-1.5000  6  6
-1.5000 2.5000  6  6
 1.5000-2.5000  6  6
 -.5000 2.5000  6  6
  .5000-2.5000  6  6
-2.5000 2.5000  1  1
 2.5000-2.5000  1  1
 1.5000 1.5000  6  6
  .5000 2.5000  6  6
 -.5000-2.5000  6  6
 0.0020                     TST
  1  2  3  4  5  6  7  8  9 10 11 12 19 20 21 22 23 24 25 26 50 51 52 53 54 55
 56                              NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  4                     NATH
  1  1  1  1            IT
 480.0000 102.9050   1.4000   1.4000   0.0000    THDB AM FPER FPAR DR0
1404.9675  12.0112   2.0000   2.0000   0.0000    THDB AM FPER FPAR DR0
1404.9675  12.0112   2.0000   2.0000   0.0000    THDB AM FPER FPAR DR0
1217.3280  15.9994   2.0000   2.0000   0.0000    THDB AM FPER FPAR DR0
 240.0000                                        TI TF DT
  5                     LMAX
  4                     NEL
 12                     NPSI
  .3000
 -.5534 -.1344 2.6414  .0033  .0001  .0000  .0000  .0000  .0000  .0000  RH
  .4000
 -.6591 -.1824 2.7179  .0086  .0003  .0000  .0000  .0000  .0000  .0000
  .5000
 -.7564 -.2288 2.7117  .0178  .0007  .0000  .0000  .0000  .0000  .0000
  .7500
 -.9739 -.3398 2.6526  .0658  .0038  .0002  .0000  .0000  .0000  .0000
 1.0000
-1.1643 -.4468 2.5964  .1653  .0115  .0009  .0001  .0000  .0000  .0000
 1.5000
-1.4863 -.6518 2.5183  .5829  .0493  .0057  .0005  .0000  .0000  .0000
 2.0000
-1.7495 -.8414 2.4632 1.1648  .1250  .0191  .0025  .0003  .0000  .0000
 3.0000
-2.1541-1.1623 2.3520 1.8562  .3605  .0845  .0171  .0028  .0004  .0000
 4.0000
-2.4546-1.4114 2.2346 2.1704  .5922  .1932  .0545  .0125  .0023  .0003
 5.0000
-2.6965-1.6116 2.1309 2.3333  .7747  .3079  .1132  .0340  .0082  .0016
 6.0000
-2.9033-1.7827 2.0421 2.4319  .9278  .4063  .1797  .0678  .0206  .0051
 7.0000
-3.0845-1.9347 1.9614 2.5025 1.0553  .4913  .2416  .1088  .0405  .0121
 12                     NPSI
  .3000
 1.8190 -.4398  .0088  .0001  .0000  .0000  .0000  .0000  .0000  .0000  C(LLK)
  .4000
 1.6548 -.5349  .0179  .0003  .0000  .0000  .0000  .0000  .0000  .0000
  .5000
 1.5186 -.6162  .0311  .0006  .0000  .0000  .0000  .0000  .0000  .0000
  .7500
 1.2518 -.7799  .0847  .0024  .0001  .0000  .0000  .0000  .0000  .0000
 1.0000
 1.0486 -.9064  .1717  .0063  .0002  .0000  .0000  .0000  .0000  .0000
 1.5000
  .7461-1.0903  .4369  .0229  .0012  .0000  .0000  .0000  .0000  .0000
 2.0000
  .5251-1.2122  .7250  .0555  .0037  .0002  .0000  .0000  .0000  .0000
 3.0000
  .2219-1.3352 1.0163  .1777  .0179  .0014  .0001  .0000  .0000  .0000
 4.0000
  .0309-1.3655 1.0541  .3531  .0506  .0054  .0004  .0000  .0000  .0000
 5.0000
 -.0946-1.3697 1.0196  .5152  .1063  .0145  .0015  .0001  .0000  .0000
 6.0000
 -.1851-1.3856  .9761  .6185  .1823  .0311  .0040  .0004  .0000  .0000
 7.0000
 -.2611-1.4209  .9448  .6653  .2679  .0569  .0087  .0010  .0001  .0000
 12                     NPSI
  .3000
 1.5917-3.9436  .0031  .0000  .0000  .0000  .0000  .0000  .0000  .0000  C(CO)
  .4000
 1.4461-3.9485  .0062  .0001  .0000  .0000  .0000  .0000  .0000  .0000
  .5000
 1.3281-3.9767  .0108  .0002  .0000  .0000  .0000  .0000  .0000  .0000
  .7500
 1.1005-4.0665  .0290  .0007  .0000  .0000  .0000  .0000  .0000  .0000
 1.0000
  .9270-4.1547  .0584  .0017  .0000  .0000  .0000  .0000  .0000  .0000
 1.5000
  .6625-4.3074  .1544  .0064  .0002  .0000  .0000  .0000  .0000  .0000
 2.0000
  .4596-4.4309  .2967  .0160  .0008  .0000  .0000  .0000  .0000  .0000
 3.0000
  .1540-4.6112  .6224  .0555  .0040  .0002  .0000  .0000  .0000  .0000
 4.0000
 -.0708-4.7234  .8338  .1262  .0121  .0009  .0001  .0000  .0000  .0000
 5.0000
 -.2423-4.7849  .9157  .2238  .0277  .0026  .0002  .0000  .0000  .0000
 6.0000
 -.3743-4.8110  .9283  .3326  .0524  .0060  .0005  .0000  .0000  .0000
 7.0000
 -.4760-4.8175  .9108  .4326  .0871  .0118  .0012  .0001  .0000  .0000
 12                     NPSI
  .3000
-1.1163 -.4218  .0014  .0000  .0000  .0000  .0000  .0000  .0000  .0000  O(CO)
  .4000
-1.2556 -.4845  .0029  .0000  .0000  .0000  .0000  .0000  .0000  .0000
  .5000
-1.3712 -.5393  .0051  .0001  .0000  .0000  .0000  .0000  .0000  .0000
  .7500
-1.5981 -.6541  .0137  .0002  .0000  .0000  .0000  .0000  .0000  .0000
 1.0000
-1.7720 -.7485  .0278  .0006  .0000  .0000  .0000  .0000  .0000  .0000
 1.5000
-2.0353 -.9003  .0749  .0023  .0001  .0000  .0000  .0000  .0000  .0000
 2.0000
-2.2350-1.0203  .1500  .0059  .0002  .0000  .0000  .0000  .0000  .0000
 3.0000
-2.5333-1.1996  .3759  .0213  .0011  .0000  .0000  .0000  .0000  .0000
 4.0000
-2.7534-1.3232  .6301  .0513  .0035  .0002  .0000  .0000  .0000  .0000
 5.0000
-2.9246-1.4062  .8174  .0984  .0085  .0006  .0000  .0000  .0000  .0000
 6.0000
-3.0610-1.4581  .9203  .1622  .0169  .0014  .0001  .0000  .0000  .0000
 7.0000
-3.1710-1.4869  .9645  .2385  .0297  .0028  .0002  .0000  .0000  .0000
  2  1  0               NLAYF NST1F ISCANF
 0.0000 0.0000 0.0000   FPOSF(1,J)
-1.2500 0.0000 0.0000   FPOSF(2,J)
  4                     NVARF
 0.0000 0.0000 0.0000   VPOSF(1,J)
 0.0000 0.0000 0.0000   VPOSF(2,J)
 0.0000 0.0000 0.0000   VPOSF(3,J)
-0.1000 0.0000 0.0000   VPOSF(4,J)
  3                     NTAU
  1  1                  LPSF
  2                     NINVF NLAY2RF
  0  0                  INVF
 1.3500 0.0000 0.0000  1 0.0000 0.0000 0.0000  3 0.1000 0.0000 0.0000
  2  0  0               NLAYG NST1G ISCANG
 0.0000 0.0000 0.0000   FPOSG(1,J)
-1.1500 0.0000 0.0000   FPOSG(2,J)
  4                     NVARG
 0.0000 0.0000-1.5501   VPOSG(1,J)
 0.1500-2.6848 1.5501   VPOSG(2,J)
-0.1000 0.0000 0.0000   VPOSG(3,J)
 0.0000 0.0000 0.0000   VPOSG(4,J)
  3                     NTAU
  2  3                  LPSG
  2                     NINVG NLAY2RG
  0  0                  INVG
  20.00  21.00   5.00   EI EF DE
 -10.00                 EI EF DE

